CFPRIME UIBRKR                                                          UIBRKR      1
C***********************************************************************RIGHTE      1
C*                                                                     *RIGHTE      2
C*        Extended Transient-Midterm Stability Program (ETMSP)         *RIGHTE      3
C*        ====================================================         *RIGHTE      4
C*                                                                     *RIGHTE      5
C*       Copyright (C) (1993) Electric Power Research Institute        *RIGHTE      6
C*                                                                     *RIGHTE      7
C* EPRI reserves all rights in the software and associated             *RIGHTE      8
C* documentation as delivered. The software and its associated         *RIGHTE      9
C* documention or any portion thereof may not be reproduced in any form*RIGHTE     10
C* whatsoever without the consent of EPRI, except as explicity provided*RIGHTE     11
C* for by license. Licensee shall submit a detailed description to EPRI*RIGHTE     12
C* of any changes or modifications to the software within two (2)      *RIGHTE     13
C* months after such changes or modifications are made. At EPRI's sole *RIGHTE     14
C* discretion, the software, as changed or modified, shall be given a  *RIGHTE     15
C* new designation sufficiently different from its then current        *RIGHTE     16
C* designation as to prevent mistake,confusion, or deception as between*RIGHTE     17
C* the current software as changed or modified.                        *RIGHTE     18
C*                                                                     *RIGHTE     19
C* A license under EPRI's rights in the software can be obtained       *RIGHTE     20
C* directly from EPRI.                                                 *RIGHTE     21
C*                                                                     *RIGHTE     22
C* This program and supporting materials may be independently available*RIGHTE     23
C* from Electric Power Software centre (EPSC) for an appropriate       *RIGHTE     24
C* distribution fee. The EPSC is a service of                          *RIGHTE     25
C*                                                                     *RIGHTE     26
C*                    Power Computing Company                          *RIGHTE     27
C*                    1930 Hi Line                                     *RIGHTE     28
C*                    Dallas, Tx 75207                                 *RIGHTE     29
C*                                                                     *RIGHTE     30
C* NEITHER EPRI, ANY MEMBER OF EPRI, NOR ANY PERSON OR  ORGANIZATION   *RIGHTE     31
C* ACTING ON BEHAVE OF THEM:                                           *RIGHTE     32
C*                                                                     *RIGHTE     33
C* 1. MAKE ANY WARRANTY OR REPRESENTATION WHATSOEVER, EXPRESS OR       *RIGHTE     34
C*    IMPLIED, INCLUDING ANY WARRANTY OF MERCHANTABILITY OR FITNESS OR *RIGHTE     35
C*    ANY PURPOSE WITH RESPECT TO THE SOFTWARE OR ITS ASSOCIATED       *RIGHTE     36
C*    DOCUMENTATION; OR                                                *RIGHTE     37
C*                                                                     *RIGHTE     38
C* 2. ASSUMES ANY LIABILITY WHATSOEVER WITH RESPECT TO ANY USE OF THE  *RIGHTE     39
C*    SOFTWARE OR ITS ASSOCIATED DOCUMENTATION OR ANY PORTION THEREOF  *RIGHTE     40
C*    OR WITH RESPECT TO ANY DAMAGES WHICH MAY RESULT FROM SUCH USE.   *RIGHTE     41
C*                                                                     *RIGHTE     42
C* THIS NOTICE MAY NOT BE REMOVED FROM THE SOFTWARE BY ANY USER        *RIGHTE     43
C* THEREOF.                                                            *RIGHTE     44
C*                                                                     *RIGHTE     45
C***********************************************************************RIGHTE     46
      SUBROUTINE UIBRKR (JBLK)                                          UIBRKR      3
CD -------------------------------------------------------------------  UIBRKR      4
CD                                                                      UIBRKR      5
CD              *****     UIBRKR   ROUTINE   *****                      UIBRKR      6
CD                                                                      UIBRKR      7
CD -------------------------------------------------------------------  UIBRKR      8
CD                                                                      UIBRKR      9
CD       PURPOSE:  Performs the initialization of the udc type BREAKR.  UIBRKR     10
CD                                                                      UIBRKR     11
CD                                                                      UIBRKR     12
CD       DEFINITION OF LOCAL VARIABLES:                                 UIBRKR     13
CD          (P)    BLK    -  Current udc block.                         UIBRKR     14
CD                 BNAME  -  Current udc block name.                    UIBRKR     15
CD                 BRKPTR -  Pointer to breaker data.                   UIBRKR     16
CD                 CDELAY -  Close delay time.                          UIBRKR     17
CD                 CTIMER -  Close timer value.                         UIBRKR     18
CD                 CURMAX -  Maximum current.                           UIBRKR     19
CD                 CUROPN -  Minimum opening current value.             UIBRKR     20
CD                 I      -  Loop counter.                              UIBRKR     21
CD                 IINPUT -  Array containing integer input values.     UIBRKR     22
CD                 LEN    -  Length of current UDC block name.          UIBRKR     23
CD                 ODELAY -  Open delay time.                           UIBRKR     24
CD                 OREQST -  Open request input.                        UIBRKR     25
CD                 OTIMER -  Open timer value.                          UIBRKR     26
CD                 PARMNO -  Number of input parameters.                UIBRKR     27
CD                 RATE   -  Voltage ris rate (integrator).             UIBRKR     28
CD                 RINPUT -  Array containing real input values.        UIBRKR     29
CD                 SUBNAM -  Subroutine name.                           UIBRKR     30
CD                 TNAME  -  UDC type name.                             UIBRKR     31
CD                 VOLMAX -  Maximum voltage.                           UIBRKR     32
CD                 VOLRIS -  Voltage rise time.                         UIBRKR     33
CD                                                                      UIBRKR     34
CD -------------------------------------------------------------------  UIBRKR     35
C                                                                       UIBRKR     36
      INCLUDE 'PARX.INS'                                                UIBRKR     37
      INCLUDE 'CNUNIT.INS'                                              UIBRKR     38
      INCLUDE 'CNMSG.INS'                                               UIBRKR     39
      INCLUDE 'CNPARX.INS'                                              UIBRKR     40
      INCLUDE 'UDCA.INS'                                                UIBRKR     41
      INCLUDE 'UDCC.INS'                                                UIBRKR     42
      INCLUDE 'UDCG.INS'                                                UIBRKR     43
      INCLUDE 'UDCH.INS'                                                UIBRKR     44
      INCLUDE 'GRDC01.INS'                                              UIBRKR     45
      INCLUDE 'GRDC03.INS'                                              UIBRKR     46
C                                                                       UIBRKR     47
      LOGICAL       AND, LOGEXP(2), ONE, OR, RESET, SET, ZERO           UIBRKR     48
      LOGICAL       LIMITS, OK, END                                     UIBRKR     49
C                                                                       UIBRKR     50
      DIMENSION     PARM(4)                                             UIBRKR     51
      DIMENSION     RINPUT(20), IINPUT(20)                              UIBRKR     52
C                                                                       UIBRKR     53
      CHARACTER*20  SUBNAM                                              UIBRKR     54
      CHARACTER*18  MISS                                                UIBRKR     55
      CHARACTER*17  BNAME                                               UIBRKR     56
      CHARACTER*8   SNAME, TNAME                                        UIBRKR     57
      CHARACTER*2   OPER                                                UIBRKR     58
C                                                                       UIBRKR     59
      INCLUDE 'GRBRKR.INS'                                              UIBRKR     60
      INCLUDE 'GRLIMT.INS'                                              UIBRKR     61
      INCLUDE 'GRLOGC.INS'                                              UIBRKR     62
      INCLUDE 'GROTHR.INS'                                              UIBRKR     63
      INCLUDE 'GRSSSP.INS'                                              UIBRKR     64
      INCLUDE 'GRUNA.INS'                                               UIBRKR     65
C                                                                       UIBRKR     66
C---------------------------------------------------------------------  UIBRKR     67
C                                                                       UIBRKR     68
      IF (SDBG) THEN                                                    UIBRKR     69
         SUBNAM = 'UIBRKR ROUTINE.'                                     UIBRKR     70
      ELSE                                                              UIBRKR     71
         SUBNAM = ' '                                                   UIBRKR     72
      END IF                                                            UIBRKR     73
      TNAME = TPNAME(IBREAK)                                            UIBRKR     74
      BNAME = UDNAME(JBLK)                                              UIBRKR     75
      LEN = IUDLEN(JBLK)                                                UIBRKR     76
C                                                                       UIBRKR     77
C                                                                       UIBRKR     78
C     Retrieve input values.                                            UIBRKR     79
C     ---------------------                                             UIBRKR     80
C                                                                       UIBRKR     81
      NEXTI = IUNIPT(JBLK)                                              UIBRKR     82
      NEXTP = IUDPPT(JBLK)                                              UIBRKR     83
      I = 0                                                             UIBRKR     84
20    IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) GO TO 40                      UIBRKR     85
         I = I + 1                                                      UIBRKR     86
         IF (UIDENT(NEXTI) .EQ. ' ') THEN                               UIBRKR     87
            IF (IUDINT(NEXTI) .NE. 0) THEN                              UIBRKR     88
C                                                                       UIBRKR     89
C              Retrieve any integer input (BREAKER POINTER)             UIBRKR     90
C                                                                       UIBRKR     91
               IINPUT(I) = IUDINT(NEXTI)                                UIBRKR     92
            ELSE                                                        UIBRKR     93
C                                                                       UIBRKR     94
C              Retrieve real parameters.                                UIBRKR     95
C                                                                       UIBRKR     96
               RINPUT(I) = UDPARM(NEXTP)                                UIBRKR     97
            END IF                                                      UIBRKR     98
         ELSE                                                           UIBRKR     99
            IF (IUDINT(NEXTI) .EQ. 0) THEN                              UIBRKR    100
               IERCNT = IERCNT + 1                                      UIBRKR    101
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    102
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    103
               WRITE(MSG(3),9002) BNAME(1:LEN)                          UIBRKR    104
               WRITE(MSG(4),9003) UIDENT(NEXTI)                         UIBRKR    105
               WRITE(MSG(5),9900)                                       UIBRKR    106
               CALL PRTMSG(5)                                           UIBRKR    107
            ELSE                                                        UIBRKR    108
C                                                                       UIBRKR    109
C              Retrieve input from other blocks.                        UIBRKR    110
C                                                                       UIBRKR    111
               RINPUT(I) = UDVAL(IUDINT(NEXTI))                         UIBRKR    112
            END IF                                                      UIBRKR    113
         END IF                                                         UIBRKR    114
         NEXTI = IUDINX(NEXTI)                                          UIBRKR    115
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR    116
         GO TO 20                                                       UIBRKR    117
40    CONTINUE                                                          UIBRKR    118
C                                                                       UIBRKR    119
      NOPARM = I                                                        UIBRKR    120
C                                                                       UIBRKR    121
C     ------------------------------------------------------            UIBRKR    122
C     Assign the input values to the corresponding variables.           UIBRKR    123
C     ------------------------------------------------------            UIBRKR    124
C                                                                       UIBRKR    125
      IF (IUDSUB(JBLK) .EQ. JBREAK) THEN                                UIBRKR    126
         IBRKPT = IINPUT(1)                                             UIBRKR    127
         OREQST = RINPUT(2)                                             UIBRKR    128
         ODELAY = RINPUT(3)                                             UIBRKR    129
         VOLRIS = RINPUT(4)                                             UIBRKR    130
         VOLMAX = RINPUT(5)                                             UIBRKR    131
         CURMAX = RINPUT(6)                                             UIBRKR    132
         CUROPN = RINPUT(7)                                             UIBRKR    133
         CREQST = RINPUT(8)                                             UIBRKR    134
         CDELAY = RINPUT(9)                                             UIBRKR    135
         IF (NOPARM .NE. 9) THEN                                        UIBRKR    136
            IERCNT = IERCNT + 1                                         UIBRKR    137
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    138
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    139
               WRITE(MSG(3),9004) BNAME(1:LEN),SBBRKR(IUDSUB(JBLK))     UIBRKR    140
     *                           ,NOPARM                                UIBRKR    141
               WRITE(MSG(4),9005) 9                                     UIBRKR    142
               WRITE(MSG(5),9900)                                       UIBRKR    143
               CALL PRTMSG(5)                                           UIBRKR    144
         END IF                                                         UIBRKR    145
      ELSE IF (IUDSUB(JBLK) .EQ. JDISCO) THEN                           UIBRKR    146
         IBRKPT = IINPUT(1)                                             UIBRKR    147
         OREQST = RINPUT(2)                                             UIBRKR    148
         CURMAX = RINPUT(3)                                             UIBRKR    149
         CREQST = RINPUT(4)                                             UIBRKR    150
         IF (NOPARM .NE. 4) THEN                                        UIBRKR    151
            IERCNT = IERCNT + 1                                         UIBRKR    152
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    153
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    154
               WRITE(MSG(3),9004) BNAME(1:LEN),SBBRKR(IUDSUB(JBLK))     UIBRKR    155
     *                           ,NOPARM                                UIBRKR    156
               WRITE(MSG(4),9005) 4                                     UIBRKR    157
               WRITE(MSG(5),9900)                                       UIBRKR    158
               CALL PRTMSG(5)                                           UIBRKR    159
         END IF                                                         UIBRKR    160
      ELSE                                                              UIBRKR    161
         IUDSUB(IUDC) = 0                                               UIBRKR    162
         IERCNT = IERCNT + 1                                            UIBRKR    163
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    164
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    165
               WRITE(MSG(3),9006) BNAME(1:LEN),SBBRKR(IUDSUB(JBLK))     UIBRKR    166
               WRITE(MSG(4),9007)                                       UIBRKR    167
               WRITE(MSG(5),9900)                                       UIBRKR    168
               CALL PRTMSG(5)                                           UIBRKR    169
      END IF                                                            UIBRKR    170
C                                                                       UIBRKR    171
C     --------------------------------                                  UIBRKR    172
C     Perform the block initialization.                                 UIBRKR    173
C     --------------------------------                                  UIBRKR    174
C                                                                       UIBRKR    175
      IF (IUDSUB(JBLK) .EQ. JBREAK) THEN                                UIBRKR    176
C                                                                       UIBRKR    177
         IF (IBRKPT .EQ. 0) THEN                                        UIBRKR    178
            IERCNT = IERCNT + 1                                         UIBRKR    179
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    180
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    181
               WRITE(MSG(3),9008) BNAME(1:LEN)                          UIBRKR    182
               WRITE(MSG(4),9900)                                       UIBRKR    183
               CALL PRTMSG(4)                                           UIBRKR    184
            UDOU2(JBLK) = ' '                                           UIBRKR    185
            UDVAL(JBLK) = 0.0                                           UIBRKR    186
         ELSE                                                           UIBRKR    187
            IF (IBSTAT(IBRKPT) .EQ. IOPEND) THEN                        UIBRKR    188
               UDOU2(JBLK) = 'OPENED'                                   UIBRKR    189
            ELSE IF (IBSTAT(IBRKPT) .EQ. ICLOSE) THEN                   UIBRKR    190
               UDOU2(JBLK) = 'CLOSED'                                   UIBRKR    191
            ELSE                                                        UIBRKR    192
               IERCNT = IERCNT + 1                                      UIBRKR    193
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    194
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    195
               WRITE(MSG(3),9010) BNAME(1:LEN),DCBNAM(IBRKPT)           UIBRKR    196
               WRITE(MSG(4),9011)                                       UIBRKR    197
               WRITE(MSG(5),9012)                                       UIBRKR    198
               CALL PRTMSG(5)                                           UIBRKR    199
               UDOU2(JBLK) = 'INVALD'                                   UIBRKR    200
            END IF                                                      UIBRKR    201
            UDVAL(JBLK) = 0.0                                           UIBRKR    202
         END IF                                                         UIBRKR    203
C                                                                       UIBRKR    204
C        Initialize the open and close timers, and rate integrator,     UIBRKR    205
C        and transfer into storage for this block.                      UIBRKR    206
C                                                                       UIBRKR    207
         OTIMER = 0.0                                                   UIBRKR    208
         CTIMER = 0.0                                                   UIBRKR    209
         RATE = 0.0                                                     UIBRKR    210
C                                                                       UIBRKR    211
         NEXTS = IUDSPT(JBLK)                                           UIBRKR    212
C                                                                       UIBRKR    213
         IF (NEXTS .EQ. 0) THEN                                         UIBRKR    214
            NEXTS = IUDSFR                                              UIBRKR    215
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    216
            IUDSPT(JBLK) = NEXTS                                        UIBRKR    217
            IUDSNX(NEXTS) = 0                                           UIBRKR    218
         END IF                                                         UIBRKR    219
         UDOLD(NEXTS) = OTIMER                                          UIBRKR    220
C                                                                       UIBRKR    221
         LASTS = NEXTS                                                  UIBRKR    222
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR    223
C                                                                       UIBRKR    224
         IF (NEXTS .EQ. 0) THEN                                         UIBRKR    225
            NEXTS = IUDSFR                                              UIBRKR    226
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    227
            IUDSNX(LASTS) = NEXTS                                       UIBRKR    228
            IUDSNX(NEXTS) = 0                                           UIBRKR    229
         END IF                                                         UIBRKR    230
         UDOLD(NEXTS) = CTIMER                                          UIBRKR    231
C                                                                       UIBRKR    232
         LASTS = NEXTS                                                  UIBRKR    233
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR    234
C                                                                       UIBRKR    235
         IF (NEXTS .EQ. 0) THEN                                         UIBRKR    236
            NEXTS = IUDSFR                                              UIBRKR    237
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    238
            IUDSNX(LASTS) = NEXTS                                       UIBRKR    239
            IUDSNX(NEXTS) = 0                                           UIBRKR    240
         END IF                                                         UIBRKR    241
         UDOLD(NEXTS) = RATE                                            UIBRKR    242
C                                                                       UIBRKR    243
C                                                                       UIBRKR    244
C                                                                       UIBRKR    245
      ELSE IF (IUDSUB(JBLK) .EQ. JDISCO) THEN                           UIBRKR    246
         IF (IBRKPT .EQ. 0) THEN                                        UIBRKR    247
            IERCNT = IERCNT + 1                                         UIBRKR    248
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    249
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    250
               WRITE(MSG(3),9008) BNAME(1:LEN)                          UIBRKR    251
               WRITE(MSG(4),9900)                                       UIBRKR    252
               CALL PRTMSG(4)                                           UIBRKR    253
            UDOU2(JBLK) = ' '                                           UIBRKR    254
            UDVAL(JBLK) = 0.0                                           UIBRKR    255
         ELSE                                                           UIBRKR    256
            IF (IBSTAT(IBRKPT) .EQ. IOPEND) THEN                        UIBRKR    257
               UDOU2(JBLK) = 'OPENED'                                   UIBRKR    258
            ELSE IF (IBSTAT(IBRKPT) .EQ. ICLOSE) THEN                   UIBRKR    259
               UDOU2(JBLK) = 'CLOSED'                                   UIBRKR    260
            END IF                                                      UIBRKR    261
            UDVAL(JBLK) = 0.0                                           UIBRKR    262
         END IF                                                         UIBRKR    263
C                                                                       UIBRKR    264
      END IF                                                            UIBRKR    265
C                                                                       UIBRKR    266
C                                                                       UIBRKR    267
C---------------------------------------------------------------------  UIBRKR    268
C                                                                       UIBRKR    269
      RETURN                                                            UIBRKR    270
C                                                                       UIBRKR    271
C---------------------------------------------------------------------  UIBRKR    272
C                                                                       UIBRKR    273
C                                                                       UIBRKR    274
C---------------------------------------------------------------------  UIBRKR    275
C                                                                       UIBRKR    276
      ENTRY UILIMT (JBLK)                                               UIBRKR    277
CD -------------------------------------------------------------------  UIBRKR    278
CD                                                                      UIBRKR    279
CD              *****     UILIMT  ROUTINE   *****                       UIBRKR    280
CD                                                                      UIBRKR    281
CD -------------------------------------------------------------------  UIBRKR    282
CD                                                                      UIBRKR    283
CD       PURPOSE:  Performs the initialization of the udc type LIMIT.   UIBRKR    284
CD                                                                      UIBRKR    285
CD -------------------------------------------------------------------  UIBRKR    286
C                                                                       UIBRKR    287
      IF(SDBG)THEN                                                      UIBRKR    288
         SUBNAM = 'UILIMT ROUTINE.'                                     UIBRKR    289
      ELSE                                                              UIBRKR    290
         SUBNAM = ' '                                                   UIBRKR    291
      END IF                                                            UIBRKR    292
      TNAME = TPNAME(LIMITR)                                            UIBRKR    293
      BNAME = UDNAME(JBLK)                                              UIBRKR    294
      LEN = IUDLEN(JBLK)                                                UIBRKR    295
C                                                                       UIBRKR    296
C                                                                       UIBRKR    297
C     Determine what variables and how many are required for the        UIBRKR    298
C     specified type.                                                   UIBRKR    299
C                                                                       UIBRKR    300
C                                                                       UIBRKR    301
      NEXTI = IUNIPT(JBLK)                                              UIBRKR    302
      NEXTP = IUDPPT(JBLK)                                              UIBRKR    303
      NEXTR = IUDRPT(JBLK)                                              UIBRKR    304
      NEXTS = IUDSPT(JBLK)                                              UIBRKR    305
C                                                                       UIBRKR    306
C     Input block.                                                      UIBRKR    307
C                                                                       UIBRKR    308
      IF(NEXTI.EQ.0)THEN                                                UIBRKR    309
         MISS = 'INPUT VALUE'                                           UIBRKR    310
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    311
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    312
               WRITE(MSG(3),9103) MISS                                  UIBRKR    313
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    314
               WRITE(MSG(5),9902)                                       UIBRKR    315
               CALL PRTMSG(5)                                           UIBRKR    316
         IERCNT = IERCNT + 1                                            UIBRKR    317
         VALUE = 0.0                                                    UIBRKR    318
      ELSE                                                              UIBRKR    319
         LBLOCK = IUDINT(NEXTI)                                         UIBRKR    320
         VALUE = UDVAL(LBLOCK)                                          UIBRKR    321
         NEXTI = IUDINX(NEXTI)                                          UIBRKR    322
      END IF                                                            UIBRKR    323
C                                                                       UIBRKR    324
C     Static limit.                                                     UIBRKR    325
C                                                                       UIBRKR    326
      IF(IUDSUB(JBLK).EQ.ISTATC)THEN                                    UIBRKR    327
C                                                                       UIBRKR    328
C     RETRIEVE GAIN.                                                    UIBRKR    329
C                                                                       UIBRKR    330
         IF(NEXTP.EQ.0)THEN                                             UIBRKR    331
            MISS = 'GAIN'                                               UIBRKR    332
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    333
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    334
               WRITE(MSG(3),9103) MISS                                  UIBRKR    335
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    336
               WRITE(MSG(5),9902)                                       UIBRKR    337
               CALL PRTMSG(5)                                           UIBRKR    338
            IERCNT = IERCNT + 1                                         UIBRKR    339
            GAIN = 0.0                                                  UIBRKR    340
         ELSE                                                           UIBRKR    341
            GAIN = UDPARM(NEXTP)                                        UIBRKR    342
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    343
         END IF                                                         UIBRKR    344
C                                                                       UIBRKR    345
C     Dynamic block.                                                    UIBRKR    346
C                                                                       UIBRKR    347
      ELSEIF(IUDSUB(JBLK).EQ.IDYNMC)THEN                                UIBRKR    348
C                                                                       UIBRKR    349
C        RETRIEVE A                                                     UIBRKR    350
C                                                                       UIBRKR    351
         DO 120 I = 1, 4                                                UIBRKR    352
            IF(NEXTP.EQ.0)THEN                                          UIBRKR    353
               MISS = 'PARAMETER'                                       UIBRKR    354
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    355
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    356
               WRITE(MSG(3),9103) MISS                                  UIBRKR    357
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    358
               WRITE(MSG(5),9902)                                       UIBRKR    359
               CALL PRTMSG(5)                                           UIBRKR    360
               IERCNT = IERCNT + 1                                      UIBRKR    361
               PARM(I) = 0.0                                            UIBRKR    362
            ELSE                                                        UIBRKR    363
               PARM(I) = UDPARM(NEXTP)                                  UIBRKR    364
               NEXTP = IUDPNX(NEXTP)                                    UIBRKR    365
            END IF                                                      UIBRKR    366
120      CONTINUE                                                       UIBRKR    367
C                                                                       UIBRKR    368
C     Variable rate limit.                                              UIBRKR    369
C                                                                       UIBRKR    370
      ELSEIF(IUDSUB(JBLK).EQ.IVRATE)THEN                                UIBRKR    371
C                                                                       UIBRKR    372
C        RETRIEVE T.                                                    UIBRKR    373
C                                                                       UIBRKR    374
         IF(NEXTI.EQ.0.OR.NEXTP.EQ.0)THEN                               UIBRKR    375
            MISS = 'TC'                                                 UIBRKR    376
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    377
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    378
               WRITE(MSG(3),9103) MISS                                  UIBRKR    379
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    380
               WRITE(MSG(5),9902)                                       UIBRKR    381
               CALL PRTMSG(5)                                           UIBRKR    382
            IERCNT = IERCNT + 1                                         UIBRKR    383
            T = 0.0                                                     UIBRKR    384
         ELSE                                                           UIBRKR    385
            IF(UIDENT(NEXTI).NE.' ')THEN                                UIBRKR    386
               LBLOCK= IUDINT(NEXTI)                                    UIBRKR    387
               T = UDVAL(LBLOCK)                                        UIBRKR    388
            ELSE                                                        UIBRKR    389
               T = UDPARM(NEXTP)                                        UIBRKR    390
            END IF                                                      UIBRKR    391
            NEXTI = IUDINX(NEXTI)                                       UIBRKR    392
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    393
         END IF                                                         UIBRKR    394
      ENDIF                                                             UIBRKR    395
C                                                                       UIBRKR    396
C     Rate limit.                                                       UIBRKR    397
C                                                                       UIBRKR    398
      IF(IUDSUB(JBLK).EQ.IVRATE.OR.IUDSUB(JBLK).EQ.IRATES)THEN          UIBRKR    399
C                                                                       UIBRKR    400
C        Retrieve down rate.                                            UIBRKR    401
C                                                                       UIBRKR    402
         IF(NEXTI.EQ.0.OR.NEXTP.EQ.0)THEN                               UIBRKR    403
            MISS = 'DOWN RATE'                                          UIBRKR    404
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    405
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    406
               WRITE(MSG(3),9103) MISS                                  UIBRKR    407
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    408
               WRITE(MSG(5),9902)                                       UIBRKR    409
               CALL PRTMSG(5)                                           UIBRKR    410
            IERCNT = IERCNT + 1                                         UIBRKR    411
            DNRATE = 0.0                                                UIBRKR    412
         ELSE                                                           UIBRKR    413
            IF(UIDENT(NEXTI).NE.' ')THEN                                UIBRKR    414
               LBLOCK= IUDINT(NEXTI)                                    UIBRKR    415
               DNRATE= UDVAL(LBLOCK)                                    UIBRKR    416
            ELSE                                                        UIBRKR    417
               DNRATE= UDPARM(NEXTP)                                    UIBRKR    418
            END IF                                                      UIBRKR    419
            NEXTI = IUDINX(NEXTI)                                       UIBRKR    420
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    421
         END IF                                                         UIBRKR    422
C                                                                       UIBRKR    423
C        Retrieve up rate.                                              UIBRKR    424
C                                                                       UIBRKR    425
         IF(NEXTI.EQ.0.OR.NEXTP.EQ.0)THEN                               UIBRKR    426
            MISS = 'UP RATE'                                            UIBRKR    427
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    428
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    429
               WRITE(MSG(3),9103) MISS                                  UIBRKR    430
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    431
               WRITE(MSG(5),9902)                                       UIBRKR    432
               CALL PRTMSG(5)                                           UIBRKR    433
            IERCNT = IERCNT + 1                                         UIBRKR    434
            UPRATE = 0.0                                                UIBRKR    435
         ELSE                                                           UIBRKR    436
            IF(UIDENT(NEXTI).NE.' ')THEN                                UIBRKR    437
               LBLOCK= IUDINT(NEXTI)                                    UIBRKR    438
               UPRATE= UDVAL(LBLOCK)                                    UIBRKR    439
            ELSE                                                        UIBRKR    440
               UPRATE= UDPARM(NEXTP)                                    UIBRKR    441
            END IF                                                      UIBRKR    442
            NEXTI = IUDINX(NEXTI)                                       UIBRKR    443
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    444
         END IF                                                         UIBRKR    445
      END IF                                                            UIBRKR    446
C                                                                       UIBRKR    447
C     Retrieve minimum.                                                 UIBRKR    448
C                                                                       UIBRKR    449
      IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                                UIBRKR    450
         MISS = 'MINIMUM'                                               UIBRKR    451
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    452
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    453
               WRITE(MSG(3),9103) MISS                                  UIBRKR    454
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    455
               WRITE(MSG(5),9902)                                       UIBRKR    456
               CALL PRTMSG(5)                                           UIBRKR    457
         IERCNT = IERCNT + 1                                            UIBRKR    458
         VALMIN = 0.0                                                   UIBRKR    459
      ELSE                                                              UIBRKR    460
         IF(UIDENT(NEXTI) .NE. ' ')THEN                                 UIBRKR    461
            LBLOCK = IUDINT(NEXTI)                                      UIBRKR    462
            VALMIN = UDVAL(LBLOCK)                                      UIBRKR    463
         ELSE                                                           UIBRKR    464
            VALMIN = UDPARM(NEXTP)                                      UIBRKR    465
         END IF                                                         UIBRKR    466
         NEXTI = IUDINX(NEXTI)                                          UIBRKR    467
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR    468
      END IF                                                            UIBRKR    469
C                                                                       UIBRKR    470
C     Retrieve maximum.                                                 UIBRKR    471
C                                                                       UIBRKR    472
      IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                                UIBRKR    473
         MISS = 'MAXIMUM'                                               UIBRKR    474
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    475
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    476
               WRITE(MSG(3),9103) MISS                                  UIBRKR    477
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    478
               WRITE(MSG(5),9902)                                       UIBRKR    479
               CALL PRTMSG(5)                                           UIBRKR    480
         IERCNT = IERCNT + 1                                            UIBRKR    481
         VALMAX = 0.0                                                   UIBRKR    482
      ELSE                                                              UIBRKR    483
         IF(UIDENT(NEXTI) .NE. ' ')THEN                                 UIBRKR    484
            LBLOCK = IUDINT(NEXTI)                                      UIBRKR    485
            VALMAX = UDVAL(LBLOCK)                                      UIBRKR    486
         ELSE                                                           UIBRKR    487
            VALMAX = UDPARM(NEXTP)                                      UIBRKR    488
         END IF                                                         UIBRKR    489
         NEXTI = IUDINX(NEXTI)                                          UIBRKR    490
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR    491
      END IF                                                            UIBRKR    492
C                                                                       UIBRKR    493
C     Static limit.                                                     UIBRKR    494
C                                                                       UIBRKR    495
      IF(IUDSUB(JBLK).EQ.ISTATC)THEN                                    UIBRKR    496
C                                                                       UIBRKR    497
         UDVAL(JBLK) = MAX(GAIN * VALUE, VALMIN)                        UIBRKR    498
         UDVAL(JBLK) = MIN(UDVAL(JBLK), VALMAX)                         UIBRKR    499
C                                                                       UIBRKR    500
C                                                                       UIBRKR    501
C     Dynamic limit.                                                    UIBRKR    502
C                                                                       UIBRKR    503
      ELSEIF(IUDSUB(JBLK).EQ.IDYNMC)THEN                                UIBRKR    504
C                                                                       UIBRKR    505
         A1 = PARM(1)                                                   UIBRKR    506
         A0 = PARM(2)                                                   UIBRKR    507
         C1 = PARM(3)                                                   UIBRKR    508
         C0 = PARM(4)                                                   UIBRKR    509
C                                                                       UIBRKR    510
         A = - C0 / C1                                                  UIBRKR    511
         B = 1.0                                                        UIBRKR    512
         C = 1.0 / C1 * (A0 - A1 * C0 / C1)                             UIBRKR    513
         D = A1 / C1                                                    UIBRKR    514
C                                                                       UIBRKR    515
C        Calculate initial state value                                  UIBRKR    516
C                                                                       UIBRKR    517
         X = VALUE * C1 / C0                                            UIBRKR    518
C                                                                       UIBRKR    519
C                                                                       UIBRKR    520
C        Apply limits to X.                                             UIBRKR    521
C                                                                       UIBRKR    522
         Y = (1 / C1)  *  (A1 * VALUE + (A0 - A1 * C0 / C1) * X)        UIBRKR    523
C                                                                       UIBRKR    524
C        If limits are exceeded calculate new X using the limit which   UIBRKR    525
C        was exceeded.                                                  UIBRKR    526
C                                                                       UIBRKR    527
         IF(Y .LT. VALMIN)THEN                                          UIBRKR    528
            Y = VALMIN                                                  UIBRKR    529
            X = (Y - (A1 * VALUE / C1))  /  ((A0 / C1) - (A1 * C0 /     UIBRKR    530
     1          C1**2))                                                 UIBRKR    531
         ELSEIF(Y .GT. VALMAX)THEN                                      UIBRKR    532
            Y = VALMAX                                                  UIBRKR    533
            X = (Y - (A1 * VALUE / C1))  /  ((A0 / C1) - (A1 * C0 /     UIBRKR    534
     1          C1**2))                                                 UIBRKR    535
         END IF                                                         UIBRKR    536
C                                                                       UIBRKR    537
C        Store current x and value.                                     UIBRKR    538
C                                                                       UIBRKR    539
         NEXTS = IUDSPT(JBLK)                                           UIBRKR    540
         IF(NEXTS.EQ.0)THEN                                             UIBRKR    541
            NEXTS = IUDSFR                                              UIBRKR    542
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    543
            IUDSNX(NEXTS) = 0                                           UIBRKR    544
            IUDSPT(JBLK) = NEXTS                                        UIBRKR    545
         END IF                                                         UIBRKR    546
         UDOLD(NEXTS) = X                                               UIBRKR    547
         LASTS = NEXTS                                                  UIBRKR    548
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR    549
C                                                                       UIBRKR    550
         IF(NEXTS.EQ.0)THEN                                             UIBRKR    551
            NEXTS = IUDSFR                                              UIBRKR    552
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    553
            IUDSNX(LASTS) = NEXTS                                       UIBRKR    554
            IUDSNX(NEXTS) = 0                                           UIBRKR    555
         END IF                                                         UIBRKR    556
         UDOLD(NEXTS) = VALUE                                           UIBRKR    557
         LASTS = NEXTS                                                  UIBRKR    558
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR    559
C                                                                       UIBRKR    560
C                                                                       UIBRKR    561
C                                                                       UIBRKR    562
         UDVAL(JBLK) = C * X + D * VALUE                                UIBRKR    563
C                                                                       UIBRKR    564
C     Rate limit.                                                       UIBRKR    565
C                                                                       UIBRKR    566
      ELSEIF(IUDSUB(JBLK).EQ.IRATES)THEN                                UIBRKR    567
         IF(VALUE.GT.VALMAX) VALUE = VALMAX                             UIBRKR    568
         IF(VALUE.LT.VALMIN) VALUE = VALMIN                             UIBRKR    569
         UDVAL(JBLK) = VALUE                                            UIBRKR    570
         IF(UPRATE.LT.0.0)THEN                                          UIBRKR    571
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    572
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    573
               WRITE(MSG(3),9106) BNAME(1:LEN),UPRATE                   UIBRKR    574
               WRITE(MSG(4),9107)                                       UIBRKR    575
               CALL PRTMSG(4)                                           UIBRKR    576
            IERCNT = IERCNT + 1                                         UIBRKR    577
         ENDIF                                                          UIBRKR    578
         IF(DNRATE.GT.0.0)THEN                                          UIBRKR    579
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    580
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    581
               WRITE(MSG(3),9108) BNAME(1:LEN),DNRATE                   UIBRKR    582
               WRITE(MSG(4),9109)                                       UIBRKR    583
               CALL PRTMSG(4)                                           UIBRKR    584
            IERCNT = IERCNT + 1                                         UIBRKR    585
         ENDIF                                                          UIBRKR    586
         IF(DNRATE.EQ.0.0.AND.UPRATE.EQ.0.0)THEN                        UIBRKR    587
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    588
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    589
               WRITE(MSG(3),9110) BNAME(1:LEN)                          UIBRKR    590
               WRITE(MSG(4),9111)                                       UIBRKR    591
               CALL PRTMSG(4)                                           UIBRKR    592
            IERCNT = IERCNT + 1                                         UIBRKR    593
         ENDIF                                                          UIBRKR    594
C                                                                       UIBRKR    595
C     Variable rate.                                                    UIBRKR    596
C                                                                       UIBRKR    597
      ELSEIF(IUDSUB(JBLK).EQ.IVRATE)THEN                                UIBRKR    598
         UDVAL(JBLK) = VALUE                                            UIBRKR    599
C                                                                       UIBRKR    600
C     Check rate limits.                                                UIBRKR    601
C                                                                       UIBRKR    602
         IF(UPRATE.LT.0.0)THEN                                          UIBRKR    603
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    604
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    605
               WRITE(MSG(3),9106) BNAME(1:LEN),UPRATE                   UIBRKR    606
               WRITE(MSG(4),9107)                                       UIBRKR    607
               CALL PRTMSG(4)                                           UIBRKR    608
            IERCNT = IERCNT + 1                                         UIBRKR    609
         ENDIF                                                          UIBRKR    610
         IF(DNRATE.GT.0.0)THEN                                          UIBRKR    611
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    612
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    613
               WRITE(MSG(3),9108) BNAME(1:LEN),DNRATE                   UIBRKR    614
               WRITE(MSG(4),9107)                                       UIBRKR    615
               CALL PRTMSG(4)                                           UIBRKR    616
            IERCNT = IERCNT + 1                                         UIBRKR    617
         ENDIF                                                          UIBRKR    618
         IF(DNRATE.EQ.0.0.AND.UPRATE.EQ.0.0)THEN                        UIBRKR    619
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    620
               WRITE(MSG(2),9001) TNAME                                 UIBRKR    621
               WRITE(MSG(3),9110) BNAME(1:LEN)                          UIBRKR    622
               WRITE(MSG(4),9111)                                       UIBRKR    623
               CALL PRTMSG(4)                                           UIBRKR    624
            IERCNT = IERCNT + 1                                         UIBRKR    625
         ENDIF                                                          UIBRKR    626
C                                                                       UIBRKR    627
C     Check output for limit violation                                  UIBRKR    628
C                                                                       UIBRKR    629
         DVALUE = 0.0                                                   UIBRKR    630
         IF(VALUE.LT.VALMIN) THEN                                       UIBRKR    631
            DVALUE=VALUE-VALMIN                                         UIBRKR    632
            VALUE=VALMIN                                                UIBRKR    633
         ELSEIF(VALUE.GT.VALMAX) THEN                                   UIBRKR    634
            DVALUE=VALUE-VALMAX                                         UIBRKR    635
            VALUE=VALMAX                                                UIBRKR    636
         ENDIF                                                          UIBRKR    637
C                                                                       UIBRKR    638
C     Create storage for integrators.                                   UIBRKR    639
C                                                                       UIBRKR    640
         NEXTS = IUDSPT(JBLK)                                           UIBRKR    641
         IF(NEXTS.EQ.0)THEN                                             UIBRKR    642
            NEXTS = IUDSFR                                              UIBRKR    643
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    644
            IUDSNX(NEXTS) = 0                                           UIBRKR    645
            IUDSPT(JBLK) = NEXTS                                        UIBRKR    646
         ENDIF                                                          UIBRKR    647
         UDOLD(NEXTS) = VALUE                                           UIBRKR    648
         LASTS = NEXTS                                                  UIBRKR    649
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR    650
C                                                                       UIBRKR    651
         IF(NEXTS.EQ.0)THEN                                             UIBRKR    652
            NEXTS = IUDSFR                                              UIBRKR    653
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR    654
            IUDSNX(LASTS) = NEXTS                                       UIBRKR    655
            IUDSNX(NEXTS) = 0                                           UIBRKR    656
         ENDIF                                                          UIBRKR    657
         UDOLD(NEXTS) = DVALUE                                          UIBRKR    658
         LASTS = NEXTS                                                  UIBRKR    659
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR    660
C                                                                       UIBRKR    661
C     Invalid subtype.                                                  UIBRKR    662
C                                                                       UIBRKR    663
      ELSE                                                              UIBRKR    664
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    665
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    666
               WRITE(MSG(3),9104) BNAME(1:LEN)                          UIBRKR    667
               WRITE(MSG(4),9105)                                       UIBRKR    668
               WRITE(MSG(5),9902)                                       UIBRKR    669
               CALL PRTMSG(5)                                           UIBRKR    670
         IERCNT = IERCNT + 1                                            UIBRKR    671
         UDVAL(JBLK) = 0.0                                              UIBRKR    672
      END IF                                                            UIBRKR    673
C                                                                       UIBRKR    674
      RETURN                                                            UIBRKR    675
C                                                                       UIBRKR    676
C                                                                       UIBRKR    677
C---------------------------------------------------------------------  UIBRKR    678
C                                                                       UIBRKR    679
      ENTRY UILOGC (JBLK)                                               UIBRKR    680
CD -------------------------------------------------------------------  UIBRKR    681
CD                                                                      UIBRKR    682
CD              *****     UILOGCD ROUTINE   *****                       UIBRKR    683
CD                                                                      UIBRKR    684
CD -------------------------------------------------------------------  UIBRKR    685
CD                                                                      UIBRKR    686
CD       PURPOSE:  Performs the initialization of the udc type LOGIC.   UIBRKR    687
CD                                                                      UIBRKR    688
CD -------------------------------------------------------------------  UIBRKR    689
C                                                                       UIBRKR    690
      IF(SDBG)THEN                                                      UIBRKR    691
         SUBNAM = 'UILOGC ROUTINE.'                                     UIBRKR    692
      ELSE                                                              UIBRKR    693
         SUBNAM = ' '                                                   UIBRKR    694
      ENDIF                                                             UIBRKR    695
      TNAME = TPNAME(LOGIC)                                             UIBRKR    696
      BNAME = UDNAME(JBLK)                                              UIBRKR    697
      LEN = IUDLEN(JBLK)                                                UIBRKR    698
C                                                                       UIBRKR    699
C                                                                       UIBRKR    700
      NEXTI = IUNIPT(JBLK)                                              UIBRKR    701
      NEXTP = IUDPPT(JBLK)                                              UIBRKR    702
      LASTP = NEXTP                                                     UIBRKR    703
      NEXTR = IUDRPT(JBLK)                                              UIBRKR    704
C                                                                       UIBRKR    705
C     If the subtype has a logical expression, evaluate it.             UIBRKR    706
C                                                                       UIBRKR    707
      IF(IUDSUB(JBLK).EQ.ISWTCH .OR. IUDSUB(JBLK).EQ.ITIMER .OR.        UIBRKR    708
     1    IUDSUB(JBLK).EQ.IEXPRE .OR. IUDSUB(JBLK).EQ.IFFLOP .OR.       UIBRKR    709
     2    IUDSUB(JBLK).EQ.ICOUNT)THEN                                   UIBRKR    710
C                                                                       UIBRKR    711
         LOGEXP(1) = .FALSE.                                            UIBRKR    712
         LOGEXP(2) = .FALSE.                                            UIBRKR    713
         J = 0                                                          UIBRKR    714
C                                                                       UIBRKR    715
220      IF(NEXTR.EQ.0 .OR. J .GE. 2) GOTO 240                          UIBRKR    716
C                                                                       UIBRKR    717
C           Retrieve the logical expression.                            UIBRKR    718
C                                                                       UIBRKR    719
            J = J + 1                                                   UIBRKR    720
            IF(IUDBNM(NEXTR) .LE. 0)THEN                                UIBRKR    721
               VALUE1 = UDPRM1(NEXTR)                                   UIBRKR    722
            ELSE                                                        UIBRKR    723
               JBLOCK = IUDBNM(NEXTR)                                   UIBRKR    724
               VALUE1 = UDVAL(JBLOCK)                                   UIBRKR    725
            ENDIF                                                       UIBRKR    726
            OPER = UDRELA(NEXTR)                                        UIBRKR    727
            IF(JUDBNM(NEXTR) .LE. 0)THEN                                UIBRKR    728
               VALUE2 = UDPRM2(NEXTR)                                   UIBRKR    729
            ELSE                                                        UIBRKR    730
               JBLOCK = JUDBNM(NEXTR)                                   UIBRKR    731
               VALUE2 = UDVAL(JBLOCK)                                   UIBRKR    732
            ENDIF                                                       UIBRKR    733
C                                                                       UIBRKR    734
C           Evaluate the logical expression.                            UIBRKR    735
C                                                                       UIBRKR    736
            LOGEXP(J) = .FALSE.                                         UIBRKR    737
            IF(OPER.EQ.'EQ')THEN                                        UIBRKR    738
               IF(VALUE1.EQ.VALUE2) LOGEXP(J) = .TRUE.                  UIBRKR    739
            ELSEIF(OPER.EQ.'NE')THEN                                    UIBRKR    740
               IF(VALUE1 .NE. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR    741
            ELSEIF(OPER.EQ.'LT')THEN                                    UIBRKR    742
               IF(VALUE1 .LT. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR    743
            ELSEIF(OPER.EQ.'LE')THEN                                    UIBRKR    744
               IF(VALUE1 .LE. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR    745
            ELSEIF(OPER.EQ.'GT')THEN                                    UIBRKR    746
               IF(VALUE1 .GT. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR    747
            ELSEIF(OPER.EQ.'GE')THEN                                    UIBRKR    748
               IF(VALUE1 .GE. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR    749
            ENDIF                                                       UIBRKR    750
C                                                                       UIBRKR    751
            LASTR = NEXTR                                               UIBRKR    752
            NEXTR = IUDRNX(NEXTR)                                       UIBRKR    753
C                                                                       UIBRKR    754
            GOTO 220                                                    UIBRKR    755
240      CONTINUE                                                       UIBRKR    756
      ENDIF                                                             UIBRKR    757
C                                                                       UIBRKR    758
C     Logical expression.                                               UIBRKR    759
C                                                                       UIBRKR    760
      IF(IUDSUB(JBLK).EQ.IEXPRE)THEN                                    UIBRKR    761
C                                                                       UIBRKR    762
C        Determine if a logical expression was stored.                  UIBRKR    763
C                                                                       UIBRKR    764
         IF(J .NE. 1)THEN                                               UIBRKR    765
            MISS = 'LOGICAL EXPRESSION'                                 UIBRKR    766
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    767
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    768
               WRITE(MSG(3),9103) MISS                                  UIBRKR    769
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    770
               WRITE(MSG(5),9902)                                       UIBRKR    771
               CALL PRTMSG(5)                                           UIBRKR    772
            IERCNT = IERCNT + 1                                         UIBRKR    773
            LOGEXP(1) = .FALSE.                                         UIBRKR    774
         ENDIF                                                          UIBRKR    775
C                                                                       UIBRKR    776
         IF(LOGEXP(1))THEN                                              UIBRKR    777
            UDVAL(JBLK) = 1.0                                           UIBRKR    778
         ELSE                                                           UIBRKR    779
            UDVAL(JBLK) = 0.0                                           UIBRKR    780
         ENDIF                                                          UIBRKR    781
C                                                                       UIBRKR    782
C                                                                       UIBRKR    783
C                                                                       UIBRKR    784
C     Boolean AND function.                                             UIBRKR    785
C                                                                       UIBRKR    786
      ELSEIF(IUDSUB(JBLK).EQ.IANDS)THEN                                 UIBRKR    787
C                                                                       UIBRKR    788
C        AND function is true if all of its inputs are non-zero.        UIBRKR    789
C                                                                       UIBRKR    790
         AND = .TRUE.                                                   UIBRKR    791
260      IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0) GOTO 280                        UIBRKR    792
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR    793
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR    794
            ELSE                                                        UIBRKR    795
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR    796
            ENDIF                                                       UIBRKR    797
            IF(VALUE1.EQ.0.0)THEN                                       UIBRKR    798
               AND = .FALSE.                                            UIBRKR    799
               NEXTI = 0                                                UIBRKR    800
               NEXTP = 0                                                UIBRKR    801
            ELSE                                                        UIBRKR    802
               NEXTI = IUDINX(NEXTI)                                    UIBRKR    803
               NEXTP = IUDPNX(NEXTP)                                    UIBRKR    804
            ENDIF                                                       UIBRKR    805
            GOTO 260                                                    UIBRKR    806
280      CONTINUE                                                       UIBRKR    807
C                                                                       UIBRKR    808
         IF(AND)THEN                                                    UIBRKR    809
            UDVAL(JBLK) = 1.0                                           UIBRKR    810
         ELSE                                                           UIBRKR    811
            UDVAL(JBLK) = 0.0                                           UIBRKR    812
         ENDIF                                                          UIBRKR    813
C                                                                       UIBRKR    814
C                                                                       UIBRKR    815
C                                                                       UIBRKR    816
C     Boolean OR function.                                              UIBRKR    817
C                                                                       UIBRKR    818
      ELSEIF(IUDSUB(JBLK).EQ.IORS)THEN                                  UIBRKR    819
C                                                                       UIBRKR    820
C        OR function is true if any of its inputs are non-zero.         UIBRKR    821
C                                                                       UIBRKR    822
         OR = .FALSE.                                                   UIBRKR    823
300      IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0) GOTO 320                        UIBRKR    824
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR    825
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR    826
            ELSE                                                        UIBRKR    827
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR    828
            ENDIF                                                       UIBRKR    829
            IF(VALUE1 .NE. 0.0)THEN                                     UIBRKR    830
               OR = .TRUE.                                              UIBRKR    831
               NEXTI = 0                                                UIBRKR    832
               NEXTP = 0                                                UIBRKR    833
            ELSE                                                        UIBRKR    834
               NEXTI = IUDINX(NEXTI)                                    UIBRKR    835
               NEXTP = IUDPNX(NEXTP)                                    UIBRKR    836
            ENDIF                                                       UIBRKR    837
            GOTO 300                                                    UIBRKR    838
320      CONTINUE                                                       UIBRKR    839
C                                                                       UIBRKR    840
         IF(OR)THEN                                                     UIBRKR    841
            UDVAL(JBLK) = 1.0                                           UIBRKR    842
         ELSE                                                           UIBRKR    843
            UDVAL(JBLK) = 0.0                                           UIBRKR    844
         ENDIF                                                          UIBRKR    845
C                                                                       UIBRKR    846
C                                                                       UIBRKR    847
C                                                                       UIBRKR    848
C     Flipflop switch.                                                  UIBRKR    849
C                                                                       UIBRKR    850
      ELSEIF(IUDSUB(JBLK).EQ.IFFLOP)THEN                                UIBRKR    851
C                                                                       UIBRKR    852
         SET = LOGEXP(1)                                                UIBRKR    853
         RESET = LOGEXP(2)                                              UIBRKR    854
C                                                                       UIBRKR    855
C        Determine if both logical expressions were evaluated.          UIBRKR    856
C                                                                       UIBRKR    857
         IF(J .NE. 2)THEN                                               UIBRKR    858
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    859
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    860
               WRITE(MSG(3),9204)                                       UIBRKR    861
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    862
               WRITE(MSG(5),9902)                                       UIBRKR    863
               CALL PRTMSG(5)                                           UIBRKR    864
            IERCNT = IERCNT + 1                                         UIBRKR    865
         ENDIF                                                          UIBRKR    866
C                                                                       UIBRKR    867
C        If both are true, or neither are true, then use the default    UIBRKR    868
C        of reset.                                                      UIBRKR    869
C                                                                       UIBRKR    870
         IF(SET.AND.RESET)THEN                                          UIBRKR    871
            SET = .FALSE.                                               UIBRKR    872
            RESET = .TRUE.                                              UIBRKR    873
         ELSEIF(.NOT. (SET .OR. RESET))THEN                             UIBRKR    874
            SET = .FALSE.                                               UIBRKR    875
            RESET = .TRUE.                                              UIBRKR    876
         ENDIF                                                          UIBRKR    877
C                                                                       UIBRKR    878
C        Store current set and reset values.                            UIBRKR    879
C                                                                       UIBRKR    880
         IF(NEXTP.EQ.0)THEN                                             UIBRKR    881
            CALL ADDPRM (JBLK, NEXTP, LASTP)                            UIBRKR    882
         ENDIF                                                          UIBRKR    883
         IF(SET)THEN                                                    UIBRKR    884
            UDPARM(NEXTP) = 1.0                                         UIBRKR    885
         ELSE                                                           UIBRKR    886
            UDPARM(NEXTP) = 0.0                                         UIBRKR    887
         ENDIF                                                          UIBRKR    888
         LASTP = NEXTP                                                  UIBRKR    889
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR    890
C                                                                       UIBRKR    891
C        Calculate UDVAL based on set and reset.                        UIBRKR    892
C                                                                       UIBRKR    893
         IF(SET)THEN                                                    UIBRKR    894
            UDVAL(JBLK) = 1.0                                           UIBRKR    895
         ENDIF                                                          UIBRKR    896
C                                                                       UIBRKR    897
         IF(RESET)THEN                                                  UIBRKR    898
            UDVAL(JBLK) = 0.0                                           UIBRKR    899
         ENDIF                                                          UIBRKR    900
C                                                                       UIBRKR    901
C                                                                       UIBRKR    902
C                                                                       UIBRKR    903
C     Boolean NOT function.                                             UIBRKR    904
C                                                                       UIBRKR    905
      ELSEIF(IUDSUB(JBLK).EQ.NOTS)THEN                                  UIBRKR    906
C                                                                       UIBRKR    907
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR    908
            MISS = 'INPUT VALUE'                                        UIBRKR    909
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    910
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    911
               WRITE(MSG(3),9103) MISS                                  UIBRKR    912
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    913
               WRITE(MSG(5),9902)                                       UIBRKR    914
               CALL PRTMSG(5)                                           UIBRKR    915
            IERCNT = IERCNT + 1                                         UIBRKR    916
            VALUE1 = 1.0                                                UIBRKR    917
C                                                                       UIBRKR    918
         ELSE                                                           UIBRKR    919
C                                                                       UIBRKR    920
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR    921
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR    922
            ELSE                                                        UIBRKR    923
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR    924
            ENDIF                                                       UIBRKR    925
            NEXTI = IUDINX(NEXTI)                                       UIBRKR    926
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    927
         ENDIF                                                          UIBRKR    928
C                                                                       UIBRKR    929
         IF(VALUE1.EQ.0.0)THEN                                          UIBRKR    930
            UDVAL(JBLK) = 1.0                                           UIBRKR    931
         ELSE                                                           UIBRKR    932
            UDVAL(JBLK) = 0.0                                           UIBRKR    933
         ENDIF                                                          UIBRKR    934
C                                                                       UIBRKR    935
C                                                                       UIBRKR    936
C                                                                       UIBRKR    937
C     Boolean XOR function.                                             UIBRKR    938
C                                                                       UIBRKR    939
      ELSEIF(IUDSUB(JBLK).EQ.IXORS)THEN                                 UIBRKR    940
C                                                                       UIBRKR    941
C        XOR function is true if any of its inputs are non-zero,        UIBRKR    942
C        but not all inputs are non-zero.                               UIBRKR    943
C                                                                       UIBRKR    944
         ZERO = .FALSE.                                                 UIBRKR    945
         ONE = .FALSE.                                                  UIBRKR    946
340      IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0) GOTO 360                        UIBRKR    947
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR    948
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR    949
            ELSE                                                        UIBRKR    950
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR    951
            ENDIF                                                       UIBRKR    952
            IF(VALUE1.EQ.0.0)THEN                                       UIBRKR    953
               ZERO = .TRUE.                                            UIBRKR    954
            ELSE                                                        UIBRKR    955
               ONE = .TRUE.                                             UIBRKR    956
            ENDIF                                                       UIBRKR    957
            NEXTI = IUDINX(NEXTI)                                       UIBRKR    958
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    959
            GOTO 340                                                    UIBRKR    960
360      CONTINUE                                                       UIBRKR    961
C                                                                       UIBRKR    962
         IF(ZERO.AND.ONE)THEN                                           UIBRKR    963
            UDVAL(JBLK) = 1.0                                           UIBRKR    964
         ELSE                                                           UIBRKR    965
            UDVAL(JBLK) = 0.0                                           UIBRKR    966
         ENDIF                                                          UIBRKR    967
C                                                                       UIBRKR    968
C     Logical control switch.                                           UIBRKR    969
C                                                                       UIBRKR    970
      ELSEIF(IUDSUB(JBLK).EQ.ISWTCH)THEN                                UIBRKR    971
C                                                                       UIBRKR    972
C        First input value.                                             UIBRKR    973
C                                                                       UIBRKR    974
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR    975
C                                                                       UIBRKR    976
C           No input value was stored.                                  UIBRKR    977
C                                                                       UIBRKR    978
            MISS = 'INPUT VALUE'                                        UIBRKR    979
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR    980
               WRITE(MSG(2),9102) TNAME                                 UIBRKR    981
               WRITE(MSG(3),9103) MISS                                  UIBRKR    982
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR    983
               WRITE(MSG(5),9902)                                       UIBRKR    984
               CALL PRTMSG(5)                                           UIBRKR    985
            IERCNT = IERCNT + 1                                         UIBRKR    986
         ELSE                                                           UIBRKR    987
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR    988
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR    989
            ELSE                                                        UIBRKR    990
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR    991
            ENDIF                                                       UIBRKR    992
            NEXTI = IUDINX(NEXTI)                                       UIBRKR    993
            LASTP = NEXTP                                               UIBRKR    994
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR    995
         ENDIF                                                          UIBRKR    996
C                                                                       UIBRKR    997
C       Second input value.                                             UIBRKR    998
C                                                                       UIBRKR    999
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   1000
C                                                                       UIBRKR   1001
C           No input value was stored.                                  UIBRKR   1002
C                                                                       UIBRKR   1003
            MISS = 'INPUT VALUE'                                        UIBRKR   1004
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1005
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1006
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1007
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1008
               WRITE(MSG(5),9902)                                       UIBRKR   1009
               CALL PRTMSG(5)                                           UIBRKR   1010
            IERCNT = IERCNT + 1                                         UIBRKR   1011
         ELSE                                                           UIBRKR   1012
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   1013
               VALUE2 = UDVAL(IUDINT(NEXTI))                            UIBRKR   1014
            ELSE                                                        UIBRKR   1015
               VALUE2 = UDPARM(NEXTP)                                   UIBRKR   1016
            ENDIF                                                       UIBRKR   1017
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1018
            LASTP = NEXTP                                               UIBRKR   1019
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1020
         ENDIF                                                          UIBRKR   1021
C                                                                       UIBRKR   1022
         SET = LOGEXP(1)                                                UIBRKR   1023
         RESET = LOGEXP(2)                                              UIBRKR   1024
C                                                                       UIBRKR   1025
C        Determine if both logical expressions were evaluated.          UIBRKR   1026
C                                                                       UIBRKR   1027
         IF(J .NE. 2)THEN                                               UIBRKR   1028
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1029
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1030
               WRITE(MSG(3),9204)                                       UIBRKR   1031
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1032
               WRITE(MSG(5),9902)                                       UIBRKR   1033
               CALL PRTMSG(5)                                           UIBRKR   1034
            IERCNT = IERCNT + 1                                         UIBRKR   1035
         ENDIF                                                          UIBRKR   1036
C                                                                       UIBRKR   1037
C        If both are true, or neither are true, then use the default    UIBRKR   1038
C        of set.                                                        UIBRKR   1039
C                                                                       UIBRKR   1040
         IF(SET.AND.RESET)THEN                                          UIBRKR   1041
            SET = .TRUE.                                                UIBRKR   1042
            RESET = .FALSE.                                             UIBRKR   1043
         ELSEIF(.NOT. (SET .OR. RESET))THEN                             UIBRKR   1044
            SET = .TRUE.                                                UIBRKR   1045
            RESET = .FALSE.                                             UIBRKR   1046
         ENDIF                                                          UIBRKR   1047
C                                                                       UIBRKR   1048
C        Store current set and reset values.                            UIBRKR   1049
C                                                                       UIBRKR   1050
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1051
            CALL ADDPRM (JBLK, NEXTP, LASTP)                            UIBRKR   1052
         ENDIF                                                          UIBRKR   1053
         IF(SET)THEN                                                    UIBRKR   1054
            UDPARM(NEXTP) = 1.0                                         UIBRKR   1055
         ELSE                                                           UIBRKR   1056
            UDPARM(NEXTP) = 0.0                                         UIBRKR   1057
         ENDIF                                                          UIBRKR   1058
         LASTP = NEXTP                                                  UIBRKR   1059
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR   1060
C                                                                       UIBRKR   1061
C        Calculate UDVAL based on set and reset.                        UIBRKR   1062
C                                                                       UIBRKR   1063
         IF(SET)THEN                                                    UIBRKR   1064
            UDVAL(JBLK) =  VALUE1                                       UIBRKR   1065
         ENDIF                                                          UIBRKR   1066
C                                                                       UIBRKR   1067
         IF(RESET)THEN                                                  UIBRKR   1068
            UDVAL(JBLK) = VALUE2                                        UIBRKR   1069
         ENDIF                                                          UIBRKR   1070
C                                                                       UIBRKR   1071
C                                                                       UIBRKR   1072
C                                                                       UIBRKR   1073
C     Logical control timer.                                            UIBRKR   1074
C                                                                       UIBRKR   1075
      ELSEIF(IUDSUB(JBLK).EQ.ITIMER)THEN                                UIBRKR   1076
C                                                                       UIBRKR   1077
         SET = LOGEXP(1)                                                UIBRKR   1078
         RESET = LOGEXP(2)                                              UIBRKR   1079
C                                                                       UIBRKR   1080
C        Determine if both logical expressions were evaluated.          UIBRKR   1081
C                                                                       UIBRKR   1082
         IF(J .NE. 2)THEN                                               UIBRKR   1083
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1084
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1085
               WRITE(MSG(3),9204)                                       UIBRKR   1086
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1087
               WRITE(MSG(5),9902)                                       UIBRKR   1088
               CALL PRTMSG(5)                                           UIBRKR   1089
            IERCNT = IERCNT + 1                                         UIBRKR   1090
         ENDIF                                                          UIBRKR   1091
C                                                                       UIBRKR   1092
C        If both are true, or neither are true, then use the default    UIBRKR   1093
C        of reset.                                                      UIBRKR   1094
C                                                                       UIBRKR   1095
         IF(SET.AND.RESET)THEN                                          UIBRKR   1096
            SET = .FALSE.                                               UIBRKR   1097
            RESET = .TRUE.                                              UIBRKR   1098
         ELSEIF(.NOT. (SET .OR. RESET))THEN                             UIBRKR   1099
            SET = .FALSE.                                               UIBRKR   1100
            RESET = .TRUE.                                              UIBRKR   1101
         ENDIF                                                          UIBRKR   1102
C                                                                       UIBRKR   1103
C        Store current set and reset values.                            UIBRKR   1104
C                                                                       UIBRKR   1105
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1106
            CALL ADDPRM (JBLK, NEXTP, LASTP)                            UIBRKR   1107
         ENDIF                                                          UIBRKR   1108
         IF(SET)THEN                                                    UIBRKR   1109
            UDPARM(NEXTP) = 1.0                                         UIBRKR   1110
         ELSE                                                           UIBRKR   1111
            UDPARM(NEXTP) = 0.0                                         UIBRKR   1112
         ENDIF                                                          UIBRKR   1113
         LASTP = NEXTP                                                  UIBRKR   1114
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR   1115
C                                                                       UIBRKR   1116
C        Calculate UDVAL based on set and reset.                        UIBRKR   1117
C                                                                       UIBRKR   1118
         IF(SET)THEN                                                    UIBRKR   1119
            UDVAL(JBLK) = 0.0                                           UIBRKR   1120
         ENDIF                                                          UIBRKR   1121
C                                                                       UIBRKR   1122
         IF(RESET)THEN                                                  UIBRKR   1123
            UDVAL(JBLK) = 0.0                                           UIBRKR   1124
         ENDIF                                                          UIBRKR   1125
C                                                                       UIBRKR   1126
C                                                                       UIBRKR   1127
C                                                                       UIBRKR   1128
C     Logical counter.                                                  UIBRKR   1129
C                                                                       UIBRKR   1130
      ELSEIF(IUDSUB(JBLK).EQ.ICOUNT)THEN                                UIBRKR   1131
         IF(LOGEXP(1))THEN                                              UIBRKR   1132
            UDRKW(LASTR) = 'TRUE'                                       UIBRKR   1133
            UDVAL(JBLK) = 1.0                                           UIBRKR   1134
         ELSE                                                           UIBRKR   1135
            UDRKW(LASTR) = ' '                                          UIBRKR   1136
            UDVAL(JBLK) = 0.0                                           UIBRKR   1137
         ENDIF                                                          UIBRKR   1138
C                                                                       UIBRKR   1139
C                                                                       UIBRKR   1140
C     Zero Order Hold.                                                  UIBRKR   1141
C                                                                       UIBRKR   1142
      ELSEIF(IUDSUB(JBLK).EQ.IZEROS)THEN                                UIBRKR   1143
C                                                                       UIBRKR   1144
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   1145
C                                                                       UIBRKR   1146
C           No input value was stored.                                  UIBRKR   1147
C                                                                       UIBRKR   1148
            MISS = 'INPUT BLOCK'                                        UIBRKR   1149
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1150
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1151
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1152
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1153
               WRITE(MSG(5),9902)                                       UIBRKR   1154
               CALL PRTMSG(5)                                           UIBRKR   1155
            IERCNT = IERCNT + 1                                         UIBRKR   1156
         ELSE                                                           UIBRKR   1157
            VALUE = UDVAL(IUDINT(NEXTI))                                UIBRKR   1158
         ENDIF                                                          UIBRKR   1159
C                                                                       UIBRKR   1160
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1161
C                                                                       UIBRKR   1162
C           No desired time was stored.                                 UIBRKR   1163
C                                                                       UIBRKR   1164
            MISS = 'DESIRED TIME'                                       UIBRKR   1165
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1166
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1167
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1168
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1169
               WRITE(MSG(5),9902)                                       UIBRKR   1170
               CALL PRTMSG(5)                                           UIBRKR   1171
            IERCNT = IERCNT + 1                                         UIBRKR   1172
         ELSE                                                           UIBRKR   1173
            DESIRE = UDPARM(NEXTP)                                      UIBRKR   1174
            LASTP = NEXTP                                               UIBRKR   1175
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1176
         ENDIF                                                          UIBRKR   1177
C                                                                       UIBRKR   1178
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1179
C                                                                       UIBRKR   1180
C           No time step was stored.                                    UIBRKR   1181
C                                                                       UIBRKR   1182
            MISS = 'TIME STEP'                                          UIBRKR   1183
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1184
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1185
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1186
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1187
               WRITE(MSG(5),9902)                                       UIBRKR   1188
               CALL PRTMSG(5)                                           UIBRKR   1189
            IERCNT = IERCNT + 1                                         UIBRKR   1190
         ELSE                                                           UIBRKR   1191
            STEP = UDPARM(NEXTP)                                        UIBRKR   1192
            LASTP = NEXTP                                               UIBRKR   1193
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1194
         ENDIF                                                          UIBRKR   1195
C                                                                       UIBRKR   1196
C        Store time to begin the time steps.                            UIBRKR   1197
C                                                                       UIBRKR   1198
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1199
            CALL ADDPRM (JBLK, NEXTP, LASTP)                            UIBRKR   1200
            UDPARM(NEXTP) = DESIRE - (INT (DESIRE / STEP)) * STEP       UIBRKR   1201
         ENDIF                                                          UIBRKR   1202
         START = UDPARM(NEXTP)                                          UIBRKR   1203
         LASTP = NEXTP                                                  UIBRKR   1204
         NEXTP = IUDPNX(NEXTP)                                          UIBRKR   1205
C                                                                       UIBRKR   1206
C        Calculate UDVAL.                                               UIBRKR   1207
C                                                                       UIBRKR   1208
         UDVAL(JBLK) = VALUE                                            UIBRKR   1209
C                                                                       UIBRKR   1210
C                                                                       UIBRKR   1211
C     Invalid subtype.                                                  UIBRKR   1212
C                                                                       UIBRKR   1213
      ELSE                                                              UIBRKR   1214
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1215
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1216
               WRITE(MSG(3),9104) BNAME(1:LEN)                          UIBRKR   1217
               WRITE(MSG(4),9105)                                       UIBRKR   1218
               WRITE(MSG(5),9902)                                       UIBRKR   1219
               CALL PRTMSG(5)                                           UIBRKR   1220
         IERCNT = IERCNT + 1                                            UIBRKR   1221
         UDVAL(JBLK) = 0.0                                              UIBRKR   1222
      ENDIF                                                             UIBRKR   1223
C                                                                       UIBRKR   1224
       RETURN                                                           UIBRKR   1225
C                                                                       UIBRKR   1226
C                                                                       UIBRKR   1227
C---------------------------------------------------------------------  UIBRKR   1228
C                                                                       UIBRKR   1229
      ENTRY UIOTHR (JBLK)                                               UIBRKR   1230
CD -------------------------------------------------------------------  UIBRKR   1231
CD                                                                      UIBRKR   1232
CD              *****     UIOTHR  ROUTINE   *****                       UIBRKR   1233
CD                                                                      UIBRKR   1234
CD -------------------------------------------------------------------  UIBRKR   1235
CD                                                                      UIBRKR   1236
CD       PURPOSE:  Performs the initialization of the udc type OTHER.   UIBRKR   1237
CD                                                                      UIBRKR   1238
CD -------------------------------------------------------------------  UIBRKR   1239
C                                                                       UIBRKR   1240
      IF(SDBG)THEN                                                      UIBRKR   1241
         SUBNAM = 'UIOTHR ROUTINE.'                                     UIBRKR   1242
      ELSE                                                              UIBRKR   1243
         SUBNAM = ' '                                                   UIBRKR   1244
      END IF                                                            UIBRKR   1245
      TNAME = TPNAME(IOTHER)                                            UIBRKR   1246
      BNAME = UDNAME(JBLK)                                              UIBRKR   1247
      LEN = IUDLEN(JBLK)                                                UIBRKR   1248
C                                                                       UIBRKR   1249
C                                                                       UIBRKR   1250
      NEXTI = IUNIPT(JBLK)                                              UIBRKR   1251
      NEXTP = IUDPPT(JBLK)                                              UIBRKR   1252
      LASTP = NEXTP                                                     UIBRKR   1253
      NEXTR = IUDRPT(JBLK)                                              UIBRKR   1254
C                                                                       UIBRKR   1255
C     Evaluate logical expressions if present.                          UIBRKR   1256
C                                                                       UIBRKR   1257
      IF(IUDSUB(JBLK).EQ.LEVELS .OR. IUDSUB(JBLK).EQ.IBRDGE             UIBRKR   1258
     1   .OR. IUDSUB(JBLK).EQ.IDCLIN.OR.IUDSUB(JBLK).EQ.ISAMPL          UIBRKR   1259
     2   .OR. IUDSUB(JBLK).EQ.IRAMPR)THEN                               UIBRKR   1260
C                                                                       UIBRKR   1261
         LOGEXP(1) = .FALSE.                                            UIBRKR   1262
         LOGEXP(2) = .FALSE.                                            UIBRKR   1263
         J = 0                                                          UIBRKR   1264
420      IF(NEXTR.EQ.0.OR.J.GE.2) GO TO 440                             UIBRKR   1265
C                                                                       UIBRKR   1266
C           Retrieve the logical expression.                            UIBRKR   1267
C                                                                       UIBRKR   1268
            J = J + 1                                                   UIBRKR   1269
            IF(IUDBNM(NEXTR) .LE. 0)THEN                                UIBRKR   1270
               VALUE1 = UDPRM1(NEXTR)                                   UIBRKR   1271
            ELSE                                                        UIBRKR   1272
               JBLOCK = IUDBNM(NEXTR)                                   UIBRKR   1273
               VALUE1 = UDVAL(JBLOCK)                                   UIBRKR   1274
            END IF                                                      UIBRKR   1275
            OPER = UDRELA(NEXTR)                                        UIBRKR   1276
            IF(JUDBNM(NEXTR) .LE. 0)THEN                                UIBRKR   1277
               VALUE2 = UDPRM2(NEXTR)                                   UIBRKR   1278
            ELSE                                                        UIBRKR   1279
               JBLOCK = JUDBNM(NEXTR)                                   UIBRKR   1280
               VALUE2 = UDVAL(JBLOCK)                                   UIBRKR   1281
            END IF                                                      UIBRKR   1282
C                                                                       UIBRKR   1283
C           Evaluate the logical expression.                            UIBRKR   1284
C                                                                       UIBRKR   1285
            LOGEXP(J) = .FALSE.                                         UIBRKR   1286
            IF(OPER.EQ.'EQ')THEN                                        UIBRKR   1287
               IF(VALUE1 .EQ. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR   1288
            ELSEIF(OPER.EQ.'NE')THEN                                    UIBRKR   1289
               IF(VALUE1 .NE. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR   1290
            ELSEIF(OPER.EQ.'LT')THEN                                    UIBRKR   1291
               IF(VALUE1 .LT. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR   1292
            ELSEIF(OPER.EQ.'LE')THEN                                    UIBRKR   1293
               IF(VALUE1 .LE. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR   1294
            ELSEIF(OPER.EQ.'GT')THEN                                    UIBRKR   1295
               IF(VALUE1 .GT. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR   1296
            ELSEIF(OPER.EQ.'GE')THEN                                    UIBRKR   1297
               IF(VALUE1 .GE. VALUE2) LOGEXP(J) = .TRUE.                UIBRKR   1298
            END IF                                                      UIBRKR   1299
C                                                                       UIBRKR   1300
            LASTR = NEXTR                                               UIBRKR   1301
            NEXTR = IUDRNX(NEXTR)                                       UIBRKR   1302
            GO TO 420                                                   UIBRKR   1303
440      CONTINUE                                                       UIBRKR   1304
      END IF                                                            UIBRKR   1305
C                                                                       UIBRKR   1306
C     DIGIT:  Digitizer.                                                UIBRKR   1307
C                                                                       UIBRKR   1308
      IF(IUDSUB(JBLK).EQ.IDIGIT)THEN                                    UIBRKR   1309
C                                                                       UIBRKR   1310
C        Input value.                                                   UIBRKR   1311
C                                                                       UIBRKR   1312
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   1313
C                                                                       UIBRKR   1314
C           No input value was stored.                                  UIBRKR   1315
C                                                                       UIBRKR   1316
            MISS = 'INPUT VALUE'                                        UIBRKR   1317
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1318
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1319
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1320
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1321
               WRITE(MSG(5),9902)                                       UIBRKR   1322
               CALL PRTMSG(5)                                           UIBRKR   1323
            IERCNT = IERCNT + 1                                         UIBRKR   1324
         ELSE                                                           UIBRKR   1325
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   1326
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   1327
            ELSE                                                        UIBRKR   1328
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   1329
            END IF                                                      UIBRKR   1330
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1331
            LASTP = NEXTP                                               UIBRKR   1332
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1333
         END IF                                                         UIBRKR   1334
C                                                                       UIBRKR   1335
C        Quantum.                                                       UIBRKR   1336
C                                                                       UIBRKR   1337
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1338
C                                                                       UIBRKR   1339
C           Missing quantum value.                                      UIBRKR   1340
C                                                                       UIBRKR   1341
            MISS = 'QUANTUM'                                            UIBRKR   1342
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1343
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1344
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1345
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1346
               WRITE(MSG(5),9902)                                       UIBRKR   1347
               CALL PRTMSG(5)                                           UIBRKR   1348
            IERCNT = IERCNT + 1                                         UIBRKR   1349
            QUANTM = 0.0                                                UIBRKR   1350
         ELSE                                                           UIBRKR   1351
            QUANTM = UDPARM(NEXTP)                                      UIBRKR   1352
            LASTP = NEXTP                                               UIBRKR   1353
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1354
         END IF                                                         UIBRKR   1355
C                                                                       UIBRKR   1356
C                                                                       UIBRKR   1357
C        Calculate UDVAL.                                               UIBRKR   1358
C                                                                       UIBRKR   1359
         N = INT(VALUE1 / QUANTM)                                       UIBRKR   1360
         UDVAL(JBLK) = REAL (N) * QUANTM                                UIBRKR   1361
C                                                                       UIBRKR   1362
C     DELAY:  Delay function.                                           UIBRKR   1363
C                                                                       UIBRKR   1364
      ELSEIF(IUDSUB(JBLK).EQ.IDELAY)THEN                                UIBRKR   1365
C                                                                       UIBRKR   1366
C        Input.                                                         UIBRKR   1367
C                                                                       UIBRKR   1368
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   1369
C                                                                       UIBRKR   1370
C           No input value was stored.                                  UIBRKR   1371
C                                                                       UIBRKR   1372
            MISS = 'INPUT VALUE'                                        UIBRKR   1373
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1374
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1375
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1376
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1377
               WRITE(MSG(5),9902)                                       UIBRKR   1378
               CALL PRTMSG(5)                                           UIBRKR   1379
            IERCNT = IERCNT + 1                                         UIBRKR   1380
         ELSE                                                           UIBRKR   1381
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   1382
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   1383
            ELSE                                                        UIBRKR   1384
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   1385
            END IF                                                      UIBRKR   1386
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1387
            LASTP = NEXTP                                               UIBRKR   1388
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1389
         END IF                                                         UIBRKR   1390
C                                                                       UIBRKR   1391
C        Delay time.                                                    UIBRKR   1392
C                                                                       UIBRKR   1393
         IF(NEXTI.EQ.0.OR.NEXTP.EQ.0)THEN                               UIBRKR   1394
C                                                                       UIBRKR   1395
C           No delay time was stored.                                   UIBRKR   1396
C                                                                       UIBRKR   1397
            MISS = 'DELAY TIME'                                         UIBRKR   1398
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1399
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1400
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1401
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1402
               WRITE(MSG(5),9902)                                       UIBRKR   1403
               CALL PRTMSG(5)                                           UIBRKR   1404
            IERCNT = IERCNT + 1                                         UIBRKR   1405
         ELSE                                                           UIBRKR   1406
            IF(UIDENT(NEXTI).NE.' ')THEN                                UIBRKR   1407
               V = UDVAL(IUDINT(NEXTI))/CTIME                           UIBRKR   1408
            ELSE                                                        UIBRKR   1409
               V = UDPARM(NEXTP)/CTIME                                  UIBRKR   1410
            END IF                                                      UIBRKR   1411
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1412
            LASTP = NEXTP                                               UIBRKR   1413
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1414
         END IF                                                         UIBRKR   1415
C                                                                       UIBRKR   1416
C        Current pointer.                                               UIBRKR   1417
C                                                                       UIBRKR   1418
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1419
C                                                                       UIBRKR   1420
C           The delay list has not been created.                        UIBRKR   1421
C                                                                       UIBRKR   1422
            JTOP = IDELFR                                               UIBRKR   1423
            IF(V.LT.1.0)THEN                                            UIBRKR   1424
               JBOTOM =JTOP + 1                                         UIBRKR   1425
            ELSE                                                        UIBRKR   1426
               JBOTOM = INT(V+0.5)+JTOP-1                               UIBRKR   1427
            ENDIF                                                       UIBRKR   1428
            JCURRN = JTOP                                               UIBRKR   1429
            CALL ADDPRM(JBLK, IADDP, LASTP)                             UIBRKR   1430
            ICURPT =IADDP                                               UIBRKR   1431
            UDPARM(IADDP)=REAL(JCURRN)                                  UIBRKR   1432
         ELSE                                                           UIBRKR   1433
            JCURPT = NEXTP                                              UIBRKR   1434
            JCURRN = INT(UDPARM(NEXTP))                                 UIBRKR   1435
            LASTP = NEXTP                                               UIBRKR   1436
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1437
         END IF                                                         UIBRKR   1438
C                                                                       UIBRKR   1439
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1440
C                                                                       UIBRKR   1441
C           Create delay list.                                          UIBRKR   1442
C                                                                       UIBRKR   1443
            CALL ADDPRM(JBLK, IADDP, LASTP)                             UIBRKR   1444
            UDPARM(IADDP) = JTOP                                        UIBRKR   1445
         ELSE                                                           UIBRKR   1446
            JTOP = INT(UDPARM(NEXTP))                                   UIBRKR   1447
            LASTP = NEXTP                                               UIBRKR   1448
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1449
         END IF                                                         UIBRKR   1450
C                                                                       UIBRKR   1451
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1452
C                                                                       UIBRKR   1453
C           Create delay list.                                          UIBRKR   1454
C                                                                       UIBRKR   1455
            CALL ADDPRM(JBLK, IADDP, LASTP)                             UIBRKR   1456
            UDPARM(IADDP) = JBOTOM                                      UIBRKR   1457
            IDELFR = JBOTOM + 1                                         UIBRKR   1458
            IF(JTOP.GT.LEND.OR.JBOTOM.GT.LEND) THEN                     UIBRKR   1459
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1460
               WRITE(MSG(2),9308)                                       UIBRKR   1461
               WRITE(MSG(3),9309)                                       UIBRKR   1462
               WRITE(MSG(4),9310)                                       UIBRKR   1463
               CALL PRTMSG(4)                                           UIBRKR   1464
            MSG(1)=                                                     UIBRKR   1465
     *      'UIOTHR: TERMINATED DUE TO OVERFLOW IN UDC DELAY ARRAY'     UIBRKR   1466
            CALL ASTOP(MSG(1),53)                                       UIBRKR   1467
            ENDIF                                                       UIBRKR   1468
         ELSE                                                           UIBRKR   1469
            JBOTOM = INT(UDPARM(NEXTP))                                 UIBRKR   1470
            LASTP = NEXTP                                               UIBRKR   1471
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1472
         END IF                                                         UIBRKR   1473
C                                                                       UIBRKR   1474
C        Fill DELAY with initial value.                                 UIBRKR   1475
C                                                                       UIBRKR   1476
         IF(JTOP .NE. 0.AND.JBOTOM .NE. 0)THEN                          UIBRKR   1477
            DO 460 J = JTOP, JBOTOM                                     UIBRKR   1478
               DELAY(J) = VALUE1                                        UIBRKR   1479
460         CONTINUE                                                    UIBRKR   1480
C                                                                       UIBRKR   1481
C           Set output to initial value                                 UIBRKR   1482
C                                                                       UIBRKR   1483
            UDVAL(JBLK) = VALUE1                                        UIBRKR   1484
         ELSE                                                           UIBRKR   1485
C                                                                       UIBRKR   1486
C           No delay list was created.                                  UIBRKR   1487
C                                                                       UIBRKR   1488
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1489
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1490
               WRITE(MSG(3),9304) BNAME(1:LEN)                          UIBRKR   1491
               CALL PRTMSG(3)                                           UIBRKR   1492
            IERCNT = IERCNT + 1                                         UIBRKR   1493
         END IF                                                         UIBRKR   1494
C                                                                       UIBRKR   1495
C     DCLINE                                                            UIBRKR   1496
C                                                                       UIBRKR   1497
      ELSEIF(IUDSUB(JBLK).EQ.IDCLIN .OR. IUDSUB(JBLK).EQ.IRLCS)THEN     UIBRKR   1498
C                                                                       UIBRKR   1499
         IF(IUDSUB(JBLK).EQ.IDCLIN .AND. J .NE. 1) THEN                 UIBRKR   1500
C                                                                       UIBRKR   1501
C           No logical expression was stored.                           UIBRKR   1502
C                                                                       UIBRKR   1503
            MISS = 'LOGIC EXPRESSION'                                   UIBRKR   1504
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1505
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1506
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1507
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1508
               WRITE(MSG(5),9902)                                       UIBRKR   1509
               CALL PRTMSG(5)                                           UIBRKR   1510
            IERCNT = IERCNT + 1                                         UIBRKR   1511
            LOGEXP(1) = .FALSE.                                         UIBRKR   1512
         END IF                                                         UIBRKR   1513
C                                                                       UIBRKR   1514
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   1515
C                                                                       UIBRKR   1516
C           No dc line value was stored.                                UIBRKR   1517
C                                                                       UIBRKR   1518
            MISS = 'DC LINE'                                            UIBRKR   1519
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1520
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1521
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1522
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1523
               WRITE(MSG(5),9902)                                       UIBRKR   1524
               CALL PRTMSG(5)                                           UIBRKR   1525
            IERCNT = IERCNT + 1                                         UIBRKR   1526
            LINE = 0                                                    UIBRKR   1527
         ELSE                                                           UIBRKR   1528
            LINE = IUDINT(NEXTI)                                        UIBRKR   1529
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1530
         END IF                                                         UIBRKR   1531
C                                                                       UIBRKR   1532
         IF(NEXTI.EQ.0.OR.NEXTP.EQ.0)THEN                               UIBRKR   1533
C                                                                       UIBRKR   1534
C           No resistance was stored.                                   UIBRKR   1535
C                                                                       UIBRKR   1536
            MISS = 'RESISTANCE'                                         UIBRKR   1537
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1538
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1539
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1540
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1541
               WRITE(MSG(5),9902)                                       UIBRKR   1542
               CALL PRTMSG(5)                                           UIBRKR   1543
            IERCNT = IERCNT + 1                                         UIBRKR   1544
            R1 = 0.0                                                    UIBRKR   1545
         ELSE                                                           UIBRKR   1546
            IF(UIDENT(NEXTI).NE.' ')THEN                                UIBRKR   1547
               R1 = UDVAL(IUDINT(NEXTI))                                UIBRKR   1548
            ELSE                                                        UIBRKR   1549
               R1 = UDPARM(NEXTP)                                       UIBRKR   1550
            ENDIF                                                       UIBRKR   1551
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1552
            LASTP = NEXTP                                               UIBRKR   1553
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1554
         END IF                                                         UIBRKR   1555
C                                                                       UIBRKR   1556
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1557
C                                                                       UIBRKR   1558
C           No inductance was stored.                                   UIBRKR   1559
C                                                                       UIBRKR   1560
            MISS = 'INDUCTANCE'                                         UIBRKR   1561
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1562
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1563
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1564
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1565
               WRITE(MSG(5),9902)                                       UIBRKR   1566
               CALL PRTMSG(5)                                           UIBRKR   1567
            IERCNT = IERCNT + 1                                         UIBRKR   1568
            XL1 = 0.0                                                   UIBRKR   1569
         ELSE                                                           UIBRKR   1570
            XL1 = UDPARM(NEXTP)                                         UIBRKR   1571
            LASTP = NEXTP                                               UIBRKR   1572
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1573
         END IF                                                         UIBRKR   1574
C                                                                       UIBRKR   1575
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1576
C                                                                       UIBRKR   1577
C           No capacitance was stored.                                  UIBRKR   1578
C                                                                       UIBRKR   1579
            MISS = 'CAPACITANCE'                                        UIBRKR   1580
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1581
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1582
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1583
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1584
               WRITE(MSG(5),9902)                                       UIBRKR   1585
               CALL PRTMSG(5)                                           UIBRKR   1586
            IERCNT = IERCNT + 1                                         UIBRKR   1587
            CA1 = 0.0                                                   UIBRKR   1588
         ELSE                                                           UIBRKR   1589
            CA1 = UDPARM(NEXTP)                                         UIBRKR   1590
            LASTP = NEXTP                                               UIBRKR   1591
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1592
         END IF                                                         UIBRKR   1593
C                                                                       UIBRKR   1594
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1595
C                                                                       UIBRKR   1596
C           No capacitance was stored.                                  UIBRKR   1597
C                                                                       UIBRKR   1598
            MISS = 'CAPACITANCE'                                        UIBRKR   1599
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1600
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1601
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1602
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1603
               WRITE(MSG(5),9902)                                       UIBRKR   1604
               CALL PRTMSG(5)                                           UIBRKR   1605
            IERCNT = IERCNT + 1                                         UIBRKR   1606
            CB1 = 0.0                                                   UIBRKR   1607
         ELSE                                                           UIBRKR   1608
            CB1 = UDPARM(NEXTP)                                         UIBRKR   1609
            LASTP = NEXTP                                               UIBRKR   1610
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1611
         END IF                                                         UIBRKR   1612
C                                                                       UIBRKR   1613
C        Replace dc line values for the line specified.                 UIBRKR   1614
C                                                                       UIBRKR   1615
         IF(LINE .NE. 0.AND.IUDSUB(JBLK).EQ.IRLCS)THEN                  UIBRKR   1616
            RDCOHM(LINE) = R1                                           UIBRKR   1617
            XLDC(LINE) = XL1                                            UIBRKR   1618
            CDCA(LINE) = CA1                                            UIBRKR   1619
            CDCB(LINE) = CB1                                            UIBRKR   1620
         END IF                                                         UIBRKR   1621
         UDVAL(JBLK) = 0.0                                              UIBRKR   1622
C                                                                       UIBRKR   1623
C     BRIDGE                                                            UIBRKR   1624
C                                                                       UIBRKR   1625
      ELSEIF(IUDSUB(JBLK).EQ.IBRDGE)THEN                                UIBRKR   1626
C                                                                       UIBRKR   1627
         IF(J .NE. 1) THEN                                              UIBRKR   1628
C                                                                       UIBRKR   1629
C           No logical expression was stored.                           UIBRKR   1630
C                                                                       UIBRKR   1631
            MISS = 'LOGIC EXPRESSION'                                   UIBRKR   1632
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1633
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1634
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1635
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1636
               WRITE(MSG(5),9902)                                       UIBRKR   1637
               CALL PRTMSG(5)                                           UIBRKR   1638
            IERCNT = IERCNT + 1                                         UIBRKR   1639
            LOGEXP(1) = .FALSE.                                         UIBRKR   1640
         END IF                                                         UIBRKR   1641
C                                                                       UIBRKR   1642
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   1643
C                                                                       UIBRKR   1644
C           No dc converter value was stored.                           UIBRKR   1645
C                                                                       UIBRKR   1646
            MISS = 'DC CONVERTER'                                       UIBRKR   1647
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1648
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1649
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1650
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1651
               WRITE(MSG(5),9902)                                       UIBRKR   1652
               CALL PRTMSG(5)                                           UIBRKR   1653
            IERCNT = IERCNT + 1                                         UIBRKR   1654
            LINE = 0                                                    UIBRKR   1655
         ELSE                                                           UIBRKR   1656
            LINE = IUDINT(NEXTI)                                        UIBRKR   1657
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1658
         END IF                                                         UIBRKR   1659
C                                                                       UIBRKR   1660
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1661
C                                                                       UIBRKR   1662
C           No bridge was stored.                                       UIBRKR   1663
C                                                                       UIBRKR   1664
            MISS = 'BRIDGE NUMBER'                                      UIBRKR   1665
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1666
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1667
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1668
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1669
               WRITE(MSG(5),9902)                                       UIBRKR   1670
               CALL PRTMSG(5)                                           UIBRKR   1671
            IERCNT = IERCNT + 1                                         UIBRKR   1672
            BRIDGE = 0.0                                                UIBRKR   1673
        ELSE                                                            UIBRKR   1674
            BRIDGE = UDPARM(NEXTP)                                      UIBRKR   1675
            LASTP = NEXTP                                               UIBRKR   1676
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1677
         END IF                                                         UIBRKR   1678
C                                                                       UIBRKR   1679
C                                                                       UIBRKR   1680
         UDVAL(JBLK) = NSBRDG(LINE)                                     UIBRKR   1681
C                                                                       UIBRKR   1682
C     TAP                                                               UIBRKR   1683
C                                                                       UIBRKR   1684
      ELSEIF(IUDSUB(JBLK).EQ.ITAPS)THEN                                 UIBRKR   1685
C                                                                       UIBRKR   1686
C        Input.                                                         UIBRKR   1687
C                                                                       UIBRKR   1688
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   1689
C                                                                       UIBRKR   1690
C           No input value was stored.                                  UIBRKR   1691
C                                                                       UIBRKR   1692
            MISS = 'INPUT VALUE'                                        UIBRKR   1693
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1694
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1695
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1696
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1697
               WRITE(MSG(5),9902)                                       UIBRKR   1698
               CALL PRTMSG(5)                                           UIBRKR   1699
            IERCNT = IERCNT + 1                                         UIBRKR   1700
         ELSE                                                           UIBRKR   1701
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   1702
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   1703
            ELSE                                                        UIBRKR   1704
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   1705
            END IF                                                      UIBRKR   1706
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1707
            JOLD = NEXTP                                                UIBRKR   1708
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1709
         END IF                                                         UIBRKR   1710
C                                                                       UIBRKR   1711
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   1712
C                                                                       UIBRKR   1713
C           No dc converter value was stored.                           UIBRKR   1714
C                                                                       UIBRKR   1715
            MISS = 'DC CONVERTER'                                       UIBRKR   1716
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1717
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1718
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1719
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1720
               WRITE(MSG(5),9902)                                       UIBRKR   1721
               CALL PRTMSG(5)                                           UIBRKR   1722
            IERCNT = IERCNT + 1                                         UIBRKR   1723
            JCONV = 0                                                   UIBRKR   1724
         ELSE                                                           UIBRKR   1725
            JCONV = IUDINT(NEXTI)                                       UIBRKR   1726
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   1727
         END IF                                                         UIBRKR   1728
C                                                                       UIBRKR   1729
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1730
C                                                                       UIBRKR   1731
C           No low limit stored.                                        UIBRKR   1732
C                                                                       UIBRKR   1733
            MISS = 'LOW LIMIT'                                          UIBRKR   1734
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1735
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1736
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1737
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1738
               WRITE(MSG(5),9902)                                       UIBRKR   1739
               CALL PRTMSG(5)                                           UIBRKR   1740
            IERCNT = IERCNT + 1                                         UIBRKR   1741
            XLOW = 0.0                                                  UIBRKR   1742
         ELSE                                                           UIBRKR   1743
            XLOW = UDPARM(NEXTP)                                        UIBRKR   1744
            JOLD = NEXTP                                                UIBRKR   1745
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1746
         END IF                                                         UIBRKR   1747
C                                                                       UIBRKR   1748
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1749
C                                                                       UIBRKR   1750
C           No time1 was stored.                                        UIBRKR   1751
C                                                                       UIBRKR   1752
            MISS = 'TIME1'                                              UIBRKR   1753
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1754
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1755
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1756
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1757
               WRITE(MSG(5),9902)                                       UIBRKR   1758
               CALL PRTMSG(5)                                           UIBRKR   1759
            IERCNT = IERCNT + 1                                         UIBRKR   1760
            TIME1 = 0.0                                                 UIBRKR   1761
         ELSE                                                           UIBRKR   1762
            TIME1 = UDPARM(NEXTP)                                       UIBRKR   1763
            JOLD = NEXTP                                                UIBRKR   1764
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1765
         END IF                                                         UIBRKR   1766
C                                                                       UIBRKR   1767
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1768
C                                                                       UIBRKR   1769
C           No high limit was stored.                                   UIBRKR   1770
C                                                                       UIBRKR   1771
            MISS = 'HIGH LIMIT'                                         UIBRKR   1772
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1773
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1774
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1775
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1776
               WRITE(MSG(5),9902)                                       UIBRKR   1777
               CALL PRTMSG(5)                                           UIBRKR   1778
            IERCNT = IERCNT + 1                                         UIBRKR   1779
            HI = 0.0                                                    UIBRKR   1780
         ELSE                                                           UIBRKR   1781
            HI = UDPARM(NEXTP)                                          UIBRKR   1782
            JOLD = NEXTP                                                UIBRKR   1783
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1784
         END IF                                                         UIBRKR   1785
C                                                                       UIBRKR   1786
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1787
C                                                                       UIBRKR   1788
C           No time2 was stored.                                        UIBRKR   1789
C                                                                       UIBRKR   1790
            MISS = 'TIME2'                                              UIBRKR   1791
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1792
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1793
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1794
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1795
               WRITE(MSG(5),9902)                                       UIBRKR   1796
               CALL PRTMSG(5)                                           UIBRKR   1797
            IERCNT = IERCNT + 1                                         UIBRKR   1798
            TIME2 = 0                                                   UIBRKR   1799
         ELSE                                                           UIBRKR   1800
            TIME2 = UDPARM(NEXTP)                                       UIBRKR   1801
            JOLD = NEXTP                                                UIBRKR   1802
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1803
         END IF                                                         UIBRKR   1804
C                                                                       UIBRKR   1805
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1806
C                                                                       UIBRKR   1807
C           No step was stored.                                         UIBRKR   1808
C                                                                       UIBRKR   1809
            MISS = 'STEP'                                               UIBRKR   1810
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1811
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1812
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1813
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1814
               WRITE(MSG(5),9902)                                       UIBRKR   1815
               CALL PRTMSG(5)                                           UIBRKR   1816
            IERCNT = IERCNT + 1                                         UIBRKR   1817
            STEP = 0.0                                                  UIBRKR   1818
         ELSE                                                           UIBRKR   1819
            STEP = UDPARM(NEXTP)                                        UIBRKR   1820
            JOLD = NEXTP                                                UIBRKR   1821
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1822
         END IF                                                         UIBRKR   1823
C                                                                       UIBRKR   1824
C        No previous time has been stored.                              UIBRKR   1825
C                                                                       UIBRKR   1826
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1827
            NEXTP = IUDPFR                                              UIBRKR   1828
            IUDPFR = IUDPNX(IUDPFR)                                     UIBRKR   1829
            IUDPNX(JOLD) = NEXTP                                        UIBRKR   1830
            IUDPNX(NEXTP) = 0                                           UIBRKR   1831
            UDPARM(NEXTP) = 0.0                                         UIBRKR   1832
         ELSE                                                           UIBRKR   1833
            MISS = 'PREVIOUS TIME'                                      UIBRKR   1834
            WRITE(MSG(1),9000) SUBNAM                                   UIBRKR   1835
            WRITE(MSG(2),9102) TNAME                                    UIBRKR   1836
            WRITE(MSG(3),9103) MISS                                     UIBRKR   1837
            WRITE(MSG(4),9901) BNAME(1:LEN)                             UIBRKR   1838
            WRITE(MSG(5),9902)                                          UIBRKR   1839
            CALL PRTMSG(5)                                              UIBRKR   1840
         END IF                                                         UIBRKR   1841
C                                                                       UIBRKR   1842
C                                                                       UIBRKR   1843
C        Calculate UDVAL.                                               UIBRKR   1844
C                                                                       UIBRKR   1845
C                                                                       UIBRKR   1846
C                                                                       UIBRKR   1847
         UDVAL(JBLK) = 0.0                                              UIBRKR   1848
C                                                                       UIBRKR   1849
C     Level subtype.                                                    UIBRKR   1850
C                                                                       UIBRKR   1851
      ELSEIF(IUDSUB(JBLK).EQ.LEVELS)THEN                                UIBRKR   1852
C                                                                       UIBRKR   1853
         IF(J .NE. 1) THEN                                              UIBRKR   1854
C                                                                       UIBRKR   1855
C           No logical expression was stored.                           UIBRKR   1856
C                                                                       UIBRKR   1857
            MISS = 'LOGIC EXPRESSION'                                   UIBRKR   1858
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1859
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1860
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1861
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1862
               WRITE(MSG(5),9902)                                       UIBRKR   1863
               CALL PRTMSG(5)                                           UIBRKR   1864
            IERCNT = IERCNT + 1                                         UIBRKR   1865
            LOGEXP(1) = .FALSE.                                         UIBRKR   1866
         END IF                                                         UIBRKR   1867
C                                                                       UIBRKR   1868
         IF(IUDSPT(JBLK).EQ.0)THEN                                      UIBRKR   1869
C                                                                       UIBRKR   1870
C           Create the save list, set slope and time value to zero.     UIBRKR   1871
C                                                                       UIBRKR   1872
            IADDS = IUDSFR                                              UIBRKR   1873
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   1874
            IUDSPT(JBLK) = IADDS                                        UIBRKR   1875
            SLOPE = 0.0                                                 UIBRKR   1876
            UDOLD(IADDS) = SLOPE                                        UIBRKR   1877
            LASTS = IADDS                                               UIBRKR   1878
C                                                                       UIBRKR   1879
            IADDS = IUDSFR                                              UIBRKR   1880
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   1881
            IUDSNX(LASTS) = IADDS                                       UIBRKR   1882
            SRTTIM = 0.0                                                UIBRKR   1883
            UDOLD(IADDS) = SRTTIM                                       UIBRKR   1884
            LASTS = IADDS                                               UIBRKR   1885
C                                                                       UIBRKR   1886
            IADDS = IUDSFR                                              UIBRKR   1887
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   1888
            IUDSNX(LASTS) = IADDS                                       UIBRKR   1889
            ENDTIM = 0.0                                                UIBRKR   1890
            UDOLD(IADDS) = ENDTIM                                       UIBRKR   1891
            LASTS = IADDS                                               UIBRKR   1892
C                                                                       UIBRKR   1893
            IADDS = IUDSFR                                              UIBRKR   1894
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   1895
            IUDSNX(LASTS) = IADDS                                       UIBRKR   1896
            RSTTIM = 0.0                                                UIBRKR   1897
            UDOLD(IADDS) = RSTTIM                                       UIBRKR   1898
            IUDSNX(IADDS) = 0                                           UIBRKR   1899
         ELSE                                                           UIBRKR   1900
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   1901
            SLOPE = UDOLD(NEXTS)                                        UIBRKR   1902
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   1903
            SRTTIM = UDOLD(NEXTS)                                       UIBRKR   1904
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   1905
            ENDTIM = UDOLD(NEXTS)                                       UIBRKR   1906
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   1907
            RSTTIM = UDOLD(NEXTS)                                       UIBRKR   1908
         END IF                                                         UIBRKR   1909
C                                                                       UIBRKR   1910
C                                                                       UIBRKR   1911
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1912
C                                                                       UIBRKR   1913
C           No start value was stored.                                  UIBRKR   1914
C                                                                       UIBRKR   1915
            MISS = 'START VALUE'                                        UIBRKR   1916
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1917
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1918
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1919
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1920
               WRITE(MSG(5),9902)                                       UIBRKR   1921
               CALL PRTMSG(5)                                           UIBRKR   1922
            IERCNT = IERCNT + 1                                         UIBRKR   1923
         ELSE                                                           UIBRKR   1924
            SRTVAL = UDPARM(NEXTP)                                      UIBRKR   1925
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1926
         END IF                                                         UIBRKR   1927
C                                                                       UIBRKR   1928
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1929
C                                                                       UIBRKR   1930
C           No end value was stored.                                    UIBRKR   1931
C                                                                       UIBRKR   1932
            MISS = 'END VALUE'                                          UIBRKR   1933
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1934
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1935
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1936
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1937
               WRITE(MSG(5),9902)                                       UIBRKR   1938
               CALL PRTMSG(5)                                           UIBRKR   1939
            IERCNT = IERCNT + 1                                         UIBRKR   1940
         ELSE                                                           UIBRKR   1941
            ENDVAL = UDPARM(NEXTP)                                      UIBRKR   1942
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1943
         END IF                                                         UIBRKR   1944
C                                                                       UIBRKR   1945
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1946
C                                                                       UIBRKR   1947
C           No duration value was stored.                               UIBRKR   1948
C                                                                       UIBRKR   1949
            MISS = 'DURATION VALUE'                                     UIBRKR   1950
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1951
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1952
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1953
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1954
               WRITE(MSG(5),9902)                                       UIBRKR   1955
               CALL PRTMSG(5)                                           UIBRKR   1956
            IERCNT = IERCNT + 1                                         UIBRKR   1957
         ELSE                                                           UIBRKR   1958
            DURVAL = UDPARM(NEXTP)                                      UIBRKR   1959
            IF(DURVAL.LE.CTIME)THEN                                     UIBRKR   1960
               DURVAL = CTIME                                           UIBRKR   1961
               UDPARM(NEXTP) = DURVAL                                   UIBRKR   1962
            ENDIF                                                       UIBRKR   1963
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1964
         END IF                                                         UIBRKR   1965
C                                                                       UIBRKR   1966
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   1967
C                                                                       UIBRKR   1968
C           No reset length was stored.                                 UIBRKR   1969
C                                                                       UIBRKR   1970
            MISS = 'RESET LENGTH'                                       UIBRKR   1971
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   1972
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   1973
               WRITE(MSG(3),9103) MISS                                  UIBRKR   1974
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   1975
               WRITE(MSG(5),9902)                                       UIBRKR   1976
               CALL PRTMSG(5)                                           UIBRKR   1977
            IERCNT = IERCNT + 1                                         UIBRKR   1978
         ELSE                                                           UIBRKR   1979
            RSTLEN = UDPARM(NEXTP)                                      UIBRKR   1980
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   1981
         END IF                                                         UIBRKR   1982
C                                                                       UIBRKR   1983
C                                                                       UIBRKR   1984
C        Evaluate the output value.                                     UIBRKR   1985
C                                                                       UIBRKR   1986
         IF(SLOPE.EQ.0.0)THEN                                           UIBRKR   1987
C                                                                       UIBRKR   1988
C           Calculate the slope value.                                  UIBRKR   1989
C                                                                       UIBRKR   1990
            SLOPE = (ENDVAL - SRTVAL) / DURVAL                          UIBRKR   1991
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   1992
            UDOLD(NEXTS) = SLOPE                                        UIBRKR   1993
         END IF                                                         UIBRKR   1994
C                                                                       UIBRKR   1995
C                                                                       UIBRKR   1996
         IF(SRTTIM.EQ.0.0.AND.ENDTIM.EQ.0.0.AND.                        UIBRKR   1997
     1       RSTTIM.EQ.0.0)THEN                                         UIBRKR   1998
            IF(LOGEXP(1))THEN                                           UIBRKR   1999
C                                                                       UIBRKR   2000
C              Calculate time values for the saved list.                UIBRKR   2001
C                                                                       UIBRKR   2002
               SRTTIM = TIME                                            UIBRKR   2003
               ENDTIM = TIME + DURVAL                                   UIBRKR   2004
               RSTTIM = ENDTIM + RSTLEN                                 UIBRKR   2005
               NEXTS = IUDSPT(JBLK)                                     UIBRKR   2006
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   2007
               UDOLD(NEXTS) = SRTTIM                                    UIBRKR   2008
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   2009
               UDOLD(NEXTS) = ENDTIM                                    UIBRKR   2010
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   2011
               UDOLD(NEXTS) = RSTTIM                                    UIBRKR   2012
               UDVAL(JBLK) = SRTVAL                                     UIBRKR   2013
            ELSE                                                        UIBRKR   2014
               UDVAL(JBLK) = SRTVAL                                     UIBRKR   2015
            END IF                                                      UIBRKR   2016
         ELSE                                                           UIBRKR   2017
            IF(TIME .GT. SRTTIM.AND.TIME .LT. ENDTIM)THEN               UIBRKR   2018
               UDVAL(JBLK) = SLOPE * (TIME - SRTTIM) + SRTVAL           UIBRKR   2019
            ELSEIF(TIME .GE. ENDTIM.AND.TIME .LE. RSTTIM)THEN           UIBRKR   2020
               UDVAL(JBLK) = ENDVAL                                     UIBRKR   2021
            ELSE                                                        UIBRKR   2022
               UDVAL(JBLK) = SRTVAL                                     UIBRKR   2023
               NEXTS = IUDSPT(JBLK)                                     UIBRKR   2024
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   2025
               UDOLD(NEXTS) = 0.0                                       UIBRKR   2026
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   2027
               UDOLD(NEXTS) = 0.0                                       UIBRKR   2028
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   2029
               UDOLD(NEXTS) = 0.0                                       UIBRKR   2030
            END IF                                                      UIBRKR   2031
         END IF                                                         UIBRKR   2032
C                                                                       UIBRKR   2033
C     Hysteresis function.                                              UIBRKR   2034
C                                                                       UIBRKR   2035
      ELSEIF(IUDSUB(JBLK).EQ.IHYSTR)THEN                                UIBRKR   2036
C                                                                       UIBRKR   2037
         IF(IUDSPT(JBLK).EQ.0)THEN                                      UIBRKR   2038
C                                                                       UIBRKR   2039
C           Create the save list, set slope and path value to zero.     UIBRKR   2040
C                                                                       UIBRKR   2041
            IADDS = IUDSFR                                              UIBRKR   2042
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2043
            IUDSPT(JBLK) = IADDS                                        UIBRKR   2044
            SLOPE1 = 0.0                                                UIBRKR   2045
            UDOLD(IADDS) = SLOPE1                                       UIBRKR   2046
            LASTS = IADDS                                               UIBRKR   2047
C                                                                       UIBRKR   2048
            IADDS = IUDSFR                                              UIBRKR   2049
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2050
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2051
            SLOPE2 = 0.0                                                UIBRKR   2052
            UDOLD(IADDS) = SLOPE2                                       UIBRKR   2053
            LASTS = IADDS                                               UIBRKR   2054
C                                                                       UIBRKR   2055
            IADDS = IUDSFR                                              UIBRKR   2056
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2057
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2058
            JPATH = 0                                                   UIBRKR   2059
            UDOLD(IADDS) = REAL (JPATH)                                 UIBRKR   2060
            IUDSNX(IADDS) = 0                                           UIBRKR   2061
         ELSE                                                           UIBRKR   2062
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   2063
            SLOPE1 = UDOLD(NEXTS)                                       UIBRKR   2064
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2065
            SLOPE2 = UDOLD(NEXTS)                                       UIBRKR   2066
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2067
            JPATH = INT(UDOLD(NEXTS))                                   UIBRKR   2068
         END IF                                                         UIBRKR   2069
C                                                                       UIBRKR   2070
C                                                                       UIBRKR   2071
C        Input value.                                                   UIBRKR   2072
C                                                                       UIBRKR   2073
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   2074
C                                                                       UIBRKR   2075
C           No input value was stored.                                  UIBRKR   2076
C                                                                       UIBRKR   2077
            MISS = 'INPUT VALUE'                                        UIBRKR   2078
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2079
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2080
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2081
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2082
               WRITE(MSG(5),9902)                                       UIBRKR   2083
               CALL PRTMSG(5)                                           UIBRKR   2084
            IERCNT = IERCNT + 1                                         UIBRKR   2085
         ELSE                                                           UIBRKR   2086
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   2087
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   2088
            ELSE                                                        UIBRKR   2089
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   2090
            END IF                                                      UIBRKR   2091
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2092
            LASTP = NEXTP                                               UIBRKR   2093
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2094
         END IF                                                         UIBRKR   2095
C                                                                       UIBRKR   2096
C                                                                       UIBRKR   2097
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2098
C                                                                       UIBRKR   2099
C           No level A value was stored.                                UIBRKR   2100
C                                                                       UIBRKR   2101
            MISS = 'LEVEL A'                                            UIBRKR   2102
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2103
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2104
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2105
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2106
               WRITE(MSG(5),9902)                                       UIBRKR   2107
               CALL PRTMSG(5)                                           UIBRKR   2108
            IERCNT = IERCNT + 1                                         UIBRKR   2109
         ELSE                                                           UIBRKR   2110
            ALEVEL = UDPARM(NEXTP)                                      UIBRKR   2111
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2112
         END IF                                                         UIBRKR   2113
C                                                                       UIBRKR   2114
C                                                                       UIBRKR   2115
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2116
C                                                                       UIBRKR   2117
C           No level B value was stored.                                UIBRKR   2118
C                                                                       UIBRKR   2119
            MISS = 'LEVEL B'                                            UIBRKR   2120
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2121
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2122
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2123
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2124
               WRITE(MSG(5),9902)                                       UIBRKR   2125
               CALL PRTMSG(5)                                           UIBRKR   2126
            IERCNT = IERCNT + 1                                         UIBRKR   2127
         ELSE                                                           UIBRKR   2128
            BLEVEL = UDPARM(NEXTP)                                      UIBRKR   2129
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2130
         END IF                                                         UIBRKR   2131
C                                                                       UIBRKR   2132
C                                                                       UIBRKR   2133
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2134
C                                                                       UIBRKR   2135
C           No P1 value was stored.                                     UIBRKR   2136
C                                                                       UIBRKR   2137
            MISS = 'P1 VALUE'                                           UIBRKR   2138
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2139
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2140
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2141
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2142
               WRITE(MSG(5),9902)                                       UIBRKR   2143
               CALL PRTMSG(5)                                           UIBRKR   2144
            IERCNT = IERCNT + 1                                         UIBRKR   2145
         ELSE                                                           UIBRKR   2146
            P1 = UDPARM(NEXTP)                                          UIBRKR   2147
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2148
         END IF                                                         UIBRKR   2149
C                                                                       UIBRKR   2150
C                                                                       UIBRKR   2151
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2152
C                                                                       UIBRKR   2153
C           No P2 value was stored.                                     UIBRKR   2154
C                                                                       UIBRKR   2155
            MISS = 'P2 VALUE'                                           UIBRKR   2156
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2157
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2158
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2159
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2160
               WRITE(MSG(5),9902)                                       UIBRKR   2161
               CALL PRTMSG(5)                                           UIBRKR   2162
            IERCNT = IERCNT + 1                                         UIBRKR   2163
         ELSE                                                           UIBRKR   2164
            P2 = UDPARM(NEXTP)                                          UIBRKR   2165
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2166
         END IF                                                         UIBRKR   2167
C                                                                       UIBRKR   2168
C                                                                       UIBRKR   2169
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2170
C                                                                       UIBRKR   2171
C           No P3 value was stored.                                     UIBRKR   2172
C                                                                       UIBRKR   2173
            MISS = 'P3 VALUE'                                           UIBRKR   2174
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2175
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2176
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2177
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2178
               WRITE(MSG(5),9902)                                       UIBRKR   2179
               CALL PRTMSG(5)                                           UIBRKR   2180
            IERCNT = IERCNT + 1                                         UIBRKR   2181
         ELSE                                                           UIBRKR   2182
            P3 = UDPARM(NEXTP)                                          UIBRKR   2183
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2184
         END IF                                                         UIBRKR   2185
C                                                                       UIBRKR   2186
C                                                                       UIBRKR   2187
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2188
C                                                                       UIBRKR   2189
C           No P4 value was stored.                                     UIBRKR   2190
C                                                                       UIBRKR   2191
            MISS = 'P4 VALUE'                                           UIBRKR   2192
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2193
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2194
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2195
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2196
               WRITE(MSG(5),9902)                                       UIBRKR   2197
               CALL PRTMSG(5)                                           UIBRKR   2198
            IERCNT = IERCNT + 1                                         UIBRKR   2199
         ELSE                                                           UIBRKR   2200
            P4 = UDPARM(NEXTP)                                          UIBRKR   2201
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2202
         END IF                                                         UIBRKR   2203
C                                                                       UIBRKR   2204
C                                                                       UIBRKR   2205
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2206
C                                                                       UIBRKR   2207
C           No initial path was stored.                                 UIBRKR   2208
C                                                                       UIBRKR   2209
            MISS = 'INITIAL PATH'                                       UIBRKR   2210
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2211
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2212
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2213
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2214
               WRITE(MSG(5),9902)                                       UIBRKR   2215
               CALL PRTMSG(5)                                           UIBRKR   2216
            IERCNT = IERCNT + 1                                         UIBRKR   2217
         ELSE                                                           UIBRKR   2218
            INIT = INT(UDPARM(NEXTP))                                   UIBRKR   2219
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2220
         END IF                                                         UIBRKR   2221
C                                                                       UIBRKR   2222
C                                                                       UIBRKR   2223
C                                                                       UIBRKR   2224
         IF(SLOPE1.EQ.0.0.AND.SLOPE2.EQ.0.0)THEN                        UIBRKR   2225
C                                                                       UIBRKR   2226
C           Calculate the first slope value.                            UIBRKR   2227
C                                                                       UIBRKR   2228
            IF(P3 .NE. P4)THEN                                          UIBRKR   2229
               SLOPE1 = (ALEVEL - BLEVEL) / (P4 - P3)                   UIBRKR   2230
            END IF                                                      UIBRKR   2231
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   2232
            UDOLD(NEXTS) = SLOPE1                                       UIBRKR   2233
C                                                                       UIBRKR   2234
C           Calculate the second slope value.                           UIBRKR   2235
C                                                                       UIBRKR   2236
            IF(P1 .NE. P2)THEN                                          UIBRKR   2237
               SLOPE2 = (ALEVEL - BLEVEL) / (P2 - P1)                   UIBRKR   2238
            END IF                                                      UIBRKR   2239
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2240
            UDOLD(NEXTS) = SLOPE2                                       UIBRKR   2241
C                                                                       UIBRKR   2242
C           Define the path initially.                                  UIBRKR   2243
C                                                                       UIBRKR   2244
            IF(INIT .GE. 0)THEN                                         UIBRKR   2245
               JPATH = 1                                                UIBRKR   2246
            ELSE                                                        UIBRKR   2247
               JPATH = 2                                                UIBRKR   2248
            END IF                                                      UIBRKR   2249
C                                                                       UIBRKR   2250
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2251
            UDOLD(NEXTS) = REAL (JPATH)                                 UIBRKR   2252
            LASTS = NEXTS                                               UIBRKR   2253
         ELSE                                                           UIBRKR   2254
C                                                                       UIBRKR   2255
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   2256
            SLOPE1 = UDOLD(NEXTS)                                       UIBRKR   2257
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2258
            SLOPE2 = UDOLD(NEXTS)                                       UIBRKR   2259
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2260
            JPATH = INT(UDOLD(NEXTS))                                   UIBRKR   2261
            LASTS = NEXTS                                               UIBRKR   2262
         END IF                                                         UIBRKR   2263
C                                                                       UIBRKR   2264
C                                                                       UIBRKR   2265
C        Calculate the output value.                                    UIBRKR   2266
C                                                                       UIBRKR   2267
         IF(JPATH.EQ.1)THEN                                             UIBRKR   2268
            IF(VALUE1 .GE. P4)THEN                                      UIBRKR   2269
               UDVAL(JBLK) = ALEVEL                                     UIBRKR   2270
            ELSEIF(VALUE1 .LE. P3)THEN                                  UIBRKR   2271
               UDVAL(JBLK) = BLEVEL                                     UIBRKR   2272
            ELSE                                                        UIBRKR   2273
               UDVAL(JBLK) = BLEVEL + (VALUE1 - P3) * SLOPE1            UIBRKR   2274
            END IF                                                      UIBRKR   2275
         ELSE                                                           UIBRKR   2276
            IF(VALUE1 .GE. P2)THEN                                      UIBRKR   2277
               UDVAL(JBLK) = ALEVEL                                     UIBRKR   2278
            ELSEIF(VALUE1 .LE. P1)THEN                                  UIBRKR   2279
               UDVAL(JBLK) = BLEVEL                                     UIBRKR   2280
            ELSE                                                        UIBRKR   2281
               UDVAL(JBLK) = BLEVEL + (VALUE1 - P1) * SLOPE2            UIBRKR   2282
            END IF                                                      UIBRKR   2283
         END IF                                                         UIBRKR   2284
C                                                                       UIBRKR   2285
C     First deadband function.                                          UIBRKR   2286
C                                                                       UIBRKR   2287
C                                                                       UIBRKR   2288
      ELSEIF(IUDSUB(JBLK).EQ.IDEAD1)THEN                                UIBRKR   2289
C                                                                       UIBRKR   2290
C        Input value.                                                   UIBRKR   2291
C                                                                       UIBRKR   2292
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   2293
C                                                                       UIBRKR   2294
C           No input value was stored.                                  UIBRKR   2295
C                                                                       UIBRKR   2296
            MISS = 'INPUT VALUE'                                        UIBRKR   2297
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2298
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2299
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2300
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2301
               WRITE(MSG(5),9902)                                       UIBRKR   2302
               CALL PRTMSG(5)                                           UIBRKR   2303
            IERCNT = IERCNT + 1                                         UIBRKR   2304
         ELSE                                                           UIBRKR   2305
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   2306
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   2307
            ELSE                                                        UIBRKR   2308
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   2309
            END IF                                                      UIBRKR   2310
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2311
            LASTP = NEXTP                                               UIBRKR   2312
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2313
         END IF                                                         UIBRKR   2314
C                                                                       UIBRKR   2315
C                                                                       UIBRKR   2316
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2317
C                                                                       UIBRKR   2318
C           No Deadband positive value was stored.                      UIBRKR   2319
C                                                                       UIBRKR   2320
            MISS = 'DBP'                                                UIBRKR   2321
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2322
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2323
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2324
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2325
               WRITE(MSG(5),9902)                                       UIBRKR   2326
               CALL PRTMSG(5)                                           UIBRKR   2327
            IERCNT = IERCNT + 1                                         UIBRKR   2328
         ELSE                                                           UIBRKR   2329
            DBP = UDPARM(NEXTP)                                         UIBRKR   2330
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2331
         END IF                                                         UIBRKR   2332
C                                                                       UIBRKR   2333
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2334
C                                                                       UIBRKR   2335
C           No Deadband positive output value was stored.               UIBRKR   2336
C                                                                       UIBRKR   2337
            MISS = 'DBP OUTPUT'                                         UIBRKR   2338
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2339
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2340
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2341
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2342
               WRITE(MSG(5),9902)                                       UIBRKR   2343
               CALL PRTMSG(5)                                           UIBRKR   2344
            IERCNT = IERCNT + 1                                         UIBRKR   2345
         ELSE                                                           UIBRKR   2346
            OUTP = UDPARM(NEXTP)                                        UIBRKR   2347
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2348
         END IF                                                         UIBRKR   2349
C                                                                       UIBRKR   2350
C                                                                       UIBRKR   2351
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2352
C                                                                       UIBRKR   2353
C           No Deadband negative value was stored.                      UIBRKR   2354
C                                                                       UIBRKR   2355
            MISS = 'DBN'                                                UIBRKR   2356
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2357
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2358
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2359
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2360
               WRITE(MSG(5),9902)                                       UIBRKR   2361
               CALL PRTMSG(5)                                           UIBRKR   2362
            IERCNT = IERCNT + 1                                         UIBRKR   2363
         ELSE                                                           UIBRKR   2364
            DBN = UDPARM(NEXTP)                                         UIBRKR   2365
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2366
         END IF                                                         UIBRKR   2367
C                                                                       UIBRKR   2368
C                                                                       UIBRKR   2369
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2370
C                                                                       UIBRKR   2371
C           No Deadband negative output value was stored.               UIBRKR   2372
C                                                                       UIBRKR   2373
            MISS = 'DBN OUTPUT'                                         UIBRKR   2374
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2375
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2376
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2377
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2378
               WRITE(MSG(5),9902)                                       UIBRKR   2379
               CALL PRTMSG(5)                                           UIBRKR   2380
            IERCNT = IERCNT + 1                                         UIBRKR   2381
         ELSE                                                           UIBRKR   2382
            OUTN = UDPARM(NEXTP)                                        UIBRKR   2383
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2384
         END IF                                                         UIBRKR   2385
C                                                                       UIBRKR   2386
C                                                                       UIBRKR   2387
         IF(VALUE1 .GT. DBP)THEN                                        UIBRKR   2388
            UDVAL(JBLK) = OUTP                                          UIBRKR   2389
         ELSEIF(VALUE1 .LT. DBN)THEN                                    UIBRKR   2390
            UDVAL(JBLK) = OUTN                                          UIBRKR   2391
         ELSE                                                           UIBRKR   2392
            UDVAL(JBLK) = 0.0                                           UIBRKR   2393
         END IF                                                         UIBRKR   2394
C                                                                       UIBRKR   2395
C     Second deadband function.                                         UIBRKR   2396
C                                                                       UIBRKR   2397
C                                                                       UIBRKR   2398
      ELSEIF(IUDSUB(JBLK).EQ.IDEAD2)THEN                                UIBRKR   2399
C                                                                       UIBRKR   2400
C        Input value.                                                   UIBRKR   2401
C                                                                       UIBRKR   2402
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   2403
C                                                                       UIBRKR   2404
C           No input value was stored.                                  UIBRKR   2405
C                                                                       UIBRKR   2406
            MISS = 'INPUT VALUE'                                        UIBRKR   2407
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2408
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2409
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2410
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2411
               WRITE(MSG(5),9902)                                       UIBRKR   2412
               CALL PRTMSG(5)                                           UIBRKR   2413
            IERCNT = IERCNT + 1                                         UIBRKR   2414
         ELSE                                                           UIBRKR   2415
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   2416
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   2417
            ELSE                                                        UIBRKR   2418
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   2419
            END IF                                                      UIBRKR   2420
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2421
            LASTP = NEXTP                                               UIBRKR   2422
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2423
         END IF                                                         UIBRKR   2424
C                                                                       UIBRKR   2425
C                                                                       UIBRKR   2426
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2427
C                                                                       UIBRKR   2428
C           No Deadband positive value was stored.                      UIBRKR   2429
C                                                                       UIBRKR   2430
            MISS = 'DBP'                                                UIBRKR   2431
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2432
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2433
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2434
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2435
               WRITE(MSG(5),9902)                                       UIBRKR   2436
               CALL PRTMSG(5)                                           UIBRKR   2437
            IERCNT = IERCNT + 1                                         UIBRKR   2438
         ELSE                                                           UIBRKR   2439
            DBP = UDPARM(NEXTP)                                         UIBRKR   2440
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2441
         END IF                                                         UIBRKR   2442
C                                                                       UIBRKR   2443
C                                                                       UIBRKR   2444
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2445
C                                                                       UIBRKR   2446
C           No Deadband positive slope was stored.                      UIBRKR   2447
C                                                                       UIBRKR   2448
            MISS = 'SLOPE P'                                            UIBRKR   2449
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2450
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2451
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2452
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2453
               WRITE(MSG(5),9902)                                       UIBRKR   2454
               CALL PRTMSG(5)                                           UIBRKR   2455
            IERCNT = IERCNT + 1                                         UIBRKR   2456
         ELSE                                                           UIBRKR   2457
            SLOPEP = UDPARM(NEXTP)                                      UIBRKR   2458
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2459
         END IF                                                         UIBRKR   2460
C                                                                       UIBRKR   2461
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2462
C                                                                       UIBRKR   2463
C           No Deadband negative value was stored.                      UIBRKR   2464
C                                                                       UIBRKR   2465
            MISS = 'DBN'                                                UIBRKR   2466
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2467
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2468
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2469
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2470
               WRITE(MSG(5),9902)                                       UIBRKR   2471
               CALL PRTMSG(5)                                           UIBRKR   2472
            IERCNT = IERCNT + 1                                         UIBRKR   2473
         ELSE                                                           UIBRKR   2474
            DBN = UDPARM(NEXTP)                                         UIBRKR   2475
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2476
         END IF                                                         UIBRKR   2477
C                                                                       UIBRKR   2478
C                                                                       UIBRKR   2479
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   2480
C                                                                       UIBRKR   2481
C           No Deadband negative slope was stored.                      UIBRKR   2482
C                                                                       UIBRKR   2483
            MISS = 'SLOPE N'                                            UIBRKR   2484
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2485
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2486
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2487
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2488
               WRITE(MSG(5),9902)                                       UIBRKR   2489
               CALL PRTMSG(5)                                           UIBRKR   2490
            IERCNT = IERCNT + 1                                         UIBRKR   2491
         ELSE                                                           UIBRKR   2492
            SLOPEN = UDPARM(NEXTP)                                      UIBRKR   2493
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2494
         END IF                                                         UIBRKR   2495
C                                                                       UIBRKR   2496
C                                                                       UIBRKR   2497
         IF(VALUE1 .GT. DBP)THEN                                        UIBRKR   2498
            UDVAL(JBLK) = (VALUE1 - DBP) * SLOPEP                       UIBRKR   2499
         ELSEIF(VALUE1 .LT. DBN)THEN                                    UIBRKR   2500
            UDVAL(JBLK) = (VALUE1 - DBN) * SLOPEN                       UIBRKR   2501
         ELSE                                                           UIBRKR   2502
            UDVAL(JBLK) = 0.0                                           UIBRKR   2503
         END IF                                                         UIBRKR   2504
C                                                                       UIBRKR   2505
C     Sample & Hold function.                                           UIBRKR   2506
C                                                                       UIBRKR   2507
C                                                                       UIBRKR   2508
      ELSE IF (IUDSUB(JBLK) .EQ. ISAMPL) THEN                           UIBRKR   2509
C                                                                       UIBRKR   2510
C        Input1 value.                                                  UIBRKR   2511
C                                                                       UIBRKR   2512
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2513
C                                                                       UIBRKR   2514
C           No input value was stored.                                  UIBRKR   2515
C                                                                       UIBRKR   2516
            MISS = 'INPUT VALUE 1'                                      UIBRKR   2517
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2518
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2519
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2520
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2521
               WRITE(MSG(5),9902)                                       UIBRKR   2522
               CALL PRTMSG(5)                                           UIBRKR   2523
            IERCNT = IERCNT + 1                                         UIBRKR   2524
         ELSE                                                           UIBRKR   2525
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2526
               VALUE1 = UDVAL(IUDINT(NEXTI))                            UIBRKR   2527
            ELSE                                                        UIBRKR   2528
               VALUE1 = UDPARM(NEXTP)                                   UIBRKR   2529
            END IF                                                      UIBRKR   2530
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2531
            LASTP = NEXTP                                               UIBRKR   2532
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2533
         END IF                                                         UIBRKR   2534
C                                                                       UIBRKR   2535
C        Input2 value.                                                  UIBRKR   2536
C                                                                       UIBRKR   2537
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2538
C                                                                       UIBRKR   2539
C           No input value was stored.                                  UIBRKR   2540
C                                                                       UIBRKR   2541
            MISS = 'INPUT VALUE 2'                                      UIBRKR   2542
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2543
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2544
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2545
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2546
               WRITE(MSG(5),9902)                                       UIBRKR   2547
               CALL PRTMSG(5)                                           UIBRKR   2548
            IERCNT = IERCNT + 1                                         UIBRKR   2549
         ELSE                                                           UIBRKR   2550
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2551
               VALUE2 = UDVAL(IUDINT(NEXTI))                            UIBRKR   2552
            ELSE                                                        UIBRKR   2553
               VALUE2 = UDPARM(NEXTP)                                   UIBRKR   2554
            END IF                                                      UIBRKR   2555
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2556
            LASTP = NEXTP                                               UIBRKR   2557
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2558
         END IF                                                         UIBRKR   2559
C                                                                       UIBRKR   2560
         IF (J .NE. 2) THEN                                             UIBRKR   2561
C                                                                       UIBRKR   2562
C           No logical expression was stored.                           UIBRKR   2563
C                                                                       UIBRKR   2564
            MISS = 'LOGIC EXPRESSION'                                   UIBRKR   2565
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2566
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2567
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2568
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2569
               WRITE(MSG(5),9902)                                       UIBRKR   2570
               CALL PRTMSG(5)                                           UIBRKR   2571
            IERCNT = IERCNT + 1                                         UIBRKR   2572
         END IF                                                         UIBRKR   2573
         SET = LOGEXP(1)                                                UIBRKR   2574
         RESET= LOGEXP(2)                                               UIBRKR   2575
         UDVAL(JBLK) = VALUE2                                           UIBRKR   2576
         IF (SET) UDVAL(JBLK) = VALUE1                                  UIBRKR   2577
C                                                                       UIBRKR   2578
C     Status is 1 if last true was SET, 2 if RESET                      UIBRKR   2579
C                                                                       UIBRKR   2580
C     Set up storage for logic, status                                  UIBRKR   2581
C                                                                       UIBRKR   2582
         IF (IUDSPT(JBLK) .EQ. 0) THEN                                  UIBRKR   2583
C                                                                       UIBRKR   2584
C           Create the save list                                        UIBRKR   2585
C                                                                       UIBRKR   2586
            IADDS = IUDSFR                                              UIBRKR   2587
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2588
            IUDSPT(JBLK) = IADDS                                        UIBRKR   2589
            UDOLD(IADDS) = 0.0                                          UIBRKR   2590
            IF (SET) UDOLD(IADDS) = 1.0                                 UIBRKR   2591
            LASTS = IADDS                                               UIBRKR   2592
C                                                                       UIBRKR   2593
            IADDS = IUDSFR                                              UIBRKR   2594
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2595
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2596
            UDOLD(IADDS) = 0.0                                          UIBRKR   2597
            IF (RESET) UDOLD(IADDS) = 1.0                               UIBRKR   2598
            LASTS = IADDS                                               UIBRKR   2599
C                                                                       UIBRKR   2600
            IADDS = IUDSFR                                              UIBRKR   2601
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2602
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2603
            UDOLD(IADDS) = 2.0                                          UIBRKR   2604
            IF (SET) UDOLD(IADDS) = 1.0                                 UIBRKR   2605
            IUDSNX(IADDS) = 0                                           UIBRKR   2606
         ELSE                                                           UIBRKR   2607
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   2608
            UDOLD(NEXTS) = 0.0                                          UIBRKR   2609
            IF (SET) UDOLD(NEXTS) = 1.0                                 UIBRKR   2610
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2611
            UDOLD(NEXTS) = 0.0                                          UIBRKR   2612
            IF (RESET) UDOLD(NEXTS) = 1.0                               UIBRKR   2613
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2614
            UDOLD(NEXTS) = 2.0                                          UIBRKR   2615
            IF (SET) UDOLD(NEXTS) = 1.0                                 UIBRKR   2616
         END IF                                                         UIBRKR   2617
                                                                        UIBRKR   2618
C                                                                       UIBRKR   2619
C     Retriggered Ramp function.                                        UIBRKR   2620
C                                                                       UIBRKR   2621
      ELSE IF (IUDSUB(JBLK) .EQ. IRAMPR) THEN                           UIBRKR   2622
C                                                                       UIBRKR   2623
C        Level 0 value.                                                 UIBRKR   2624
C                                                                       UIBRKR   2625
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2626
C                                                                       UIBRKR   2627
C           No input value was stored.                                  UIBRKR   2628
C                                                                       UIBRKR   2629
            MISS = 'LEVEL 0'                                            UIBRKR   2630
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2631
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2632
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2633
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2634
               WRITE(MSG(5),9902)                                       UIBRKR   2635
               CALL PRTMSG(5)                                           UIBRKR   2636
            IERCNT = IERCNT + 1                                         UIBRKR   2637
         ELSE                                                           UIBRKR   2638
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2639
               XLEV0 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2640
            ELSE                                                        UIBRKR   2641
               XLEV0 = UDPARM(NEXTP)                                    UIBRKR   2642
            END IF                                                      UIBRKR   2643
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2644
            LASTP = NEXTP                                               UIBRKR   2645
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2646
         END IF                                                         UIBRKR   2647
C                                                                       UIBRKR   2648
C        Level 1 value.                                                 UIBRKR   2649
C                                                                       UIBRKR   2650
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2651
C                                                                       UIBRKR   2652
C           No input value was stored.                                  UIBRKR   2653
C                                                                       UIBRKR   2654
            MISS = 'LEVEL 1'                                            UIBRKR   2655
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2656
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2657
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2658
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2659
               WRITE(MSG(5),9902)                                       UIBRKR   2660
               CALL PRTMSG(5)                                           UIBRKR   2661
            IERCNT = IERCNT + 1                                         UIBRKR   2662
         ELSE                                                           UIBRKR   2663
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2664
               XLEV1 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2665
            ELSE                                                        UIBRKR   2666
               XLEV1 = UDPARM(NEXTP)                                    UIBRKR   2667
            END IF                                                      UIBRKR   2668
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2669
            LASTP = NEXTP                                               UIBRKR   2670
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2671
         END IF                                                         UIBRKR   2672
C                                                                       UIBRKR   2673
C        Time 1 value.                                                  UIBRKR   2674
C                                                                       UIBRKR   2675
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2676
C                                                                       UIBRKR   2677
C           No input value was stored.                                  UIBRKR   2678
C                                                                       UIBRKR   2679
            MISS = 'TIME 1'                                             UIBRKR   2680
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2681
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2682
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2683
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2684
               WRITE(MSG(5),9902)                                       UIBRKR   2685
               CALL PRTMSG(5)                                           UIBRKR   2686
            IERCNT = IERCNT + 1                                         UIBRKR   2687
         ELSE                                                           UIBRKR   2688
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2689
               TIME1 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2690
            ELSE                                                        UIBRKR   2691
               TIME1 = UDPARM(NEXTP)                                    UIBRKR   2692
            END IF                                                      UIBRKR   2693
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2694
            LASTP = NEXTP                                               UIBRKR   2695
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2696
         END IF                                                         UIBRKR   2697
C                                                                       UIBRKR   2698
C        Level 2 value.                                                 UIBRKR   2699
C                                                                       UIBRKR   2700
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2701
C                                                                       UIBRKR   2702
C           No input value was stored.                                  UIBRKR   2703
C                                                                       UIBRKR   2704
            MISS = 'LEVEL 2'                                            UIBRKR   2705
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2706
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2707
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2708
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2709
               WRITE(MSG(5),9902)                                       UIBRKR   2710
               CALL PRTMSG(5)                                           UIBRKR   2711
            IERCNT = IERCNT + 1                                         UIBRKR   2712
         ELSE                                                           UIBRKR   2713
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2714
               XLEV2 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2715
            ELSE                                                        UIBRKR   2716
               XLEV2 = UDPARM(NEXTP)                                    UIBRKR   2717
            END IF                                                      UIBRKR   2718
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2719
            LASTP = NEXTP                                               UIBRKR   2720
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2721
         END IF                                                         UIBRKR   2722
C                                                                       UIBRKR   2723
C        Time 2 value.                                                  UIBRKR   2724
C                                                                       UIBRKR   2725
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2726
C                                                                       UIBRKR   2727
C           No input value was stored.                                  UIBRKR   2728
C                                                                       UIBRKR   2729
            MISS = 'TIME 2'                                             UIBRKR   2730
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2731
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2732
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2733
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2734
               WRITE(MSG(5),9902)                                       UIBRKR   2735
               CALL PRTMSG(5)                                           UIBRKR   2736
            IERCNT = IERCNT + 1                                         UIBRKR   2737
         ELSE                                                           UIBRKR   2738
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2739
               TIME2 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2740
            ELSE                                                        UIBRKR   2741
               TIME2 = UDPARM(NEXTP)                                    UIBRKR   2742
            END IF                                                      UIBRKR   2743
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2744
            LASTP = NEXTP                                               UIBRKR   2745
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2746
         END IF                                                         UIBRKR   2747
C                                                                       UIBRKR   2748
C        Level 3 value.                                                 UIBRKR   2749
C                                                                       UIBRKR   2750
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2751
C                                                                       UIBRKR   2752
C           No input value was stored.                                  UIBRKR   2753
C                                                                       UIBRKR   2754
            MISS = 'LEVEL 3'                                            UIBRKR   2755
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2756
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2757
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2758
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2759
               WRITE(MSG(5),9902)                                       UIBRKR   2760
               CALL PRTMSG(5)                                           UIBRKR   2761
            IERCNT = IERCNT + 1                                         UIBRKR   2762
         ELSE                                                           UIBRKR   2763
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2764
               XLEV3 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2765
            ELSE                                                        UIBRKR   2766
               XLEV3 = UDPARM(NEXTP)                                    UIBRKR   2767
            END IF                                                      UIBRKR   2768
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2769
            LASTP = NEXTP                                               UIBRKR   2770
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2771
         END IF                                                         UIBRKR   2772
C                                                                       UIBRKR   2773
C        Level 4 value.                                                 UIBRKR   2774
C                                                                       UIBRKR   2775
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2776
C                                                                       UIBRKR   2777
C           No input value was stored.                                  UIBRKR   2778
C                                                                       UIBRKR   2779
            MISS = 'LEVEL 4'                                            UIBRKR   2780
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2781
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2782
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2783
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2784
               WRITE(MSG(5),9902)                                       UIBRKR   2785
               CALL PRTMSG(5)                                           UIBRKR   2786
            IERCNT = IERCNT + 1                                         UIBRKR   2787
         ELSE                                                           UIBRKR   2788
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2789
               XLEV4 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2790
            ELSE                                                        UIBRKR   2791
               XLEV4 = UDPARM(NEXTP)                                    UIBRKR   2792
            END IF                                                      UIBRKR   2793
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2794
            LASTP = NEXTP                                               UIBRKR   2795
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2796
         END IF                                                         UIBRKR   2797
C                                                                       UIBRKR   2798
C        Time 4 value.                                                  UIBRKR   2799
C                                                                       UIBRKR   2800
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2801
C                                                                       UIBRKR   2802
C           No input value was stored.                                  UIBRKR   2803
C                                                                       UIBRKR   2804
            MISS = 'TIME 4'                                             UIBRKR   2805
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2806
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2807
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2808
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2809
               WRITE(MSG(5),9902)                                       UIBRKR   2810
               CALL PRTMSG(5)                                           UIBRKR   2811
            IERCNT = IERCNT + 1                                         UIBRKR   2812
         ELSE                                                           UIBRKR   2813
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2814
               TIME4 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2815
            ELSE                                                        UIBRKR   2816
               TIME4 = UDPARM(NEXTP)                                    UIBRKR   2817
            END IF                                                      UIBRKR   2818
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2819
            LASTP = NEXTP                                               UIBRKR   2820
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2821
         END IF                                                         UIBRKR   2822
C                                                                       UIBRKR   2823
C        Level 5 value.                                                 UIBRKR   2824
C                                                                       UIBRKR   2825
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2826
C                                                                       UIBRKR   2827
C           No input value was stored.                                  UIBRKR   2828
C                                                                       UIBRKR   2829
            MISS = 'LEVEL 5'                                            UIBRKR   2830
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2831
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2832
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2833
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2834
               WRITE(MSG(5),9902)                                       UIBRKR   2835
               CALL PRTMSG(5)                                           UIBRKR   2836
            IERCNT = IERCNT + 1                                         UIBRKR   2837
         ELSE                                                           UIBRKR   2838
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2839
               XLEV5 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2840
            ELSE                                                        UIBRKR   2841
               XLEV5 = UDPARM(NEXTP)                                    UIBRKR   2842
            END IF                                                      UIBRKR   2843
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2844
            LASTP = NEXTP                                               UIBRKR   2845
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2846
         END IF                                                         UIBRKR   2847
C                                                                       UIBRKR   2848
C        Time 5 value.                                                  UIBRKR   2849
C                                                                       UIBRKR   2850
         IF (NEXTI .EQ. 0 .OR. NEXTP .EQ. 0) THEN                       UIBRKR   2851
C                                                                       UIBRKR   2852
C           No input value was stored.                                  UIBRKR   2853
C                                                                       UIBRKR   2854
            MISS = 'TIME 5'                                             UIBRKR   2855
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2856
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2857
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2858
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2859
               WRITE(MSG(5),9902)                                       UIBRKR   2860
               CALL PRTMSG(5)                                           UIBRKR   2861
            IERCNT = IERCNT + 1                                         UIBRKR   2862
         ELSE                                                           UIBRKR   2863
            IF (UIDENT(NEXTI) .NE. ' ') THEN                            UIBRKR   2864
               TIME5 = UDVAL(IUDINT(NEXTI))                             UIBRKR   2865
            ELSE                                                        UIBRKR   2866
               TIME5 = UDPARM(NEXTP)                                    UIBRKR   2867
            END IF                                                      UIBRKR   2868
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   2869
            LASTP = NEXTP                                               UIBRKR   2870
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   2871
         END IF                                                         UIBRKR   2872
C                                                                       UIBRKR   2873
         IF (J .NE. 2) THEN                                             UIBRKR   2874
C                                                                       UIBRKR   2875
C           No logical expression was stored.                           UIBRKR   2876
C                                                                       UIBRKR   2877
            MISS = 'LOGIC EXPRESSION'                                   UIBRKR   2878
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   2879
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   2880
               WRITE(MSG(3),9103) MISS                                  UIBRKR   2881
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   2882
               WRITE(MSG(5),9902)                                       UIBRKR   2883
               CALL PRTMSG(5)                                           UIBRKR   2884
            IERCNT = IERCNT + 1                                         UIBRKR   2885
         ELSE                                                           UIBRKR   2886
            SET = LOGEXP(1)                                             UIBRKR   2887
            RESET = LOGEXP(2)                                           UIBRKR   2888
         END IF                                                         UIBRKR   2889
         UDVAL(JBLK) = XLEV0                                            UIBRKR   2890
         IF (SET) UDVAL(JBLK) = XLEV1                                   UIBRKR   2891
C                                                                       UIBRKR   2892
C     Set up storage for status, timer, levels and times                UIBRKR   2893
C                                                                       UIBRKR   2894
         IF (IUDSPT(JBLK) .EQ. 0) THEN                                  UIBRKR   2895
C                                                                       UIBRKR   2896
C           Create the save list, set slope and time value to zero.     UIBRKR   2897
C                                                                       UIBRKR   2898
            IADDS = IUDSFR                                              UIBRKR   2899
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2900
            IUDSPT(JBLK) = IADDS                                        UIBRKR   2901
            UDOLD(IADDS) = 0.0                                          UIBRKR   2902
            LASTS = IADDS                                               UIBRKR   2903
C                                                                       UIBRKR   2904
            IADDS = IUDSFR                                              UIBRKR   2905
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2906
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2907
            UDOLD(IADDS) = 0.0                                          UIBRKR   2908
            LASTS = IADDS                                               UIBRKR   2909
C                                                                       UIBRKR   2910
C                                                                       UIBRKR   2911
            IADDS = IUDSFR                                              UIBRKR   2912
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2913
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2914
            UDOLD(IADDS) = XLEV0                                        UIBRKR   2915
            LASTS = IADDS                                               UIBRKR   2916
C                                                                       UIBRKR   2917
            IADDS = IUDSFR                                              UIBRKR   2918
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2919
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2920
            UDOLD(IADDS) = XLEV1                                        UIBRKR   2921
            LASTS = IADDS                                               UIBRKR   2922
C                                                                       UIBRKR   2923
            IADDS = IUDSFR                                              UIBRKR   2924
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2925
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2926
            UDOLD(IADDS) = TIME1                                        UIBRKR   2927
            LASTS = IADDS                                               UIBRKR   2928
C                                                                       UIBRKR   2929
            IADDS = IUDSFR                                              UIBRKR   2930
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2931
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2932
            UDOLD(IADDS) = XLEV2                                        UIBRKR   2933
            LASTS = IADDS                                               UIBRKR   2934
C                                                                       UIBRKR   2935
            IADDS = IUDSFR                                              UIBRKR   2936
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2937
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2938
            UDOLD(IADDS) = TIME2                                        UIBRKR   2939
            LASTS = IADDS                                               UIBRKR   2940
C                                                                       UIBRKR   2941
            IADDS = IUDSFR                                              UIBRKR   2942
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2943
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2944
            UDOLD(IADDS) = XLEV3                                        UIBRKR   2945
            LASTS = IADDS                                               UIBRKR   2946
C                                                                       UIBRKR   2947
            IADDS = IUDSFR                                              UIBRKR   2948
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2949
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2950
            UDOLD(IADDS) = XLEV4                                        UIBRKR   2951
            LASTS = IADDS                                               UIBRKR   2952
C                                                                       UIBRKR   2953
            IADDS = IUDSFR                                              UIBRKR   2954
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2955
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2956
            UDOLD(IADDS) = TIME4                                        UIBRKR   2957
            LASTS = IADDS                                               UIBRKR   2958
C                                                                       UIBRKR   2959
            IADDS = IUDSFR                                              UIBRKR   2960
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2961
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2962
            UDOLD(IADDS) = XLEV5                                        UIBRKR   2963
            LASTS = IADDS                                               UIBRKR   2964
C                                                                       UIBRKR   2965
            IADDS = IUDSFR                                              UIBRKR   2966
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   2967
            IUDSNX(LASTS) = IADDS                                       UIBRKR   2968
            UDOLD(IADDS) = TIME5                                        UIBRKR   2969
            IUDSNX(IADDS) = 0                                           UIBRKR   2970
         ELSE                                                           UIBRKR   2971
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   2972
            UDOLD(NEXTS) = 0.0                                          UIBRKR   2973
            NEXTS = IUDSPT(JBLK)                                        UIBRKR   2974
            UDOLD(NEXTS) = 0.0                                          UIBRKR   2975
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2976
            UDOLD(NEXTS) = XLEV0                                        UIBRKR   2977
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2978
            UDOLD(NEXTS) = XLEV1                                        UIBRKR   2979
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2980
            UDOLD(NEXTS) = TIME1                                        UIBRKR   2981
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2982
            UDOLD(NEXTS) = XLEV2                                        UIBRKR   2983
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2984
            UDOLD(NEXTS) = TIME2                                        UIBRKR   2985
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2986
            UDOLD(NEXTS) = XLEV3                                        UIBRKR   2987
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2988
            UDOLD(NEXTS) = XLEV4                                        UIBRKR   2989
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2990
            UDOLD(NEXTS) = TIME4                                        UIBRKR   2991
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2992
            UDOLD(NEXTS) = XLEV5                                        UIBRKR   2993
            NEXTS = IUDSNX(NEXTS)                                       UIBRKR   2994
            UDOLD(NEXTS) = TIME5                                        UIBRKR   2995
         END IF                                                         UIBRKR   2996
C                                                                       UIBRKR   2997
C     Invalid subtype.                                                  UIBRKR   2998
C                                                                       UIBRKR   2999
      ELSE                                                              UIBRKR   3000
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3001
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3002
               WRITE(MSG(3),9104) BNAME(1:LEN)                          UIBRKR   3003
               WRITE(MSG(4),9105)                                       UIBRKR   3004
               WRITE(MSG(5),9902)                                       UIBRKR   3005
               CALL PRTMSG(5)                                           UIBRKR   3006
         IERCNT = IERCNT + 1                                            UIBRKR   3007
         UDVAL(JBLK) = 0.0                                              UIBRKR   3008
      END IF                                                            UIBRKR   3009
C                                                                       UIBRKR   3010
      RETURN                                                            UIBRKR   3011
C                                                                       UIBRKR   3012
C                                                                       UIBRKR   3013
C---------------------------------------------------------------------  UIBRKR   3014
C                                                                       UIBRKR   3015
      ENTRY UISETP (JBLK)                                               UIBRKR   3016
CD -------------------------------------------------------------------  UIBRKR   3017
CD                                                                      UIBRKR   3018
CD              *****     UISETP  ROUTINE   *****                       UIBRKR   3019
CD                                                                      UIBRKR   3020
CD -------------------------------------------------------------------  UIBRKR   3021
CD                                                                      UIBRKR   3022
CD       PURPOSE:  Performs the initialization of the udc type SETUP.   UIBRKR   3023
CD                                                                      UIBRKR   3024
CD -------------------------------------------------------------------  UIBRKR   3025
C                                                                       UIBRKR   3026
      IF(SDBG)THEN                                                      UIBRKR   3027
         SUBNAM = 'UISETP ROUTINE.'                                     UIBRKR   3028
      ELSE                                                              UIBRKR   3029
         SUBNAM = ' '                                                   UIBRKR   3030
      ENDIF                                                             UIBRKR   3031
      TNAME = TPNAME(ISETUP)                                            UIBRKR   3032
      BNAME = UDNAME(JBLK)                                              UIBRKR   3033
      LEN = IUDLEN(JBLK)                                                UIBRKR   3034
C                                                                       UIBRKR   3035
C                                                                       UIBRKR   3036
      NEXTI = IUNIPT(JBLK)                                              UIBRKR   3037
      NEXTP = IUDPPT(JBLK)                                              UIBRKR   3038
C                                                                       UIBRKR   3039
C                                                                       UIBRKR   3040
C     Subtype start.                                                    UIBRKR   3041
C                                                                       UIBRKR   3042
      IF(IUDSUB(JBLK).EQ.ISPSTR)THEN                                    UIBRKR   3043
C                                                                       UIBRKR   3044
C        This subtype should not be stored in the udc arrays.           UIBRKR   3045
C                                                                       UIBRKR   3046
         UDVAL(JBLK) = 0.0                                              UIBRKR   3047
         SNAME = SBSETP(ISPSTR)                                         UIBRKR   3048
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3049
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3050
               WRITE(MSG(3),9402) SNAME                                 UIBRKR   3051
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3052
               WRITE(MSG(5),9403) SNAME                                 UIBRKR   3053
               WRITE(MSG(6),9404)                                       UIBRKR   3054
               CALL PRTMSG(6)                                           UIBRKR   3055
         IERCNT = IERCNT + 1                                            UIBRKR   3056
C                                                                       UIBRKR   3057
C                                                                       UIBRKR   3058
C                                                                       UIBRKR   3059
C     Subtype value.                                                    UIBRKR   3060
C                                                                       UIBRKR   3061
      ELSEIF(IUDSUB(JBLK).EQ.ISPVAL)THEN                                UIBRKR   3062
C                                                                       UIBRKR   3063
C        Find the initial value.                                        UIBRKR   3064
C                                                                       UIBRKR   3065
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   3066
            MISS = 'INITIAL VALUE'                                      UIBRKR   3067
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3068
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3069
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3070
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3071
               WRITE(MSG(5),9902)                                       UIBRKR   3072
               CALL PRTMSG(5)                                           UIBRKR   3073
            IERCNT = IERCNT + 1                                         UIBRKR   3074
           UDVAL(JBLK) = 0.0                                            UIBRKR   3075
         ELSE                                                           UIBRKR   3076
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR   3077
               XINIT = UDPARM(NEXTP)                                    UIBRKR   3078
            ELSE                                                        UIBRKR   3079
               XINIT = UDVAL(IUDINT(NEXTI))                             UIBRKR   3080
            ENDIF                                                       UIBRKR   3081
            UDVAL(JBLK) = XINIT                                         UIBRKR   3082
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3083
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3084
         ENDIF                                                          UIBRKR   3085
C                                                                       UIBRKR   3086
C     Subtype offset.                                                   UIBRKR   3087
C                                                                       UIBRKR   3088
      ELSEIF(IUDSUB(JBLK).EQ.ISPOFF)THEN                                UIBRKR   3089
C                                                                       UIBRKR   3090
C        Find the initial value.                                        UIBRKR   3091
C                                                                       UIBRKR   3092
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   3093
            MISS = 'INITIAL VALUE'                                      UIBRKR   3094
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3095
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3096
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3097
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3098
               WRITE(MSG(5),9902)                                       UIBRKR   3099
               CALL PRTMSG(5)                                           UIBRKR   3100
            IERCNT = IERCNT + 1                                         UIBRKR   3101
            UDVAL(JBLK) = 0.0                                           UIBRKR   3102
         ELSE                                                           UIBRKR   3103
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR   3104
               XINIT = UDPARM(NEXTP)                                    UIBRKR   3105
            ELSE                                                        UIBRKR   3106
               XINIT = UDVAL(IUDINT(NEXTI))                             UIBRKR   3107
            ENDIF                                                       UIBRKR   3108
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3109
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3110
         ENDIF                                                          UIBRKR   3111
C                                                                       UIBRKR   3112
C        Find the input value.                                          UIBRKR   3113
C                                                                       UIBRKR   3114
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   3115
            MISS = 'INPUT VALUE'                                        UIBRKR   3116
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3117
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3118
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3119
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3120
               WRITE(MSG(5),9902)                                       UIBRKR   3121
               CALL PRTMSG(5)                                           UIBRKR   3122
            IERCNT = IERCNT + 1                                         UIBRKR   3123
            UDVAL(JBLK) = 0.0                                           UIBRKR   3124
         ELSE                                                           UIBRKR   3125
            INPUT1 = IUDINT(NEXTI)                                      UIBRKR   3126
            UDVAL(JBLK) = XINIT + UDVAL(INPUT1)                         UIBRKR   3127
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3128
         ENDIF                                                          UIBRKR   3129
C                                                                       UIBRKR   3130
C        Store initial offset for solution                              UIBRKR   3131
C                                                                       UIBRKR   3132
         NEXTS = IUDSPT(JBLK)                                           UIBRKR   3133
         IF(NEXTS.EQ.0)THEN                                             UIBRKR   3134
            NEXTS = IUDSFR                                              UIBRKR   3135
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   3136
            IUDSNX(NEXTS) = 0                                           UIBRKR   3137
            IUDSPT(JBLK) = NEXTS                                        UIBRKR   3138
         ENDIF                                                          UIBRKR   3139
         UDOLD(NEXTS) = XINIT                                           UIBRKR   3140
         LASTS = NEXTS                                                  UIBRKR   3141
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR   3142
C                                                                       UIBRKR   3143
C                                                                       UIBRKR   3144
C                                                                       UIBRKR   3145
C     Subtype integrator.                                               UIBRKR   3146
C                                                                       UIBRKR   3147
      ELSEIF(IUDSUB(JBLK).EQ.ISPINT)THEN                                UIBRKR   3148
C                                                                       UIBRKR   3149
C        Find the initial value.                                        UIBRKR   3150
C                                                                       UIBRKR   3151
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   3152
            MISS = 'INITIAL VALUE'                                      UIBRKR   3153
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3154
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3155
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3156
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3157
               WRITE(MSG(5),9902)                                       UIBRKR   3158
               CALL PRTMSG(5)                                           UIBRKR   3159
            IERCNT = IERCNT + 1                                         UIBRKR   3160
            UDVAL(JBLK) = 0.0                                           UIBRKR   3161
         ELSE                                                           UIBRKR   3162
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR   3163
               XINIT = UDPARM(NEXTP)                                    UIBRKR   3164
            ELSE                                                        UIBRKR   3165
               XINIT = UDVAL(IUDINT(NEXTI))                             UIBRKR   3166
            ENDIF                                                       UIBRKR   3167
            UDVAL(JBLK) = XINIT                                         UIBRKR   3168
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3169
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3170
         ENDIF                                                          UIBRKR   3171
C                                                                       UIBRKR   3172
C        Find the input value.                                          UIBRKR   3173
C                                                                       UIBRKR   3174
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   3175
            MISS = 'INPUT VALUE'                                        UIBRKR   3176
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3177
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3178
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3179
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3180
               WRITE(MSG(5),9902)                                       UIBRKR   3181
               CALL PRTMSG(5)                                           UIBRKR   3182
            IERCNT = IERCNT + 1                                         UIBRKR   3183
            VALUE = 0.0                                                 UIBRKR   3184
         ELSE                                                           UIBRKR   3185
            JBLOCK = IUDINT(NEXTI)                                      UIBRKR   3186
            VALUE = UDVAL(JBLOCK)                                       UIBRKR   3187
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3188
         ENDIF                                                          UIBRKR   3189
C                                                                       UIBRKR   3190
C        Find the gain value.                                           UIBRKR   3191
C                                                                       UIBRKR   3192
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   3193
            MISS = 'GAIN VALUE'                                         UIBRKR   3194
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3195
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3196
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3197
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3198
               WRITE(MSG(5),9902)                                       UIBRKR   3199
               CALL PRTMSG(5)                                           UIBRKR   3200
            IERCNT = IERCNT + 1                                         UIBRKR   3201
            GAIN = 1.0                                                  UIBRKR   3202
         ELSE                                                           UIBRKR   3203
            GAIN = UDPARM(NEXTP)                                        UIBRKR   3204
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3205
         ENDIF                                                          UIBRKR   3206
C                                                                       UIBRKR   3207
C        Store initial X and control                                    UIBRKR   3208
C                                                                       UIBRKR   3209
         NEXTS = IUDSPT(JBLK)                                           UIBRKR   3210
         IF(NEXTS.EQ.0)THEN                                             UIBRKR   3211
            NEXTS = IUDSFR                                              UIBRKR   3212
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   3213
            IUDSNX(NEXTS) = 0                                           UIBRKR   3214
            IUDSPT(JBLK) = NEXTS                                        UIBRKR   3215
         ENDIF                                                          UIBRKR   3216
         UDOLD(NEXTS) = XINIT                                           UIBRKR   3217
         LASTS = NEXTS                                                  UIBRKR   3218
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR   3219
C                                                                       UIBRKR   3220
         IF(NEXTS.EQ.0)THEN                                             UIBRKR   3221
            NEXTS = IUDSFR                                              UIBRKR   3222
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   3223
            IUDSNX(LASTS) = NEXTS                                       UIBRKR   3224
            IUDSNX(NEXTS) = 0                                           UIBRKR   3225
         ENDIF                                                          UIBRKR   3226
         UDOLD(NEXTS) = VALUE                                           UIBRKR   3227
         LASTS = NEXTS                                                  UIBRKR   3228
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR   3229
C                                                                       UIBRKR   3230
C                                                                       UIBRKR   3231
      ELSEIF(IUDSUB(JBLK).EQ.ISPLIN)THEN                                UIBRKR   3232
C                                                                       UIBRKR   3233
C        Find the initial value.                                        UIBRKR   3234
C                                                                       UIBRKR   3235
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   3236
            MISS = 'INITIAL VALUE'                                      UIBRKR   3237
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3238
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3239
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3240
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3241
               WRITE(MSG(5),9902)                                       UIBRKR   3242
               CALL PRTMSG(5)                                           UIBRKR   3243
            IERCNT = IERCNT + 1                                         UIBRKR   3244
            UDVAL(JBLK) = 0.0                                           UIBRKR   3245
         ELSE                                                           UIBRKR   3246
            IF(UIDENT(NEXTI).EQ.' ')THEN                                UIBRKR   3247
               XINIT = UDPARM(NEXTP)                                    UIBRKR   3248
            ELSE                                                        UIBRKR   3249
               XINIT = UDVAL(IUDINT(NEXTI))                             UIBRKR   3250
            ENDIF                                                       UIBRKR   3251
            UDVAL(JBLK) = XINIT                                         UIBRKR   3252
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3253
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3254
         ENDIF                                                          UIBRKR   3255
C                                                                       UIBRKR   3256
C        Find the input value.                                          UIBRKR   3257
C                                                                       UIBRKR   3258
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   3259
            MISS = 'INPUT VALUE'                                        UIBRKR   3260
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3261
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3262
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3263
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3264
               WRITE(MSG(5),9902)                                       UIBRKR   3265
               CALL PRTMSG(5)                                           UIBRKR   3266
            IERCNT = IERCNT + 1                                         UIBRKR   3267
            VALUE = 0.0                                                 UIBRKR   3268
         ELSE                                                           UIBRKR   3269
            JBLOCK = IUDINT(NEXTI)                                      UIBRKR   3270
            VALUE = UDVAL(JBLOCK)                                       UIBRKR   3271
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3272
         ENDIF                                                          UIBRKR   3273
C                                                                       UIBRKR   3274
C        Find the gain value.                                           UIBRKR   3275
C                                                                       UIBRKR   3276
         IF(NEXTP.EQ.0)THEN                                             UIBRKR   3277
            MISS = 'GAIN VALUE'                                         UIBRKR   3278
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3279
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3280
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3281
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3282
               WRITE(MSG(5),9902)                                       UIBRKR   3283
               CALL PRTMSG(5)                                           UIBRKR   3284
            IERCNT = IERCNT + 1                                         UIBRKR   3285
            GAIN = 1.0                                                  UIBRKR   3286
         ELSE                                                           UIBRKR   3287
            GAIN = UDPARM(NEXTP)                                        UIBRKR   3288
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3289
         ENDIF                                                          UIBRKR   3290
C                                                                       UIBRKR   3291
C        Find the low limit.                                            UIBRKR   3292
C                                                                       UIBRKR   3293
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   3294
            MISS = 'LOW LIMIT'                                          UIBRKR   3295
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3296
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3297
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3298
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3299
               WRITE(MSG(5),9902)                                       UIBRKR   3300
               CALL PRTMSG(5)                                           UIBRKR   3301
            IERCNT = IERCNT + 1                                         UIBRKR   3302
            XLOW = 0.0                                                  UIBRKR   3303
         ELSE                                                           UIBRKR   3304
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   3305
               JBLOCK = IUDINT(NEXTI)                                   UIBRKR   3306
               XLOW = UDVAL(JBLOCK)                                     UIBRKR   3307
            ELSE                                                        UIBRKR   3308
               XLOW = UDPARM(NEXTP)                                     UIBRKR   3309
            ENDIF                                                       UIBRKR   3310
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3311
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3312
         ENDIF                                                          UIBRKR   3313
C                                                                       UIBRKR   3314
C        Find the high limit.                                           UIBRKR   3315
C                                                                       UIBRKR   3316
         IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                             UIBRKR   3317
            MISS = 'HIGH LIMIT'                                         UIBRKR   3318
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3319
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3320
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3321
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3322
               WRITE(MSG(5),9902)                                       UIBRKR   3323
               CALL PRTMSG(5)                                           UIBRKR   3324
            IERCNT = IERCNT + 1                                         UIBRKR   3325
            HI = 0.0                                                    UIBRKR   3326
         ELSE                                                           UIBRKR   3327
            IF(UIDENT(NEXTI) .NE. ' ')THEN                              UIBRKR   3328
               JBLOCK = IUDINT(NEXTI)                                   UIBRKR   3329
               HI = UDVAL(JBLOCK)                                       UIBRKR   3330
            ELSE                                                        UIBRKR   3331
               HI = UDPARM(NEXTP)                                       UIBRKR   3332
            ENDIF                                                       UIBRKR   3333
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3334
            NEXTP = IUDPNX(NEXTP)                                       UIBRKR   3335
         ENDIF                                                          UIBRKR   3336
C                                                                       UIBRKR   3337
C        Set initial state.                                             UIBRKR   3338
C                                                                       UIBRKR   3339
         IF(UDVAL(JBLK) .GT. HI)  UDVAL(JBLK) = HI                      UIBRKR   3340
         IF(UDVAL(JBLK) .LT. XLOW) UDVAL(JBLK) = XLOW                   UIBRKR   3341
C                                                                       UIBRKR   3342
C        Store initial state and control.                               UIBRKR   3343
C                                                                       UIBRKR   3344
         NEXTS = IUDSPT(JBLK)                                           UIBRKR   3345
         IF(NEXTS.EQ.0)THEN                                             UIBRKR   3346
            NEXTS = IUDSFR                                              UIBRKR   3347
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   3348
            IUDSNX(NEXTS) = 0                                           UIBRKR   3349
            IUDSPT(JBLK) = NEXTS                                        UIBRKR   3350
         ENDIF                                                          UIBRKR   3351
         UDOLD(NEXTS) = UDVAL(JBLK)                                     UIBRKR   3352
         LASTS = NEXTS                                                  UIBRKR   3353
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR   3354
C                                                                       UIBRKR   3355
         IF(NEXTS.EQ.0)THEN                                             UIBRKR   3356
            NEXTS = IUDSFR                                              UIBRKR   3357
            IUDSFR = IUDSNX(IUDSFR)                                     UIBRKR   3358
            IUDSNX(LASTS) = NEXTS                                       UIBRKR   3359
            IUDSNX(NEXTS) = 0                                           UIBRKR   3360
         ENDIF                                                          UIBRKR   3361
         UDOLD(NEXTS) = VALUE                                           UIBRKR   3362
         LASTS = NEXTS                                                  UIBRKR   3363
         NEXTS = IUDSNX(NEXTS)                                          UIBRKR   3364
C                                                                       UIBRKR   3365
C                                                                       UIBRKR   3366
C                                                                       UIBRKR   3367
      ELSE                                                              UIBRKR   3368
C                                                                       UIBRKR   3369
C        Invalid subtype.                                               UIBRKR   3370
C                                                                       UIBRKR   3371
         UDVAL(JBLK) = 0.0                                              UIBRKR   3372
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3373
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3374
               WRITE(MSG(3),9104) BNAME(1:LEN)                          UIBRKR   3375
               WRITE(MSG(4),9105)                                       UIBRKR   3376
               WRITE(MSG(5),9902)                                       UIBRKR   3377
               CALL PRTMSG(5)                                           UIBRKR   3378
         IERCNT = IERCNT + 1                                            UIBRKR   3379
      ENDIF                                                             UIBRKR   3380
C                                                                       UIBRKR   3381
      RETURN                                                            UIBRKR   3382
C                                                                       UIBRKR   3383
C                                                                       UIBRKR   3384
C---------------------------------------------------------------------  UIBRKR   3385
C                                                                       UIBRKR   3386
      ENTRY UISUBS (JBLK, OK)                                           UIBRKR   3387
CD -------------------------------------------------------------------  UIBRKR   3388
CD                                                                      UIBRKR   3389
CD              *****     UISUBS  ROUTINE   *****                       UIBRKR   3390
CD                                                                      UIBRKR   3391
CD -------------------------------------------------------------------  UIBRKR   3392
CD                                                                      UIBRKR   3393
CD       PURPOSE:  Performs the initialization of the udc type          UIBRKR   3394
CD                 SUBSYSTEM.                                           UIBRKR   3395
CD                                                                      UIBRKR   3396
CD -------------------------------------------------------------------  UIBRKR   3397
C                                                                       UIBRKR   3398
      IF(SDBG)THEN                                                      UIBRKR   3399
         SUBNAM = 'UISUBS ROUTINE.'                                     UIBRKR   3400
      ELSE                                                              UIBRKR   3401
         SUBNAM = ' '                                                   UIBRKR   3402
      END IF                                                            UIBRKR   3403
      TNAME = TPNAME(ISUBSY)                                            UIBRKR   3404
      BNAME = UDNAME(JBLK)                                              UIBRKR   3405
      LEN = IUDLEN(JBLK)                                                UIBRKR   3406
C                                                                       UIBRKR   3407
C     Subtype break.                                                    UIBRKR   3408
C                                                                       UIBRKR   3409
      IF(IUDSUB(JBLK).EQ.ISBRKS)THEN                                    UIBRKR   3410
         NEXTI = IUNIPT(JBLK)                                           UIBRKR   3411
         NEXTP = IUDPPT(JBLK)                                           UIBRKR   3412
C                                                                       UIBRKR   3413
C        Find the input block.                                          UIBRKR   3414
C                                                                       UIBRKR   3415
         IF(NEXTI.EQ.0)THEN                                             UIBRKR   3416
            MISS = 'INPUT BLOCK'                                        UIBRKR   3417
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3418
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3419
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3420
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3421
               WRITE(MSG(5),9902)                                       UIBRKR   3422
               CALL PRTMSG(5)                                           UIBRKR   3423
            IERCNT = IERCNT + 1                                         UIBRKR   3424
            OK = .FALSE.                                                UIBRKR   3425
            SKCALC(ISKTOP) = 0.0                                        UIBRKR   3426
         ELSE                                                           UIBRKR   3427
            SKCALC(ISKTOP) = UDVAL(IUDINT(NEXTI))                       UIBRKR   3428
            OK = .TRUE.                                                 UIBRKR   3429
            NEXTI = IUDINX(NEXTI)                                       UIBRKR   3430
         END IF                                                         UIBRKR   3431
C                                                                       UIBRKR   3432
         UDVAL(JBLK) = SKCALC(ISKTOP)                                   UIBRKR   3433
C                                                                       UIBRKR   3434
C        Find the expected value.                                       UIBRKR   3435
C                                                                       UIBRKR   3436
         IF(NEXTP.EQ.0 .OR. NEXTI.EQ.0)THEN                             UIBRKR   3437
            MISS = 'EXPECTED VALUE'                                     UIBRKR   3438
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3439
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3440
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3441
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3442
               WRITE(MSG(5),9902)                                       UIBRKR   3443
               CALL PRTMSG(5)                                           UIBRKR   3444
            IERCNT = IERCNT + 1                                         UIBRKR   3445
         ELSE                                                           UIBRKR   3446
            IF(IUDINT(NEXTI).EQ.0)THEN                                  UIBRKR   3447
               SKDESR(ISKTOP) = UDPARM(NEXTP)                           UIBRKR   3448
            ELSE                                                        UIBRKR   3449
               SKDESR(ISKTOP) = UDVAL(IUDINT(NEXTI))                    UIBRKR   3450
            END IF                                                      UIBRKR   3451
         END IF                                                         UIBRKR   3452
C                                                                       UIBRKR   3453
      ELSE                                                              UIBRKR   3454
C                                                                       UIBRKR   3455
C        Check if limits are given for this block.                      UIBRKR   3456
C                                                                       UIBRKR   3457
         IF(SKHIGH(ISKTOP).EQ.0.0.AND.SKLOW(ISKTOP).EQ.0.0)THEN         UIBRKR   3458
            LIMITS = .FALSE.                                            UIBRKR   3459
         ELSE                                                           UIBRKR   3460
            LIMITS = .TRUE.                                             UIBRKR   3461
         END IF                                                         UIBRKR   3462
C                                                                       UIBRKR   3463
         OK = .FALSE.                                                   UIBRKR   3464
C                                                                       UIBRKR   3465
         IF(ISKSTR(ISKTOP) .NE. JBLK)THEN                               UIBRKR   3466
C                                                                       UIBRKR   3467
C           This block should be the starting block on the top of the   UIBRKR   3468
C           stack.                                                      UIBRKR   3469
C                                                                       UIBRKR   3470
            UDVAL(JBLK) = 0.0                                           UIBRKR   3471
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3472
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3473
               WRITE(MSG(3),9504)                                       UIBRKR   3474
               WRITE(MSG(4),9505) TNAME                                 UIBRKR   3475
               WRITE(MSG(5),9506)                                       UIBRKR   3476
               CALL PRTMSG(5)                                           UIBRKR   3477
            IERCNT = IERCNT + 1                                         UIBRKR   3478
C                                                                       UIBRKR   3479
         ELSE                                                           UIBRKR   3480
C                                                                       UIBRKR   3481
C                                                                       UIBRKR   3482
            NEXTI = IUNIPT(JBLK)                                        UIBRKR   3483
            NEXTP = IUDPPT(JBLK)                                        UIBRKR   3484
C                                                                       UIBRKR   3485
C                                                                       UIBRKR   3486
C           Subtype value.                                              UIBRKR   3487
C                                                                       UIBRKR   3488
            IF(IUDSUB(JBLK).EQ.ISSVAL)THEN                              UIBRKR   3489
C                                                                       UIBRKR   3490
C              Find the initial value.                                  UIBRKR   3491
C                                                                       UIBRKR   3492
               IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                       UIBRKR   3493
                  MISS = 'INITIAL VALUE'                                UIBRKR   3494
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3495
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3496
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3497
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3498
               WRITE(MSG(5),9902)                                       UIBRKR   3499
               CALL PRTMSG(5)                                           UIBRKR   3500
                  IERCNT = IERCNT + 1                                   UIBRKR   3501
               END IF                                                   UIBRKR   3502
C                                                                       UIBRKR   3503
C             Calculate the output value.                               UIBRKR   3504
C                                                                       UIBRKR   3505
               OK = .TRUE.                                              UIBRKR   3506
               IF(ISKCNT(ISKTOP) .LT. 1)THEN                            UIBRKR   3507
                  UDVAL(JBLK) = SKINIT(ISKTOP)                          UIBRKR   3508
               ELSE                                                     UIBRKR   3509
                  UDVAL(JBLK) = SKINIT(ISKTOP) + SKINCR(ISKTOP)         UIBRKR   3510
               END IF                                                   UIBRKR   3511
C                                                                       UIBRKR   3512
C              Check that the answer is within limits.                  UIBRKR   3513
C                                                                       UIBRKR   3514
               IF(LIMITS)THEN                                           UIBRKR   3515
                  IF(UDVAL(JBLK) .GT. SKHIGH(ISKTOP))THEN               UIBRKR   3516
                     UDVAL(JBLK) = SKHIGH(ISKTOP)                       UIBRKR   3517
                  ELSEIF(UDVAL(JBLK) .LT. SKLOW(ISKTOP))THEN            UIBRKR   3518
                     UDVAL(JBLK) = SKLOW(ISKTOP)                        UIBRKR   3519
                  END IF                                                UIBRKR   3520
               END IF                                                   UIBRKR   3521
C                                                                       UIBRKR   3522
C           Subtype offset.                                             UIBRKR   3523
C                                                                       UIBRKR   3524
            ELSEIF(IUDSUB(JBLK).EQ.ISSOFS)THEN                          UIBRKR   3525
C                                                                       UIBRKR   3526
               OK = .TRUE.                                              UIBRKR   3527
C                                                                       UIBRKR   3528
C              Find the initial value.                                  UIBRKR   3529
C                                                                       UIBRKR   3530
               IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                       UIBRKR   3531
                  MISS = 'INITIAL VALUE'                                UIBRKR   3532
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3533
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3534
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3535
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3536
               WRITE(MSG(5),9902)                                       UIBRKR   3537
               CALL PRTMSG(5)                                           UIBRKR   3538
                  IERCNT = IERCNT + 1                                   UIBRKR   3539
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3540
               ELSE                                                     UIBRKR   3541
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3542
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   3543
               END IF                                                   UIBRKR   3544
C                                                                       UIBRKR   3545
C              Find the input block.                                    UIBRKR   3546
C                                                                       UIBRKR   3547
               IF(NEXTI.EQ.0)THEN                                       UIBRKR   3548
                  MISS = 'INPUT BLOCK'                                  UIBRKR   3549
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3550
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3551
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3552
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3553
               WRITE(MSG(5),9902)                                       UIBRKR   3554
               CALL PRTMSG(5)                                           UIBRKR   3555
                  IERCNT = IERCNT + 1                                   UIBRKR   3556
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3557
                  X = 0.0                                               UIBRKR   3558
               ELSE                                                     UIBRKR   3559
                  X = UDVAL(IUDINT(NEXTI))                              UIBRKR   3560
C                                                                       UIBRKR   3561
                  IF(ISKCNT(ISKTOP) .LT. 1)THEN                         UIBRKR   3562
                     UDVAL(JBLK) = SKINIT(ISKTOP) + X                   UIBRKR   3563
                  ELSE                                                  UIBRKR   3564
                     UDVAL(JBLK) = SKINIT(ISKTOP) + SKINCR(ISKTOP) + X  UIBRKR   3565
                  END IF                                                UIBRKR   3566
                  IF(LIMITS)THEN                                        UIBRKR   3567
                     IF(UDVAL(JBLK) .GT. SKHIGH(ISKTOP))THEN            UIBRKR   3568
                        UDVAL(JBLK) = SKHIGH(ISKTOP)                    UIBRKR   3569
                     ELSEIF(UDVAL(JBLK) .LT. SKLOW(ISKTOP))THEN         UIBRKR   3570
                        UDVAL(JBLK) = SKLOW(ISKTOP)                     UIBRKR   3571
                     END IF                                             UIBRKR   3572
                  END IF                                                UIBRKR   3573
C                                                                       UIBRKR   3574
C                 Store initial value (Required for solution).          UIBRKR   3575
C                                                                       UIBRKR   3576
                  NEXTS = IUDSPT(JBLK)                                  UIBRKR   3577
                  IF(NEXTS.EQ.0)THEN                                    UIBRKR   3578
                     NEXTS = IUDSFR                                     UIBRKR   3579
                     IUDSFR = IUDSNX(IUDSFR)                            UIBRKR   3580
                     IUDSNX(NEXTS) = 0                                  UIBRKR   3581
                     IUDSPT(JBLK) = NEXTS                               UIBRKR   3582
                  END IF                                                UIBRKR   3583
                  UDOLD(NEXTS) = UDVAL(JBLK) - X                        UIBRKR   3584
                  LASTS = NEXTS                                         UIBRKR   3585
                  NEXTS = IUDSNX(NEXTS)                                 UIBRKR   3586
               END IF                                                   UIBRKR   3587
C                                                                       UIBRKR   3588
C                                                                       UIBRKR   3589
C           Subtype integrator.                                         UIBRKR   3590
C                                                                       UIBRKR   3591
            ELSEIF(IUDSUB(JBLK).EQ.ISINTS)THEN                          UIBRKR   3592
               OK = .TRUE.                                              UIBRKR   3593
C                                                                       UIBRKR   3594
C              Find the initial value.                                  UIBRKR   3595
C                                                                       UIBRKR   3596
               IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                       UIBRKR   3597
                  MISS = 'INITIAL VALUE'                                UIBRKR   3598
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3599
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3600
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3601
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3602
               WRITE(MSG(5),9902)                                       UIBRKR   3603
               CALL PRTMSG(5)                                           UIBRKR   3604
                  IERCNT = IERCNT + 1                                   UIBRKR   3605
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3606
               ELSE                                                     UIBRKR   3607
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3608
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   3609
               END IF                                                   UIBRKR   3610
C                                                                       UIBRKR   3611
C              Find the input block.                                    UIBRKR   3612
C                                                                       UIBRKR   3613
               IF(NEXTI.EQ.0)THEN                                       UIBRKR   3614
                  MISS = 'INPUT BLOCK'                                  UIBRKR   3615
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3616
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3617
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3618
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3619
               WRITE(MSG(5),9902)                                       UIBRKR   3620
               CALL PRTMSG(5)                                           UIBRKR   3621
                  IERCNT = IERCNT + 1                                   UIBRKR   3622
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3623
                  X = 0.0                                               UIBRKR   3624
               ELSE                                                     UIBRKR   3625
                  X = UDVAL(IUDINT(NEXTI))                              UIBRKR   3626
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3627
               END IF                                                   UIBRKR   3628
C                                                                       UIBRKR   3629
C              Find the gain value.                                     UIBRKR   3630
C                                                                       UIBRKR   3631
               IF(NEXTP.EQ.0)THEN                                       UIBRKR   3632
                  MISS = 'GAIN VALUE'                                   UIBRKR   3633
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3634
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3635
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3636
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3637
               WRITE(MSG(5),9902)                                       UIBRKR   3638
               CALL PRTMSG(5)                                           UIBRKR   3639
                  IERCNT = IERCNT + 1                                   UIBRKR   3640
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3641
               END IF                                                   UIBRKR   3642
C                                                                       UIBRKR   3643
C                                                                       UIBRKR   3644
C                                                                       UIBRKR   3645
               IF(ISKCNT(ISKTOP) .LT. 1)THEN                            UIBRKR   3646
                  UDVAL(JBLK) = SKINIT(ISKTOP)                          UIBRKR   3647
               ELSE                                                     UIBRKR   3648
                  UDVAL(JBLK) = SKINIT(ISKTOP) + SKINCR(ISKTOP)         UIBRKR   3649
               END IF                                                   UIBRKR   3650
               IF(LIMITS)THEN                                           UIBRKR   3651
                  IF(UDVAL(JBLK) .GT. SKHIGH(ISKTOP))THEN               UIBRKR   3652
                     UDVAL(JBLK) = SKHIGH(ISKTOP)                       UIBRKR   3653
                  ELSEIF(UDVAL(JBLK) .LT. SKLOW(ISKTOP))THEN            UIBRKR   3654
                     UDVAL(JBLK) = SKLOW(ISKTOP)                        UIBRKR   3655
                  END IF                                                UIBRKR   3656
               END IF                                                   UIBRKR   3657
C                                                                       UIBRKR   3658
C           Store initial X and control.                                UIBRKR   3659
C                                                                       UIBRKR   3660
               NEXTS = IUDSPT(JBLK)                                     UIBRKR   3661
               IF(NEXTS.EQ.0)THEN                                       UIBRKR   3662
                  NEXTS = IUDSFR                                        UIBRKR   3663
                  IUDSFR = IUDSNX(IUDSFR)                               UIBRKR   3664
                  IUDSNX(NEXTS) = 0                                     UIBRKR   3665
                  IUDSPT(JBLK) = NEXTS                                  UIBRKR   3666
               END IF                                                   UIBRKR   3667
               UDOLD(NEXTS) = SKINIT(ISKTOP) + SKINCR(ISKTOP)           UIBRKR   3668
               LASTS = NEXTS                                            UIBRKR   3669
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   3670
C                                                                       UIBRKR   3671
               IF(NEXTS.EQ.0)THEN                                       UIBRKR   3672
                  NEXTS = IUDSFR                                        UIBRKR   3673
                  IUDSFR = IUDSNX(IUDSFR)                               UIBRKR   3674
                  IUDSNX(LASTS) = NEXTS                                 UIBRKR   3675
                  IUDSNX(NEXTS) = 0                                     UIBRKR   3676
               END IF                                                   UIBRKR   3677
               UDOLD(NEXTS) = X                                         UIBRKR   3678
               LASTS = NEXTS                                            UIBRKR   3679
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   3680
C                                                                       UIBRKR   3681
C                                                                       UIBRKR   3682
C                                                                       UIBRKR   3683
C           Subtype limited integrator.                                 UIBRKR   3684
C                                                                       UIBRKR   3685
            ELSEIF(IUDSUB(JBLK).EQ.ISLINS)THEN                          UIBRKR   3686
               OK = .TRUE.                                              UIBRKR   3687
C                                                                       UIBRKR   3688
C              Find the initial value.                                  UIBRKR   3689
C                                                                       UIBRKR   3690
               IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                       UIBRKR   3691
                  MISS = 'INITIAL VALUE'                                UIBRKR   3692
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3693
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3694
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3695
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3696
               WRITE(MSG(5),9902)                                       UIBRKR   3697
               CALL PRTMSG(5)                                           UIBRKR   3698
                  IERCNT = IERCNT + 1                                   UIBRKR   3699
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3700
               ELSE                                                     UIBRKR   3701
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3702
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   3703
               END IF                                                   UIBRKR   3704
C                                                                       UIBRKR   3705
C              Find the input value.                                    UIBRKR   3706
C                                                                       UIBRKR   3707
               IF(NEXTI.EQ.0)THEN                                       UIBRKR   3708
                  MISS = 'INPUT VALUE'                                  UIBRKR   3709
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3710
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3711
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3712
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3713
               WRITE(MSG(5),9902)                                       UIBRKR   3714
               CALL PRTMSG(5)                                           UIBRKR   3715
                  IERCNT = IERCNT + 1                                   UIBRKR   3716
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3717
                  X = 0.0                                               UIBRKR   3718
               ELSE                                                     UIBRKR   3719
                  X = UDVAL(IUDINT(NEXTI))                              UIBRKR   3720
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3721
               END IF                                                   UIBRKR   3722
C                                                                       UIBRKR   3723
C              Find the gain value.                                     UIBRKR   3724
C                                                                       UIBRKR   3725
               IF(NEXTP.EQ.0)THEN                                       UIBRKR   3726
                  MISS = 'GAIN VALUE'                                   UIBRKR   3727
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3728
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3729
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3730
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3731
               WRITE(MSG(5),9902)                                       UIBRKR   3732
               CALL PRTMSG(5)                                           UIBRKR   3733
                  IERCNT = IERCNT + 1                                   UIBRKR   3734
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3735
               ELSE                                                     UIBRKR   3736
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   3737
               END IF                                                   UIBRKR   3738
C                                                                       UIBRKR   3739
C                                                                       UIBRKR   3740
C              Find the low limit for the integrator.                   UIBRKR   3741
C                                                                       UIBRKR   3742
               IF(NEXTP.EQ.0 .OR. NEXTI.EQ.0)THEN                       UIBRKR   3743
                  MISS = 'LIMITED LOW'                                  UIBRKR   3744
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3745
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3746
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3747
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3748
               WRITE(MSG(5),9902)                                       UIBRKR   3749
               CALL PRTMSG(5)                                           UIBRKR   3750
                  IERCNT = IERCNT + 1                                   UIBRKR   3751
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3752
               ELSE                                                     UIBRKR   3753
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   3754
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3755
               END IF                                                   UIBRKR   3756
C                                                                       UIBRKR   3757
C                                                                       UIBRKR   3758
C              Find the high limit for the integrator.                  UIBRKR   3759
C                                                                       UIBRKR   3760
               IF(NEXTP.EQ.0 .OR. NEXTI.EQ.0)THEN                       UIBRKR   3761
                  MISS = 'LIMITED HIGH'                                 UIBRKR   3762
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3763
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3764
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3765
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3766
               WRITE(MSG(5),9902)                                       UIBRKR   3767
               CALL PRTMSG(5)                                           UIBRKR   3768
                  IERCNT = IERCNT + 1                                   UIBRKR   3769
                  UDVAL(JBLK) = 0.0                                     UIBRKR   3770
               ELSE                                                     UIBRKR   3771
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   3772
                  NEXTI = IUDINX(NEXTI)                                 UIBRKR   3773
               END IF                                                   UIBRKR   3774
C                                                                       UIBRKR   3775
               IF(ISKCNT(ISKTOP) .LT. 1)THEN                            UIBRKR   3776
                  UDVAL(JBLK) = SKINIT(ISKTOP)                          UIBRKR   3777
               ELSE                                                     UIBRKR   3778
                  UDVAL(JBLK) = SKINIT(ISKTOP) + SKINCR(ISKTOP)         UIBRKR   3779
               END IF                                                   UIBRKR   3780
               IF(LIMITS)THEN                                           UIBRKR   3781
                  IF(UDVAL(JBLK) .GT. SKHIGH(ISKTOP))THEN               UIBRKR   3782
                     UDVAL(JBLK) = SKHIGH(ISKTOP)                       UIBRKR   3783
                  ELSEIF(UDVAL(JBLK) .LT. SKLOW(ISKTOP))THEN            UIBRKR   3784
                     UDVAL(JBLK) = SKLOW(ISKTOP)                        UIBRKR   3785
                  END IF                                                UIBRKR   3786
               END IF                                                   UIBRKR   3787
C                                                                       UIBRKR   3788
C              Store initial X and control                              UIBRKR   3789
C                                                                       UIBRKR   3790
               NEXTS = IUDSPT(JBLK)                                     UIBRKR   3791
               IF(NEXTS.EQ.0)THEN                                       UIBRKR   3792
                  NEXTS = IUDSFR                                        UIBRKR   3793
                  IUDSFR = IUDSNX(IUDSFR)                               UIBRKR   3794
                  IUDSNX(NEXTS) = 0                                     UIBRKR   3795
                  IUDSPT(JBLK) = NEXTS                                  UIBRKR   3796
               END IF                                                   UIBRKR   3797
               UDOLD(NEXTS) = SKINIT(ISKTOP) + SKINCR(ISKTOP)           UIBRKR   3798
               LASTS = NEXTS                                            UIBRKR   3799
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   3800
C                                                                       UIBRKR   3801
               IF(NEXTS.EQ.0)THEN                                       UIBRKR   3802
                  NEXTS = IUDSFR                                        UIBRKR   3803
                  IUDSFR = IUDSNX(IUDSFR)                               UIBRKR   3804
                  IUDSNX(LASTS) = NEXTS                                 UIBRKR   3805
                  IUDSNX(NEXTS) = 0                                     UIBRKR   3806
               END IF                                                   UIBRKR   3807
               UDOLD(NEXTS) = X                                         UIBRKR   3808
               LASTS = NEXTS                                            UIBRKR   3809
               NEXTS = IUDSNX(NEXTS)                                    UIBRKR   3810
C                                                                       UIBRKR   3811
C                                                                       UIBRKR   3812
            ELSE                                                        UIBRKR   3813
C                                                                       UIBRKR   3814
C              Invalid subtype.                                         UIBRKR   3815
C                                                                       UIBRKR   3816
               UDVAL(JBLK) = 0.0                                        UIBRKR   3817
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3818
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3819
               WRITE(MSG(3),9104) BNAME(1:LEN)                          UIBRKR   3820
               WRITE(MSG(4),9105)                                       UIBRKR   3821
               WRITE(MSG(5),9902)                                       UIBRKR   3822
               CALL PRTMSG(5)                                           UIBRKR   3823
               IERCNT = IERCNT + 1                                      UIBRKR   3824
            END IF                                                      UIBRKR   3825
         END IF                                                         UIBRKR   3826
      END IF                                                            UIBRKR   3827
C                                                                       UIBRKR   3828
      RETURN                                                            UIBRKR   3829
C                                                                       UIBRKR   3830
C                                                                       UIBRKR   3831
C---------------------------------------------------------------------  UIBRKR   3832
C                                                                       UIBRKR   3833
      ENTRY UIUNA (JBLK)                                                UIBRKR   3834
CD -------------------------------------------------------------------  UIBRKR   3835
CD                                                                      UIBRKR   3836
CD              *****     UIUNA   ROUTINE   *****                       UIBRKR   3837
CD                                                                      UIBRKR   3838
CD -------------------------------------------------------------------  UIBRKR   3839
CD                                                                      UIBRKR   3840
CD       PURPOSE:  Performs the initialization of the udc type UNARY.   UIBRKR   3841
CD                                                                      UIBRKR   3842
CD -------------------------------------------------------------------  UIBRKR   3843
C                                                                       UIBRKR   3844
      IF(SDBG)THEN                                                      UIBRKR   3845
         SUBNAM = 'UIUNA ROUTINE.'                                      UIBRKR   3846
      ELSE                                                              UIBRKR   3847
         SUBNAM = ' '                                                   UIBRKR   3848
      END IF                                                            UIBRKR   3849
      TNAME = TPNAME(IUNARY)                                            UIBRKR   3850
      BNAME = UDNAME(JBLK)                                              UIBRKR   3851
      LEN = IUDLEN(JBLK)                                                UIBRKR   3852
C                                                                       UIBRKR   3853
C     Retrieve input value.                                             UIBRKR   3854
C                                                                       UIBRKR   3855
      NEXTI = IUNIPT(JBLK)                                              UIBRKR   3856
      NEXTP = IUDPPT(JBLK)                                              UIBRKR   3857
C                                                                       UIBRKR   3858
      IF(NEXTI.EQ.0 .OR. NEXTP.EQ.0)THEN                                UIBRKR   3859
C                                                                       UIBRKR   3860
C        No input value was stored.                                     UIBRKR   3861
C                                                                       UIBRKR   3862
         MISS = 'INPUT'                                                 UIBRKR   3863
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3864
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3865
               WRITE(MSG(3),9103) MISS                                  UIBRKR   3866
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   3867
               WRITE(MSG(5),9902)                                       UIBRKR   3868
               CALL PRTMSG(5)                                           UIBRKR   3869
         IERCNT = IERCNT + 1                                            UIBRKR   3870
C                                                                       UIBRKR   3871
      ELSE                                                              UIBRKR   3872
C                                                                       UIBRKR   3873
         IF(UIDENT(NEXTI) .NE. ' ')THEN                                 UIBRKR   3874
            VALUE = UDVAL(IUDINT(NEXTI))                                UIBRKR   3875
         ELSE                                                           UIBRKR   3876
            VALUE = UDPARM(NEXTP)                                       UIBRKR   3877
         END IF                                                         UIBRKR   3878
C                                                                       UIBRKR   3879
         IF(IUDSUB(JBLK).EQ.ISINS .OR. IUDSUB(JBLK).EQ.ICOSS .OR.       UIBRKR   3880
     1       IUDSUB(JBLK).EQ.ITANS)THEN                                 UIBRKR   3881
C                                                                       UIBRKR   3882
C           The value is given in degrees, convert it to radians.       UIBRKR   3883
C                                                                       UIBRKR   3884
            VALUE = VALUE * PII/180.0                                   UIBRKR   3885
C                                                                       UIBRKR   3886
         END IF                                                         UIBRKR   3887
C                                                                       UIBRKR   3888
C        Determine the UDC based on what subtype is stored.             UIBRKR   3889
C                                                                       UIBRKR   3890
C                                                                       UIBRKR   3891
C        SIN subtype.                                                   UIBRKR   3892
C                                                                       UIBRKR   3893
         IF(IUDSUB(JBLK).EQ.ISINS)THEN                                  UIBRKR   3894
            UDVAL(JBLK) = SIN(VALUE)                                    UIBRKR   3895
C                                                                       UIBRKR   3896
C                                                                       UIBRKR   3897
C        COS subtype.                                                   UIBRKR   3898
C                                                                       UIBRKR   3899
         ELSEIF(IUDSUB(JBLK).EQ.ICOSS)THEN                              UIBRKR   3900
            UDVAL(JBLK) = COS(VALUE)                                    UIBRKR   3901
C                                                                       UIBRKR   3902
C                                                                       UIBRKR   3903
C        TAN subtype.                                                   UIBRKR   3904
C                                                                       UIBRKR   3905
         ELSEIF(IUDSUB(JBLK).EQ.ITANS)THEN                              UIBRKR   3906
            UDVAL(JBLK) = TAN(VALUE)                                    UIBRKR   3907
C                                                                       UIBRKR   3908
C                                                                       UIBRKR   3909
C        ASIN subtype.                                                  UIBRKR   3910
C                                                                       UIBRKR   3911
         ELSEIF(IUDSUB(JBLK).EQ.IASINS)THEN                             UIBRKR   3912
            IF(ABS(VALUE).GT.1.0)THEN                                   UIBRKR   3913
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3914
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3915
               WRITE(MSG(3),9612) BNAME(1:LEN)                          UIBRKR   3916
               WRITE(MSG(4),9613) 'ASIN',VALUE                          UIBRKR   3917
               CALL PRTMSG(4)                                           UIBRKR   3918
               VALUE = SIGN(1.0,VALUE)                                  UIBRKR   3919
            ENDIF                                                       UIBRKR   3920
            UDVAL(JBLK) = ASIN(VALUE)                                   UIBRKR   3921
C                                                                       UIBRKR   3922
C                                                                       UIBRKR   3923
C        ACOS subtype.                                                  UIBRKR   3924
C                                                                       UIBRKR   3925
         ELSEIF(IUDSUB(JBLK).EQ.IACOSS)THEN                             UIBRKR   3926
            IF(ABS(VALUE).GT.1.0)THEN                                   UIBRKR   3927
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3928
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3929
               WRITE(MSG(3),9612) BNAME(1:LEN)                          UIBRKR   3930
               WRITE(MSG(4),9613) 'ACOS',VALUE                          UIBRKR   3931
               CALL PRTMSG(4)                                           UIBRKR   3932
               VALUE = SIGN(1.0,VALUE)                                  UIBRKR   3933
            ENDIF                                                       UIBRKR   3934
            UDVAL(JBLK) = ACOS(VALUE)                                   UIBRKR   3935
C                                                                       UIBRKR   3936
C                                                                       UIBRKR   3937
C        SINH subtype.                                                  UIBRKR   3938
C                                                                       UIBRKR   3939
         ELSEIF(IUDSUB(JBLK).EQ.ISINHS)THEN                             UIBRKR   3940
            UDVAL(JBLK) = SINH(VALUE)                                   UIBRKR   3941
C                                                                       UIBRKR   3942
C                                                                       UIBRKR   3943
C        COSH subtype.                                                  UIBRKR   3944
C                                                                       UIBRKR   3945
         ELSEIF(IUDSUB(JBLK).EQ.ICOSHS)THEN                             UIBRKR   3946
            UDVAL(JBLK) = COSH(VALUE)                                   UIBRKR   3947
C                                                                       UIBRKR   3948
C                                                                       UIBRKR   3949
C        TANH subtype.                                                  UIBRKR   3950
C                                                                       UIBRKR   3951
         ELSEIF(IUDSUB(JBLK).EQ.ITANHS)THEN                             UIBRKR   3952
            UDVAL(JBLK) = TANH(VALUE)                                   UIBRKR   3953
C                                                                       UIBRKR   3954
C                                                                       UIBRKR   3955
C        ABS subtype.                                                   UIBRKR   3956
C                                                                       UIBRKR   3957
         ELSEIF(IUDSUB(JBLK).EQ.IABSS)THEN                              UIBRKR   3958
            UDVAL(JBLK) = ABS(VALUE)                                    UIBRKR   3959
C                                                                       UIBRKR   3960
C                                                                       UIBRKR   3961
C        EXP subtype.                                                   UIBRKR   3962
C                                                                       UIBRKR   3963
         ELSEIF(IUDSUB(JBLK).EQ.IEXPS)THEN                              UIBRKR   3964
            UDVAL(JBLK) = EXP(VALUE)                                    UIBRKR   3965
C                                                                       UIBRKR   3966
C                                                                       UIBRKR   3967
C        LOG subtype.                                                   UIBRKR   3968
C                                                                       UIBRKR   3969
         ELSEIF(IUDSUB(JBLK).EQ.ILOGS)THEN                              UIBRKR   3970
            IF(VALUE.LE.0.0)THEN                                        UIBRKR   3971
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3972
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3973
               WRITE(MSG(3),9612) BNAME(1:LEN)                          UIBRKR   3974
               WRITE(MSG(4),9613) 'LOG',VALUE                           UIBRKR   3975
               CALL PRTMSG(4)                                           UIBRKR   3976
               VALUE = 1.0E-10                                          UIBRKR   3977
            ENDIF                                                       UIBRKR   3978
            UDVAL(JBLK) = LOG(VALUE)                                    UIBRKR   3979
C                                                                       UIBRKR   3980
C                                                                       UIBRKR   3981
C        INV subtype.                                                   UIBRKR   3982
C                                                                       UIBRKR   3983
         ELSEIF(IUDSUB(JBLK).EQ.INVS)THEN                               UIBRKR   3984
            IF(VALUE.EQ.0.0)THEN                                        UIBRKR   3985
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   3986
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   3987
               WRITE(MSG(3),9612) BNAME(1:LEN)                          UIBRKR   3988
               WRITE(MSG(4),9613) 'INV',VALUE                           UIBRKR   3989
               CALL PRTMSG(4)                                           UIBRKR   3990
               VALUE = 1.0E-10                                          UIBRKR   3991
            ENDIF                                                       UIBRKR   3992
            UDVAL(JBLK) = 1.0 / VALUE                                   UIBRKR   3993
C                                                                       UIBRKR   3994
C                                                                       UIBRKR   3995
C        IUDNOL subtype.                                                UIBRKR   3996
C                                                                       UIBRKR   3997
         ELSEIF(IUDSUB(JBLK).EQ.IUDNOL)THEN                             UIBRKR   3998
            NEXTP = IUDPPT(JBLK)                                        UIBRKR   3999
C                                                                       UIBRKR   4000
            IF(NEXTP.EQ.0)THEN                                          UIBRKR   4001
C                                                                       UIBRKR   4002
C              No curve is defined.                                     UIBRKR   4003
C                                                                       UIBRKR   4004
               UDVAL(JBLK) = 0.0                                        UIBRKR   4005
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   4006
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   4007
               WRITE(MSG(3),9604)                                       UIBRKR   4008
               WRITE(MSG(4),9901) BNAME(1:LEN)                          UIBRKR   4009
               WRITE(MSG(5),9902)                                       UIBRKR   4010
               CALL PRTMSG(5)                                           UIBRKR   4011
               IERCNT = IERCNT + 1                                      UIBRKR   4012
C                                                                       UIBRKR   4013
            ELSE                                                        UIBRKR   4014
               X1 = UDPARM(NEXTP)                                       UIBRKR   4015
               NEXTP = IUDPNX(NEXTP)                                    UIBRKR   4016
               Y1 = UDPARM(NEXTP)                                       UIBRKR   4017
               NEXTP = IUDPNX(NEXTP)                                    UIBRKR   4018
C                                                                       UIBRKR   4019
               IF(NEXTP.EQ.0)THEN                                       UIBRKR   4020
C                                                                       UIBRKR   4021
C                 Curve is defined as only one point.                   UIBRKR   4022
C                                                                       UIBRKR   4023
                  UDVAL(JBLK) = Y1                                      UIBRKR   4024
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   4025
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   4026
               WRITE(MSG(3),9606) BNAME(1:LEN)                          UIBRKR   4027
               WRITE(MSG(4),9607)                                       UIBRKR   4028
               CALL PRTMSG(4)                                           UIBRKR   4029
C                                                                       UIBRKR   4030
               ELSEIF(VALUE .LT. X1)THEN                                UIBRKR   4031
C                                                                       UIBRKR   4032
C                 Point is outside of the defined curve.                UIBRKR   4033
C                                                                       UIBRKR   4034
                  UDVAL(JBLK) = Y1                                      UIBRKR   4035
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   4036
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   4037
               WRITE(MSG(3),9608) BNAME(1:LEN)                          UIBRKR   4038
               WRITE(MSG(4),9609)                                       UIBRKR   4039
               WRITE(MSG(5),9610)                                       UIBRKR   4040
               CALL PRTMSG(5)                                           UIBRKR   4041
C                                                                       UIBRKR   4042
               ELSE                                                     UIBRKR   4043
C                                                                       UIBRKR   4044
C                 Find next defined point of the curve.                 UIBRKR   4045
C                                                                       UIBRKR   4046
                  X2 = UDPARM(NEXTP)                                    UIBRKR   4047
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   4048
                  Y2 = UDPARM(NEXTP)                                    UIBRKR   4049
                  NEXTP = IUDPNX(NEXTP)                                 UIBRKR   4050
C                                                                       UIBRKR   4051
                  END = .FALSE.                                         UIBRKR   4052
C                                                                       UIBRKR   4053
520               IF(END) GOTO 540                                      UIBRKR   4054
                     IF(VALUE .GE. X1.AND.VALUE .LE. X2)THEN            UIBRKR   4055
                        UDVAL(JBLK) = Y1 + (VALUE - X1) / (X2 - X1) *   UIBRKR   4056
     1                             (Y2 - Y1)                            UIBRKR   4057
                        END = .TRUE.                                    UIBRKR   4058
C                                                                       UIBRKR   4059
                     ELSEIF(NEXTP.EQ.0)THEN                             UIBRKR   4060
C                                                                       UIBRKR   4061
C                       Point is outside of the defined curve.          UIBRKR   4062
C                                                                       UIBRKR   4063
                        UDVAL(JBLK) = Y2                                UIBRKR   4064
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   4065
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   4066
               WRITE(MSG(3),9608) BNAME(1:LEN)                          UIBRKR   4067
               WRITE(MSG(4),9609)                                       UIBRKR   4068
               WRITE(MSG(5),9610)                                       UIBRKR   4069
               CALL PRTMSG(5)                                           UIBRKR   4070
                        END = .TRUE.                                    UIBRKR   4071
C                                                                       UIBRKR   4072
                     ELSE                                               UIBRKR   4073
C                                                                       UIBRKR   4074
C                       Find next defined point on the curve.           UIBRKR   4075
C                                                                       UIBRKR   4076
                        X1 = X2                                         UIBRKR   4077
                        Y1 = Y2                                         UIBRKR   4078
                        X2 = UDPARM(NEXTP)                              UIBRKR   4079
                        NEXTP = IUDPNX(NEXTP)                           UIBRKR   4080
                        Y2 = UDPARM(NEXTP)                              UIBRKR   4081
                        NEXTP = IUDPNX(NEXTP)                           UIBRKR   4082
                     END IF                                             UIBRKR   4083
                     GOTO 520                                           UIBRKR   4084
540               CONTINUE                                              UIBRKR   4085
C                                                                       UIBRKR   4086
              END IF                                                    UIBRKR   4087
            END IF                                                      UIBRKR   4088
C                                                                       UIBRKR   4089
C                                                                       UIBRKR   4090
C        Invalid subtype.                                               UIBRKR   4091
C                                                                       UIBRKR   4092
         ELSE                                                           UIBRKR   4093
               WRITE(MSG(1),9000) SUBNAM                                UIBRKR   4094
               WRITE(MSG(2),9102) TNAME                                 UIBRKR   4095
               WRITE(MSG(3),9104) BNAME(1:LEN)                          UIBRKR   4096
               WRITE(MSG(4),9105)                                       UIBRKR   4097
               WRITE(MSG(5),9902)                                       UIBRKR   4098
               CALL PRTMSG(5)                                           UIBRKR   4099
            IERCNT = IERCNT + 1                                         UIBRKR   4100
            UDVAL(JBLK) = 0.0                                           UIBRKR   4101
         END IF                                                         UIBRKR   4102
C                                                                       UIBRKR   4103
C                                                                       UIBRKR   4104
         IF(IUDSUB(JBLK).EQ.IASINS .OR. IUDSUB(JBLK).EQ.IACOSS)THEN     UIBRKR   4105
C                                                                       UIBRKR   4106
C           Convert the answer from radians to degrees.                 UIBRKR   4107
C                                                                       UIBRKR   4108
            UDVAL(JBLK) = UDVAL(JBLK) * 180.0/PII                       UIBRKR   4109
         END IF                                                         UIBRKR   4110
      END IF                                                            UIBRKR   4111
C                                                                       UIBRKR   4112
      RETURN                                                            UIBRKR   4113
C                                                                       UIBRKR   4114
9000  FORMAT(' *** MTDC ERROR', 5X, A)                                  UIBRKR   4115
9001  FORMAT(10X,'DURING THE INITIALIZATION OF UDC "',A                 UIBRKR   4116
     *,'" BLOCKS, BLOCK')                                               UIBRKR   4117
9002  FORMAT(10X,'"',A,'" CONTAINS SOME UNEXPECTED CHARACTER')          UIBRKR   4118
9003  FORMAT(10X,'INPUT "',A,'".')                                      UIBRKR   4119
9900  FORMAT(10X,'CHECK YOUR UDC INPUT FILE FOR ERRORS.')               UIBRKR   4120
9004  FORMAT(10X,'"',A,'" (SUBTYPE "',A,'") HAD ',I3)                   UIBRKR   4121
9005  FORMAT(10X,'INPUT PARAMETERS. THIS SUBTYPE REQUIRES ',I3          UIBRKR   4122
     *,' INPUT PARAMETERS.')                                            UIBRKR   4123
9006  FORMAT(10X,'"',A,'" HAS AN INVALID SUBTYPE OF "',A,'".')          UIBRKR   4124
9007  FORMAT(10X,'DATA FOR THIS BLOCK IS IGNORED.')                     UIBRKR   4125
9008  FORMAT(10X,'"',A,'" REFERENCES A NON-EXISTENT AC BUS.')           UIBRKR   4126
9010  FORMAT(10X,'"',A,'" REFERENCES BREAKER "',A,'" WHICH HAS')        UIBRKR   4127
9011  FORMAT(10X,'AN INVALID STATUS. CHECK THAT YOUR HISTORY FILE')     UIBRKR   4128
9012  FORMAT(10X,'IS THE CORRECT VERSION.')                             UIBRKR   4129
9102  FORMAT(10X,'DURING THE INITIALIZATION OF UDC "',A,'" BLOCKS,')    UIBRKR   4130
9103  FORMAT(10X,'THE VALUE OF "',A,'" CANNOT BE FOUND FOR BLOCK,')     UIBRKR   4131
9901  FORMAT(10X,'"',A,'".  THIS IS AN ERROR IN THE CODE,')             UIBRKR   4132
9902  FORMAT(10X,'THE UDC INFORMATION IS NOT BEING STORED CORRECTLY.')  UIBRKR   4133
9104  FORMAT(10X,'AN INVALID SUBTYPE WAS FOUND FOR BLOCK, "',A,'".')    UIBRKR   4134
9105  FORMAT(10X,'THIS IS AN ERROR IN THE CODE,')                       UIBRKR   4135
9106  FORMAT(10X,'"',A,'" HAS AN INVALID "UP RATE" OF "',F10.3,'"')     UIBRKR   4136
9107  FORMAT(10X,'THE VALUE MUST BE POSITIVE OR ZERO.')                 UIBRKR   4137
9108  FORMAT(10X,'"',A,'" HAS AN INVALID "DOWN RATE" OF "',F10.3,'"')   UIBRKR   4138
9109  FORMAT(10X,'THE VALUE MUST BE NEGATIVE OR ZERO.')                 UIBRKR   4139
9110  FORMAT(10X,'"',A                                                  UIBRKR   4140
     *,'" HAS INVALID "DOWN RATE" AND "UP RATE" VALUES.')               UIBRKR   4141
9111  FORMAT(10X,'BOTH VALUES CANNOT BE ZERO.')                         UIBRKR   4142
9204  FORMAT(10X                                                        UIBRKR   4143
     *,'THE LOGICAL EXPRESSIONS WERE NOT EVALUATED FOR BLOCK,')         UIBRKR   4144
9304  FORMAT(10X,'THE BLOCK, "',A                                       UIBRKR   4145
     *,'" DOES NOT HAVE A DELAY LIST DEFINED.')                         UIBRKR   4146
9308  FORMAT(10X                                                        UIBRKR   4147
     *,'THE MAXIMUM STORAGE FOR THE DELAY LINKED LIST HAS BEEN')        UIBRKR   4148
9309  FORMAT(10X                                                        UIBRKR   4149
     *,'EXCEEDED.  TO CHANGE THE SIZE OF THE LIST, CHANGE THE')         UIBRKR   4150
9310  FORMAT(10X,'VALUE OF PARAMETER, LEND, FOUND IN UDPARM.INS')       UIBRKR   4151
9402  FORMAT(10X,'AN INVALID SUBTYPE OF "',A,'" WAS FOUND FOR BLOCK,')  UIBRKR   4152
9403  FORMAT(10X,'THE "',A                                              UIBRKR   4153
     *,'" INFORMATION SHOULD BE STORED ON')                             UIBRKR   4154
9404  FORMAT(10X,'THE START LIST, NOT WITH THE UDC INFORMATION.')       UIBRKR   4155
9504  FORMAT(10X                                                        UIBRKR   4156
     *,'THE STACK INFORMATION HAS BEEN CORRUPTED.  THIS IS AN ERROR')   UIBRKR   4157
9505  FORMAT(10X,'IN THE CODE, IT IS IMPOSSIBLE TO EVALUATE A "',A,'"') UIBRKR   4158
9506  FORMAT(10X,'BLOCK THAT IS NOT ON THE TOP OF THE STACK.')          UIBRKR   4159
9604  FORMAT(10X,'THE USER DEFINED CURVE CANNOT BE FOUND FOR BLOCK')    UIBRKR   4160
9606  FORMAT(10X,'THE USER DEFINED CURVE FOR BLOCK "',A,'", HAS ONLY')  UIBRKR   4161
9607  FORMAT(10X,'ONE POINT.')                                          UIBRKR   4162
9608  FORMAT(10X,'THE BLOCK "',A,'", HAS A POINT THAT IS OUTSIDE OF')   UIBRKR   4163
9609  FORMAT(10X                                                        UIBRKR   4164
     *,'THE USER DEFINED CURVE.  THE OUTPUT VALUE IS SET TO THE')       UIBRKR   4165
9610  FORMAT(10X,'CLOSEST END POINT.')                                  UIBRKR   4166
9612  FORMAT(10X,'THE INPUT VALUE FOR "',A,'" IS NOT ACCEPTABLE,')      UIBRKR   4167
9613  FORMAT(10X,'FOR FUNCTION "',A,'" INPUT VALUE IS ', F12.3)         UIBRKR   4168
C                                                                       UIBRKR   4169
C---------------------------------------------------------------------  UIBRKR   4170
C                                                                       UIBRKR   4171
      END                                                               UIBRKR   4172
